;----------------------------------------------------
;    Disassembly of the file Dragon's Lair (Italian)
;    By Jeff Kulczycki, Nov 28, 2007
;    www.jeffsromhack.com
;----------------------------------------------------
;  Game Info
;----------------------------------------------------
;   GAME:   Dragon's Lair (Italian) 
;   CPU:    Z80 xMHz
;   SOUND:  Z80 xMHz,AY-8910-1.5MHz, DAC
;           40K EEPROM 
;   RES:    ?? 224 Horiz by 256 Vert, Freq 60Hz
;   COLORS: 256
;----------------------------------------------------
;    RAM VARIABLES
;----------------------------------------------------
;    Address      Description
;----------------------------------------------------
;   A000          Display Control Byte
;   A001          Number of Credits
;   A002          Number of Coins
;   A102-A104     RAM-base program routine code
;   A105            moves?
;   A106            ?
;   A107            ?
;   A108            ?
;   A109          joystick?
;   A10B-A10C     Scene Index 
;   A10D-A10E     Ending Frame Number
;   A10F-A110     Frame Number value
;   A111-A112     Scene frame length
;   A113-A114
;   A115-A12E     Move Data for Scene???
;   A12F-A136     Outgoing Serial Command buffer
;   A13C-A13D     Player1 Scene Index pointer
;   A13E-A13F     Player2 Scene Index pointer
;   A142-A144     Player1 Score
;   A148          Initial Number of Lives
;   A149          Number of Lives Remaining (Player1)
;   A14A          Number of Lives Remaining (Player2)
;   A14B          Number of Credits (inserted)
;   A14C          Number of Credits LEFT
;   A14D          Number of Credits RIGHT
;   A14E          Number of Coins LEFT
;   A150
;   A151
;   A152          Current player (0,1)
;   A153          Number of Players (0,1)
;   A154-A155     Current player's Scene Index pointer
;   A16A          DIP Switch A
;   A17F          Display characters
;   A182-A184     Player2 Score
;   A18A          High Score
;   A220-A225     Debounce buffer?
;----------------------------------------------------
;   ROM Info:  
;----------------------------------------------------
;   dlita45.bin  0x0000-0x1FFF (8K) CRC 4d3a9eac
;   dlita46.bin  0x2000-0x3FFF (8K) CRC 8479612b
;   dlita47.bin  0x4000-0x5FFF (8K) CRC 6a66f6b4
;   dlita48.bin  0x6000-0x7FFF (8K) CRC 36575106
;----------------------------------------------------
;   RAM Info: 
;----------------------------------------------------
;   A000-A7FF     System RAM 

;   C000-C7FF     RAM?
;   E000          WT LED 1
;   E008          WT LED 2
;   E010          led_den1_w  WT EXT LED 1
;   E018          led_den2_w  WT EXT LED 2
;   E020          laserdisc_w)     DISC WT
;   E028          dleuro_misc_w)        WT MISC
;   E030          watchdog_reset_w
;   E080          READ(input_port_0_r) // CP A
;   E088          READ(input_port_1_r) // CP B
;   E090          READ(input_port_2_r) // OPT SW A
;   E098          READ(input_port_3_r) // OPT SW B
;   E0A0          READ(laserdisc_r) // RD DISC DATA

;   E028          Hardware control (A000 mirror)
;        .0         stop
;        .1         off
;        .2         on
;   E030          Watchdog
;  INPUTS
;   00h           Unknown
;   01h           Unknown
;   02h           Unknown
;   03h           Unknown
;   04h           Unknown
;   80h           LDPlayer Serial byte
;
;
;
;----------------------------------------------------
;                     RESET
;----------------------------------------------------
L0000:  DI                      ; Disable interrupts
        JP      L08B7           ; Start Diagnostic tests


;----------------------------------------------------
;                    unknown
;----------------------------------------------------
L0004:  RET     


;----------------------------------------------------
;                    unknown
;----------------------------------------------------
L0005:  .BYTE $FF

;----------------------------------------------------
;                Vector Table for IM 2
;----------------------------------------------------
L0006:   .WORD $FFFF            ; 
L0008:   .WORD $FFFF            ; 
L000A:   .WORD $FFFF            ; 
L000C:   .WORD $FFFF            ; 
L000E:   .WORD $FFFF            ; 
L0010:   .WORD L0030            ; $10 Interrupt Trap
         .WORD L0846            ; $12
         .WORD L0030            ; $14 Interrupt Trap
         .WORD L0C3B            ; $16
         .WORD $FFFF            ; 
         .WORD $FFFF            ; 
         .WORD $FFFF            ; 
         .WORD $FFFF            ; 
L0020:   .WORD L0030            ; $20 Interrupt Trap
         .WORD L0030            ; $22 Interrupt Trap
         .WORD L0030            ; $24 Interrupt Trap
         .WORD L0030            ; $26 Interrupt Trap
         .WORD L0F41            ; $28 Tranmit Interrupt (Tx)
         .WORD L0030            ; $2A Interrupt Trap
         .WORD L0EEF            ; $2C Receive interrupt (Rx)
         .WORD L0F62            ; $2E Return from interrupt


;----------------------------------------------------
;                Interrupt Trap 
;----------------------------------------------------         
L0030:   DI      
L0031:   HALT    
         JR      L0031         



;----------------------------------------------------
;                Begin Main Program
;----------------------------------------------------
;          Setup Interrupt Mode 2 first
;----------------------------------------------------
L0034:  LD      (0E030h),A      ; Reset watchdog 
        IM      2               ; Set interrupt Mode 2
L0038:  SUB     A               ; A = 0
L003B:  LD      I,A             ; Vector address MSB =$00xx
;----------------------------------------------------
;              Clear RAM $A000-$A7FF
;----------------------------------------------------
L003C:  LD      BC,007FEh       ; Number of bytes to erase
        LD      HL,0A000h       ; Start of area to clear
        LD      DE,0A001h       ; Setup copy routine
        LD      (HL),000h       ; Erase byte
        LDIR                    ; Loop until all bytes erased       
;----------------------------------------------------
;              Clear
;----------------------------------------------------        
        LD      (0E030h),A      ; Reset watchdog
        LD      A,006h          ;
        LD      (0A000h),A      ;
;----------------------------------------------------
;           Clear Video RAM $C000-$C7FE
;----------------------------------------------------
        LD      BC,007FEh       ;
        LD      HL,0C000h       ;
        LD      DE,0C001h       ;
        LD      (HL),000h       ;
        LDIR                    ;        
        LD      (0E030h),A      ; Reset watchdog
;----------------------------------------------------
;                
;----------------------------------------------------
        LD      SP,0A7FFh       ; Setup Stack pointer
        CALL    L1BB7           ;
        LD      (0E030h),A      ; Reset watchdog
        CALL    L0612           ; SEARCH to Start of Attract Mode
        LD      (0E030h),A      ; Reset watchdog
        CALL    L1AEF           ;
        LD      (0E030h),A      ; Reset watchdog
;----------------------------------------------------
;                      Delay
;----------------------------------------------------        
        LD      HL,0007Fh       ; HL = Delay time
L0079:  LD      B,0FFh          ; B = Delay time
L007B:  LD      (0E030h),A      ; Reset watchdog
        DJNZ    L007B           ; Loop until inner delay done
        DEC     HL              ; Decrement outer delay
        LD      A,H             ; Check if timer 0
        OR      L               ; Is timer 0?
        JR      NZ,L0079        ; No, so keep looping
;----------------------------------------------------
;          Wait for Diagnostic Switch
;----------------------------------------------------        
        EI                      ; Enable interrups
L0086:  LD      A,(0E080h)      ; Wait for Diagnostic Switch
        BIT     7,A             ; Is Switch still held?
        JP      Z,L1D40         ; No, so continue with Game
        JR      L0086           ; Otherwise wait



;----------------------------------------------------
;       HEX Conversion Table for frame number  
;----------------------------------------------------
L0090:  .BYTE $00,$00,$00,$00,$01   ; offset 1
        .BYTE $00,$00,$00,$00,$02   ; offset 2
        .BYTE $00,$00,$00,$00,$04   ; offset 4
        .BYTE $00,$00,$00,$00,$08   ; offset 8
        .BYTE $00,$00,$00,$01,$06   ; offset 16
        .BYTE $00,$00,$00,$03,$02   ; offset 32
        .BYTE $00,$00,$00,$06,$04   ; offset 64
        .BYTE $00,$00,$01,$02,$08   ; offset 128
        .BYTE $00,$00,$02,$05,$06   ; offset 256
        .BYTE $00,$00,$05,$01,$02   ; offset 512
        .BYTE $00,$01,$00,$02,$04   ; offset 1024
        .BYTE $00,$02,$00,$04,$08   ; offset 2048
        .BYTE $00,$04,$00,$09,$06   ; offset 4096
        .BYTE $00,$08,$01,$09,$02   ; offset 8192
        .BYTE $01,$06,$03,$08,$04   ; offset 16384
        .BYTE $03,$02,$07,$06,$08   ; offset 32768



;----------------------------------------------------
;   Create Frame number (ASCII) in Serial Buffer
;----------------------------------------------------
; Routine adds 16-bit value in $A10F-$A110 to buffer
; value that is already there (usually it's zero)
;----------------------------------------------------
;   $A12F-$A13xx Serial Command Buffer (Frame number starts at $A130)
;   $A10F-$A110 Serial Commmand Buffer (frame number in hex)
;----------------------------------------------------
L00E0:  PUSH    AF              ; Save registers first
        PUSH    BC              ; Save registers first
        PUSH    DE              ; Save registers first
        PUSH    IX              ; Save registers first
        PUSH    IY              ; Save registers first
;----------------------------------------------------
;           Setup to convert HEX to Decimal
;----------------------------------------------------        
        LD      DE,(0A10Fh)     ; DE = 16-bit Frame number (in HEX)
        LD      IX,L0090        ; 16-bit Hex conversion table 
        LD      IY,0A130h       ; Frame number of command buffer starts here ($A12F+1)
        LD      B,010h          ; 16-bit addition
;----------------------------------------------------
;    Convert value in DE register to decimal
;----------------------------------------------------        
L00F5:  AND     A               ; Clear carry
        RR      D               ; Check one bit in DE
        RR      E               ; Check one bit in DE
        JR      NC,L0152        ; Binary bit cleared so check next bit
;----------------------------------------------------
;       Add bit's value 1,2,4,8,16,32,...etc.     
;----------------------------------------------------        
        AND     A               ; Clear carry
        LD      A,(IY+004h)     ; Get Command buffer value 
L0100:  ADC     A,(IX+004h)     ; Add decimal value of bit
        DAA                     ; Create decimal value
        BIT     4,A             ; Does value have 10's place
        JR      Z,L0109         ; No, so skip ahead
        SCF                     ; Set carry flag for next addtion
L0109:  RES     4,A             ; Clear 10's place
        LD      (IY+004h),A     ; Save first decimal value in buffer
        LD      A,(IY+003h)     ; Get Command buffer value 
        ADC     A,(IX+003h)     ; Add decimal value of bit
        DAA                     ; Create decimal value
        BIT     4,A             ; Does value have 10's place
        JR      Z,L011A         ; No, so skip ahead
        SCF                     ; Set carry flag for next addtion
L011A:  RES     4,A             ; Clear 10's place
        LD      (IY+003h),A     ; Save first decimal value in buffer
        LD      A,(IY+002h)     ; Get Command buffer value 
        ADC     A,(IX+002h)     ; Add decimal value of bit
        DAA                     ; Create decimal value
        BIT     4,A             ; Does value have 10's place
        JR      Z,L012B         ; No, so skip ahead
        SCF                     ; Set carry flag for next addtion
L012B:  RES     4,A             ; Clear 10's place
        LD      (IY+002h),A     ; Save first decimal value in buffer
        LD      A,(IY+001h)     ; Get Command buffer value 
        ADC     A,(IX+001h)     ; Add decimal value of bit
        DAA                     ; Create decimal value
        BIT     4,A             ; Does value have 10's place
        JR      Z,L013C         ; No, so skip ahead
        SCF                     ; Set carry flag for next addtion
L013C:  RES     4,A             ; Clear 10's place
        LD      (IY+001h),A     ; Save first decimal value in buffer
        LD      A,(IY+000h)     ; Get Command buffer value 
        ADC     A,(IX+000h)     ; Add decimal value of bit
        DAA                     ; Create decimal value
        BIT     4,A             ; Does value have 10's place
        JR      Z,L014D         ; No, so skip ahead
        SCF                     ; Set carry flag for next addtion
L014D:  RES     4,A             ; Clear 10's place
        LD      (IY+000h),A     ; Save first decimal value in buffer
;----------------------------------------------------
;         Go to next Conversion table value
;----------------------------------------------------        
L0152:  INC     IX              ; Go to next HEX conversion index
        INC     IX              ; Go to next HEX conversion index
        INC     IX              ; Go to next HEX conversion index
        INC     IX              ; Go to next HEX conversion index
        INC     IX              ; Go to next HEX conversion index
        DJNZ    L00F5           ; Loop until addition complete
;----------------------------------------------------
; Convert Frame number to ASCII for outgoing Command
;----------------------------------------------------        
        LD      B,005h          ; 5 Frame numbers to update
L0160:  LD      A,030h          ; ASCII Offset ($030-$039)
        OR      (IY+000h)       ; Add offset to frame number
        LD      (IY+000h),A     ; Save ASCII code for number
        INC     IY              ; Go to next number
        DJNZ    L0160           ; Loop until all bytes updated
;----------------------------------------------------
;              Restore registes and return
;----------------------------------------------------        
        POP     IY              ; Restore registers
        POP     IX              ; Restore registers
        POP     DE              ; Restore registers
        POP     BC              ; Restore registers
        POP     AF              ; Restore registers
        RET                     ; Return




;----------------------------------------------------
;                    unknown
;----------------------------------------------------
        DJNZ    L0177
        DEC     D
L0177:  LD      BC,00113h
        EX      AF,AF'
        LD      BC,0010Fh
        LD      C,001h
        DEC     B
        LD      BC,L0000
        DJNZ    L0187
        INC     C
L0187:  LD      BC,00101h
        ADD     HL,DE
        LD      BC,00105h
        LD      (DE),A
        LD      BC,00114h
        RLA     
        LD      BC,0010Fh
        NOP     
        NOP     
        DJNZ    L019B
        INC     C
L019B:  LD      BC,00101h
        ADD     HL,DE
        LD      BC,00105h
        LD      (DE),A
        LD      BC,00102h
        DEC     D
        LD      BC,00114h
        INC     D
        LD      BC,0010Fh
        LD      C,001h
        ADD     HL,BC
        LD      BC,0010Eh
        INC     DE
        LD      BC,00105h
        LD      (DE),A
        LD      BC,00114h
        NOP     
        NOP     
        INC     BC
        LD      BC,0010Fh
        ADD     HL,BC
        LD      BC,0010Eh
        INC     DE
        LD      BC,00106h
        LD      (DE),A
        LD      BC,00105h
        DEC     B
        LD      BC,L0000
        DJNZ    L01D5
        INC     C
L01D5:  LD      BC,00101h
        ADD     HL,DE
        LD      BC,0010Fh
        LD      (DE),A
L01DE:  LD      BC,04B3Ah
        AND     C
        CP      000h
        JR      NZ,L01EF
        LD      DE,0C109h
        CALL    L025B
        CALL    L185C
        RET     
;----------------------------------------------------
;                  
;----------------------------------------------------
L01EF:  CALL    L0244
        LD      A,(0A14Bh)      ; Get Number of Credits
        CP      001h            ; Is there 1 credit?
        JR      NZ,L020F        ; No, so skip ahead
        LD      DE,0C10Fh
        CALL    L0264
        LD      DE,0C153h
        CALL    L026D
        LD      DE,0C189h
        CALL    L025B
        CALL    L185C
        RET     

L020F:  LD      DE,0C113h
        CALL    L026D
        CALL    L0276
        LD      DE,0C18Fh
        CALL    L0264
        LD      A,(0A14Eh)      ; Number of Coins LEFT
        CP      000h            ;
        JR      NZ,L0229        ;
        CALL    L0238           ;
        RET                     ; Return
L0229:  LD      A,(0A14Fh)      ; Get Number of Coins RIGHT setting
        CP      000h
        JR      NZ,L0234
        CALL    L0238
        RET     

L0234:  CALL    L185C
        RET     

L0238:  LD      HL,001C8h
        LD      DE,0C20Dh
        LD      BC,00012h
        LDIR    
        RET     

L0244:  LD      HL,00174h
        LD      DE,0C091h
        LD      BC,00008h
        LDIR    
        LD      HL,0017Ch
        LD      DE,0C0CBh
        LD      BC,00014h
        LDIR    
        RET     

L025B:  LD      HL,001B0h
        LD      BC,00018h
        LDIR    
        RET     

L0264:  LD      HL,001A4h
        LD      BC,0000Ch
        LDIR    
        RET     

L026D:  LD      HL,001DAh
        LD      BC,L0004
        LDIR    
        RET     

L0276:  LD      DE,0C14Bh
        LD      HL,00190h
        LD      BC,00014h
        LDIR    
        RET     


;----------------------------------------------------
;                    
;----------------------------------------------------
L0282:  LD      HL,0A16Eh
        LD      B,008h
        LD      A,(HL)
        AND     A
        JR      NZ,L0292
L028B:  SLA     B
        INC     HL
        LD      A,(HL)
        AND     A
        JR      Z,L02AB         ; Yes, so debounced sucessful
L0292:  INC     (HL)
        LD      A,014h
        CP      (HL)
        JR      NZ,L02A7
        LD      (HL),000h
        LD      A,(0A000h)
        LD      C,A
        LD      A,B
        CPL     
        AND     C
        LD      (0A000h),A
        LD      (0E028h),A
L02A7:  BIT     4,B
        JR      Z,L028B
;----------------------------------------------------
;           Handle debounce buffer $A220-$A225     
;----------------------------------------------------
L02AB:  LD      HL,0A220h       ; HL = Start of debounce buffer
        LD      B,005h          ; 5 bytes in buffer
        LD      A,(0E088h)      ; Get Joystick input
        SRA     A               ; Get bits 2,3
        SRA     A               ; Get bits 2,3
        CPL                     ; Toggle all bits
        AND     003h            ; Isolate bits 2,3
;----------------------------------------------------
;           Shift bytes in buffer (newest $A220)
;----------------------------------------------------        
L02BA:  LD      C,A             ; C = new byte
        LD      A,(HL)          ; Get old byte from buffer
        LD      (HL),C          ; Swap in new byte
        INC     HL              ; Go to next buffer location
        DJNZ    L02BA           ; Loop until all bytes shifted
;----------------------------------------------------
;              
;----------------------------------------------------        
        LD      HL,0E098h       ; HL = DIP Switch B
        BIT     7,(HL)          ; Check B7
        JR      NZ,L02D6        ;
        LD      HL,00320h
L02CA:  LD      (0A230h),HL
        LD      HL,0A16Dh
        BIT     0,(HL)
        CALL    Z,L1ADA
        RET     

L02D6:  LD      HL,(0A230h)
        LD      A,H
        OR      L
        JR      Z,L02E1
        DEC     HL
        JR      L02CA
        RET                     ; Return
;----------------------------------------------------
;             Debounce both Coin Slots      
;----------------------------------------------------
L02E1:  LD      IX,0A220h       ; IX = Coin slot Debounce Buffer ($A220-$A225)
        LD      B,002h          ; 2 Slots to check for debounce buffers
L02E7:  CALL    L0350           ; Check Coin slot for debounce activation
        CALL    NZ,L02F2        ; Coin registered, so ...
        SRL     B               ; Check next slot B = 1
        JR      NC,L02E7        ; Loop back and check next Coin slot
        RET                     ; Return
        
        
        
;----------------------------------------------------
;       Number of Credits for Each Coin Slot   
;----------------------------------------------------
L02F2:  PUSH    IX              ;
        LD      C,008h          ;
        LD      DE,0A16Eh       ;
        LD      HL,0A150h       ;
        LD      IX,0A14Ch       ; IX = Number of Credits (LEFT/RIGHT)
        BIT     1,B             ; Which Coin slot Left or Right?
        JR      Z,L030A         ; Left so skip ahead
        LD      C,010h          ;
        INC     DE              ;
        INC     HL              ;
        INC     IX              ;
;----------------------------------------------------
;              
;----------------------------------------------------        
L030A:  LD      A,(0A000h)      ;
        OR      C               ;
        LD      (0A000h),A      ;
        LD      (0E028h),A      ; Coin counter?
        LD      A,001h          ;
        LD      (DE),A          ;
        INC     (HL)            ;
        LD      A,(HL)          ;
        CP      (IX+002h)       ;
        JR      NZ,L034B        ;
        LD      (HL),000h       ;
        LD      A,(0A14Bh)      ; Get Number of Credits
        ADD     A,(IX+000h)     ;
        DAA     
        CP      051h
        JR      NC,L032E
        LD      (0A14Bh),A      ; Update Number of Credits
L032E:  CALL    L1ADA
        LD      HL,0A001h
        CALL    L0384
        JR      Z,L0348
        DEC     HL
        BIT     0,(HL)
        JR      NZ,L0348
        LD      A,001h
        LD      (0A10Bh),A
        LD      A,005h
        LD      (0A112h),A
L0348:  POP     IX
        RET     

L034B:  CALL    L1AC5
        JR      L0348
        
        
        
;----------------------------------------------------
;              Check Buffer for Debounce
;----------------------------------------------------        
;     IX = Debounce Buffer 
;----------------------------------------------------
L0350:  LD      HL,0A226h       ; Coin Slot 1 
        BIT     1,B             ; Are we testing slot 1?
        JR      Z,L0358         ; Yes so skip ahead
        INC     HL              ; HL = Coin Slot 2 ($A227)
L0358:  LD      A,(IX+004h)     ; Compare buffer position
        AND     (IX+003h)       ; Compare buffer position
        AND     (IX+002h)       ; Compare buffer position
        AND     (IX+001h)       ; Compare buffer position
        AND     B               ; Compare B = 0 or B = 1 (slot number)
        LD      C,A             ; C = Results
        AND     (IX+000h)       ; Compare buffer position
        JR      Z,L037B         ; Buffer not debounced
        INC     (HL)            ; Increment Coin input
        LD      A,014h          ; Check for 20 Coins
        CP      (HL)            ; Are there more than 20 coins?
        JR      NC,L0379        ; No, so return
        LD      (HL),015h       ; Set limit of 21 coins
        LD      HL,00320h       ; HL = Timeout to wait for another coin (800ms) 
        LD      (0A230h),HL     ; Reset timeout
L0379:  XOR     A               ; Clear carry
        RET                     ; Return

L037B:  LD      (HL),A
        LD      A,(IX+000h)
        XOR     (IX+004h)
        AND     C
        RET     

L0384:  BIT     0,(HL)
        RET     Z
        BIT     2,(HL)
        RET     

        NOP     
        XOR     (IX+004h)
        AND     C
        RET     



;----------------------------------------------------
;               Check for Coin
;----------------------------------------------------
L0390:  BIT     2,(HL)              ;
        JR      Z,L039C             ;
        LD      (0A10Bh),A          ;
        LD      A,005h              ;
        LD      (0A112h),A          ;
;----------------------------------------------------
;                 Add 1 Coin
;----------------------------------------------------
L039C:  LD      HL,0A151h           ; Get Number of Coins inserted
        INC     (HL)                ; Add 1 Coins
        LD      A,(0A14Fh)          ; Get Number of Coins RIGHT setting
        CP      (HL)                ; Are there enough coins?
        JR      NZ,L03B4            ; No, so skip ahead
;----------------------------------------------------
;                Award Credit
;----------------------------------------------------
        LD      (HL),000h           ; Clear Coins to award credit
        LD      A,(0A14Dh)          ; Get Number of Credits to award
        LD      B,A                 ; B = Number of credits to award
        LD      A,(0A14Bh)          ; Get current number of Credits
        ADD     A,B                 ; Add credits to current total
        DAA                         ; Create decimal number
        LD      (0A14Bh),A          ; Update Number of Credits
;----------------------------------------------------
;                
;----------------------------------------------------
L03B4:  LD      A,001h              ;
        LD      (0A16Fh),A          ;
        LD      A,(0A000h)          ;
        SET     4,A                 ;
        LD      (0A000h),A          ;
        LD      (0E028h),A          ;
        LD      A,(0A151h)          ; Get Number of Coins inserted
        CP      000h                ; Are there no more coins?
        CALL    Z,L1ADA             ; Yes, so ...
        CALL    NZ,L1AC5            ; No, so...
        RET                         ; Return




;----------------------------------------------------
;                Do Register Check
;----------------------------------------------------
L03D0:  LD      A,0AAh          ; Load test byte into register
        LD      B,A             ; Put test byte in B register
        LD      C,A             ; Put test byte in C register
        LD      D,A             ; Put test byte in D register
        LD      E,A             ; Put test byte in E register
        LD      H,A             ; Put test byte in H register
        LD      L,A             ; Put test byte in L register
        CP      B               ; Did register load correctly?
        JR      NZ,L03ED        ; No, so skip to error
        CP      C               ; Did register load correctly?
        JR      NZ,L03ED        ; No, so skip to error
        CP      D               ; Did register load correctly?
        JR      NZ,L03ED        ; No, so skip to error
        CP      E               ; Did register load correctly?
        JR      NZ,L03ED        ; No, so skip to error
        CP      H               ; Did register load correctly?
        JR      NZ,L03ED        ; No, so skip to error
        CP      L               ; Did register load correctly?
        JR      NZ,L03ED        ; No, so skip to error
        JP      L08C5           ; Passed, do next test
;----------------------------------------------------
;           Register Error, Test Failed
;----------------------------------------------------
L03ED:  LD      A,0F9h          ; Error Code = $F9
        LD      (0E000h),A      ; Print error code to display
L03F2:  LD      (0E030h),A      ; Reset watchdog
        JR      L03F2           ; Just loop here forever



;----------------------------------------------------
;               Perform LDPlayer Test
;----------------------------------------------------
L03F7:  LD      A,02Fh          ; Put in loopback mode?
        OUT     (000h),A        ; Send byte to LDPlayer
        OUT     (001h),A        ; Send byte to LDPlayer
        OUT     (002h),A        ; Send byte to LDPlayer
        OUT     (003h),A        ; Send byte to LDPlayer
;----------------------------------------------------
;         Send Test sequence  ($00,$FF,$55,$AA)
;----------------------------------------------------        
        LD      A,000h          ; Test byte
        OUT     (000h),A        ; Send byte to LDPlayer
        LD      A,0FFh          ; Test byte
        OUT     (001h),A        ; Send byte to LDPlayer
        LD      A,055h          ; Test byte
        OUT     (002h),A        ; Send byte to LDPlayer
        LD      A,0AAh          ; Test byte
        OUT     (003h),A        ; Send byte to LDPlayer
;----------------------------------------------------
;     Read Test Sequence back  ($00,$FF,$55,$AA)
;----------------------------------------------------        
        LD      C,000h          ; C = 0
        IN      A,(000h)        ; Get byte from LDPlayer
        CP      000h            ; Does it match test byte?
        JR      NZ,L042D        ; No, so print error
        INC     C               ; C = 1
        IN      A,(001h)        ; Get byte from LDPlayer
        CP      0FFh            ; Does it match test byte?
        JR      NZ,L042D        ; No, so print error
        INC     C               ; C = 2
        IN      A,(002h)        ; Get byte from LDPlayer
        CP      055h            ; Does it match test byte? 
        JR      NZ,L042D        ; No, so print error
        INC     C               ; C = 3
        IN      A,(003h)        ; Get byte from LDPlayer
        CP      0AAh            ; Does it match test byte?
        RET     Z               ; Yes, so return
;----------------------------------------------------
;             LDPlayer Failed, print error
;----------------------------------------------------
L042D:  LD      A,092h          ; Error Code = $92
        LD      (0E000h),A      ; Print error code to display
L0432:  LD      (0E030h),A      ; Reset watchdog
        JR      L0432           ; Just loop here forever


;----------------------------------------------------
;                    unknown
;----------------------------------------------------
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00110h
        INC     C
        LD      BC,00101h
        ADD     HL,DE
        LD      BC,00105h
        LD      (DE),A
        NOP     
        NOP     
        LD      BC,00026h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00110h
        INC     C
        LD      BC,00101h
        ADD     HL,DE
        LD      BC,00105h
        LD      (DE),A
        NOP     
        NOP     
        LD      BC,00027h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        DEC     DE
        INC     E
        DEC     E
        LD      E,01Fh
        JR      NZ,L049F
        LD      (02423h),HL
        DEC     H
        LD      H,027h
        JR      Z,L04AF
        LD      HL,(02C2Bh)
        DEC     L
        LD      L,000h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,0010Ch
        DEC     B
        LD      BC,00106h
        INC     D
        NOP     
        NOP     
        LD      BC,00113h
        INC     C
L049F:  LD      BC,0010Fh
        INC     D
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
L04AF:  LD      BC,00112h
        ADD     HL,BC
        LD      BC,00107h
        EX      AF,AF'
        LD      BC,00014h
        NOP     
        LD      BC,00113h
        INC     C
        LD      BC,0010Fh
        INC     D
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        RRCA    
        LD      BC,L0109
        LD      C,001h
        INC     DE
        NOP     
        NOP     
        LD      BC,00048h
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        LD      BC,00013h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        LD      BC,00013h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00108h
        ADD     HL,BC
        LD      BC,00107h
        EX      AF,AF'
        NOP     
        NOP     
        LD      BC,00113h
        INC     BC
        LD      BC,0010Fh
        LD      (DE),A
        LD      BC,00005h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,0010Ch
        LD      BC,01301h
        LD      BC,00014h
        NOP     
        LD      BC,00113h
        INC     BC
        LD      BC,0010Fh
        LD      (DE),A
        LD      BC,00005h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        RRCA    
        LD      BC,L0109
        LD      C,000h
        NOP     
        LD      BC,00048h
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        LD      BC,00013h
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        RRCA    
        LD      BC,L0109
        LD      C,001h
        INC     DE
        NOP     
        NOP     
        LD      BC,00048h
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        RRCA    
        LD      BC,L0109
        LD      C,000h
        NOP     
        LD      BC,00048h
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00150h
        LD      D,D
        LD      BC,00154h
        LD      D,(HL)
        LD      BC,00158h
        LD      E,D
        LD      BC,00162h
        LD      E,H
        NOP     
        NOP     
        LD      BC,0015Eh
        LD      D,H
        LD      BC,L0160
        LD      D,D
        NOP     
        NOP     
        NOP     
        NOP    
        
;----------------------------------------------------
;                Message #1
;               
;----------------------------------------------------         
L05AB:  .BYTE $00,$00,$01,$50,$01,$52,$01,$54
        .BYTE $01,$56,$01,$58,$01,$5A,$01,$62
        .BYTE $01,$5C,$00,$00,$01,$5E,$01,$54
        .BYTE $01,$60,$01,$52,$00,$00,$00,$00
;----------------------------------------------------
;               
;                Message #2
;----------------------------------------------------
L05CB:  .BYTE $00,$00,$01,$51,$01,$53,$01,$55
        .BYTE $01,$57,$01,$59,$01,$5B,$00,$00
        .BYTE $01,$5D,$00,$00,$01,$5F,$01,$55
        .BYTE $01,$61,$01,$53,$00,$00,$00,$00
;----------------------------------------------------
;               
;----------------------------------------------------                  
L05EB:  .BYTE $00,$00,$01,$10,$01,$0C,$01,$05
        .BYTE $01,$01,$01,$13,$01,$05,$00,$00
        .BYTE $01,$13,$01,$14,$01,$01,$01,$0E
        .BYTE $01,$04,$01,$02,$01,$19,$00,$00


;----------------------------------------------------
;                LDPlayer Commands
;----------------------------------------------------
L060B:  .BYTE $58,$0D                ; Command = 'X' <RET>     unknown
L060D:  .BYTE $53,$30,$30,$32,$0D    ; Command = 'S002' <RET>  2 X PLAY


;----------------------------------------------------
;
;----------------------------------------------------
L0612:  LD      (0E030h),A      ; Reset watchdog
        LD      IX,L05AB        ; Message to print????
        LD      HL,0C085h       ; HL = Screen location
        CALL    L163C           ; Print number to screen
;----------------------------------------------------
;
;----------------------------------------------------        
        LD      (0E030h),A      ; Reset watchdog
        LD      IX,L05CB        ; Message to print????
        LD      HL,0C0C5h       ; HL = Screen location
        CALL    L163C           ; Print number to screen
;----------------------------------------------------
;                
;----------------------------------------------------        
        LD      (0E030h),A      ;
        LD      HL,0C153h       ;
        LD      D,002h          ;
        LD      A,04Fh          ;
        LD      (HL),A          ;
        INC     HL              ;
        LD      (HL),D          ;
;----------------------------------------------------
;                  Print Message #3                
;----------------------------------------------------        
        LD      IX,L05EB        ;
        LD      HL,0C1C5h       ;
L0640:  CALL    L163C           ; Print number to screen
;----------------------------------------------------
;                
;----------------------------------------------------
        LD      (0E030h),A      ;
        CALL    L0A01           ;
        LD      A,001h          ;
        OUT     (001h),A        ;
        LD      A,001h          ;
        OUT     (003h),A        ;
        LD      (0E030h),A      ;
        EI                      ; Enable Interrupts
;----------------------------------------------------
;           Send STOP Command to LDPlayer
;----------------------------------------------------         
L0655:  LD      HL,0A001h       ; HL = LDPlayer control byte
        SET     2,(HL)          ; Indicate that new LDPlayer COMMAND ready
        LD      BC,00002h       ; 2 bytes in command
        LD      DE,0A12Fh       ; DE = Serial Command buffer
        LD      HL,L060B        ; HL = Command "X" <RET>
        LD      (0A138h),DE     ; Save outgoing buffer pointer
        LDIR                    ; Copy command to outgoing buffer
        LD      (0E030h),A      ; Reset watchdog
        CALL    L0ED5           ;
        LD      (0E030h),A      ; Reset watchdog
;----------------------------------------------------
;   SEARCH to beginning of Attract Mode (Frame 166)
;----------------------------------------------------        
        LD      HL,0A001h       ; HL = LDPlayer control byte
        SET     2,(HL)          ; Indicate that new LDPlayer COMMAND ready
        LD      A,0A6h          ; Set Frame Number = 166
        LD      (0A10Fh),A      ; Save Frame Number in holding area
        CALL    L0EB7           ; SEARCH to Frame Number in $A10F
        LD      (0E030h),A      ; Reset watchdog
;----------------------------------------------------
;               Wait for Response (Delay)
;----------------------------------------------------        
        LD      HL,00FFFh       ; HL = Long delay counter
L0685:  LD      B,0FFh          ; B = delay counter
L0687:  LD      (0E030h),A      ; Reset watchdog during delay
        DJNZ    L0687           ; Loop on small delay
        DEC     HL              ; Decrement counter
        LD      A,H             ; Check if delay over
        OR      L               ; Is delay over?
        JR      NZ,L0685        ; No, so keep looping here
;----------------------------------------------------
;                 Check for Response
;----------------------------------------------------        
        LD      HL,0A001h       ;
        BIT     2,(HL)          ;
        JR      Z,L0655         ; No, so loop back
;----------------------------------------------------
;                 
;----------------------------------------------------        
        CALL    L0A11           ;
        LD      (0E030h),A      ;
        DI                      ;
        LD      A,0B7h          ;
        AND     0F9h            ;
        OUT     (001h),A        ;
        LD      A,0B7h          ;
        AND     0F9h            ;
        OUT     (003h),A        ;
;----------------------------------------------------
;                 
;----------------------------------------------------        
        LD      BC,00005h       ;
        LD      DE,0A12Fh       ; DE = Serial Command buffer
        LD      HL,L060D        ; Command 2 X PLAY
        LD      (0A138h),DE     ;
        LDIR                    ;
        LD      (0E030h),A      ;
        CALL    L0ED5           ;
        LD      HL,0A001h       ;
        SET     2,(HL)          ;
        RET                     ; Return



;----------------------------------------------------
;               Perform Display Test
;----------------------------------------------------
L06C6:  CALL    L0C1F           ; Enable Display
        LD      IX,L0705        ; IX = Start of data
L06CD:  LD      HL,0C000h       ; Start of RAM to fill
        LD      A,(IX+000h)     ; Get test byte from table
        CP      011h            ; Is this the last byte?
        JR      Z,L071A         ; Yes, so exit test
;----------------------------------------------------
;        Fill $C000-$C7FF with byte from table
;----------------------------------------------------         
L06D7:  LD      (0E030h),A      ; Reset watchdog 
        LD      (HL),A          ; Fill RAM with byte
        INC     HL              ; Go to next RAM location
        LD      DE,0C800h       ; DE = Last RAM address to fill
        EX      DE,HL           ; Check for last address
        SCF                     ; Set carry
        CCF                     ; Clear carry
        SBC     HL,DE           ; Has RAM address reached $C800?
        EX      DE,HL           ; Return pointer to address
        JR      NZ,L06D7        ; No, so conintue fill
;----------------------------------------------------
;             Verify video RAM $C000-$C7FF
;----------------------------------------------------        
        LD      HL,0C000h       ; HL = Start of RAM to verify
        LD      BC,00800h       ; $800 bytes to check
L06ED:  LD      (0E030h),A      ; Reset watchdog in loopo
        CPI                     ; Compare all RAM locations
L06F2:  JR      NZ,L06FB        ; RAM location bad, print error
        JP      PE,L06ED        ; Continue all verify
        INC     IX              ; Point to next byte in table
        JR      L06CD           ; Loop back to RAM Fill
;----------------------------------------------------
;       Video RAM Error, Print error code
;----------------------------------------------------        
L06FB:  LD      A,099h          ; $99 = Error code
        LD      (0E000h),A      ; Print Error code
L0700:  LD      (0E030h),A      ; Reset watchdog
        JR      L0700           ; Loop here forever
        
        
        
;----------------------------------------------------
;       Video RAM Error, Print error code
;----------------------------------------------------        
L0705:  .BYTE $FF,$01,$FE,$02,$04,$FB,$08,$F7,$10 
        .BYTE $F0,$20,$E0,$40,$BF,$80,$7F,$55,$AA      

        .BYTE $11  ; Last byte marker

L071A:    ; somewhere RET        
        LD      DE,00021h
        RET     NZ


;----------------------------------------------------
;      
;----------------------------------------------------
        LD      A,000h
L071F:  LD      (0E030h),A
        LD      (HL),A
        INC     A
        INC     HL
        LD      DE,0C800h
        EX      DE,HL
        SCF     
        CCF     
        SBC     HL,DE
        EX      DE,HL
        JR      NZ,L071F
        LD      HL,0C000h
        LD      BC,00800h
        LD      A,0FFh
L0738:  LD      (0E030h),A
        INC     A
        CPI     
        JR      NZ,L0744
        JP      PO,L0738
        RET     

L0744:  LD      A,099h
        LD      (0E000h),A
L0749:  LD      (0E030h),A
        JR      L0749
        JR      L0754
        LD      B,H
        INC     BC
        POP     HL
        DEC     B
L0754:  RET     PE

        LD      BC,0181Eh
        LD      (BC),A
        JR      NZ,L075F
        INC     B
        INC     BC
        RET     PO

        DEC     B
L075F:  RET     PO
        .BYTE $01,$1E
  
  
  
;----------------------------------------------------
;         3 bytes of routines to put into RAM
;----------------------------------------------------
L0762:  EI                      ; Enable Interrupts
        RETI                    ; Return from Interrupt



;----------------------------------------------------
;                
;----------------------------------------------------
L0765:  PUSH    AF
        PUSH    BC
        PUSH    HL
        LD      (0E030h),A
        LD      A,010h
        OUT     (000h),A
        LD      A,053h          ; char 'S'
        OUT     (000h),A
        LD      A,0B7h
        OUT     (001h),A
        LD      A,046h          ; char 'F'
        OUT     (001h),A
        LD      A,057h          ; char 'W'
        OUT     (002h),A
        LD      A,00Ch
        OUT     (002h),A
        LD      A,0B7h
        OUT     (003h),A
        LD      A,08Ch
        OUT     (003h),A
        LD      (0E030h),A
        LD      B,00Bh
        LD      C,083h
        LD      HL,00757h
        OTIR    
        LD      (0E030h),A
        LD      B,009h
        LD      C,081h
        LD      HL,0074Eh
        OTIR    
;----------------------------------------------------
;             Copy Instructions in RAM
;----------------------------------------------------        
        LD      BC,00003h       ; 3 instructions to copy
        LD      DE,0A102h       ; RAM Routine to run
        LD      HL,L0762        ; Instructions EI,RETI
        LDIR                    ; Copy bytes
;----------------------------------------------------
;                Clear Display   
;----------------------------------------------------        
        LD      A,005h          ; 
        LD      (0A001h),A      ; 
        LD      (0E030h),A      ; 
        LD      BC,00010h       ; 
        LD      HL,0E010h       ; 
        LD      DE,0E011h       ; 
        LD      (HL),00Fh       ; 
        LDIR                    ; Fill with F's?
        LD      (0E030h),A      ; 
        LD      HL,(L2006)      ; 
        LD      (0A10Bh),HL     ; 
        CALL    L0D83           ; 
        LD      A,001h          ; 
        LD      (0A112h),A
        LD      (0A10Bh),HL
        LD      (0E030h),A
        JP      L083C



;----------------------------------------------------
;
;----------------------------------------------------
        LD      DE,0A002h
        LD      BC,(02000h)
        XOR     A
        RL      C
        RL      B
        LDIR    
        LD      (0E030h),A
        LD      HL,02008h
        LD      DE,0A082h
        LD      BC,(02000h)
        XOR     A
        RL      C
        RL      B
        LDIR    
        LD      (0E030h),A
        LD      HL,(L2000)
        LD      (0A172h),HL
        LD      HL,0A172h
        XOR     A
        RL      (HL)
        INC     HL
        RL      (HL)
        LD      BC,(0A172h)
        LD      HL,0A002h
        ADD     HL,BC
        LD      (0A172h),HL
        LD      (0E030h),A
        LD      HL,(L2000)
        LD      (0A174h),HL
        LD      HL,0A174h
        XOR     A
        RL      (HL)
        INC     HL
        RL      (HL)
        LD      BC,(0A174h)
        LD      HL,0A082h
        ADD     HL,BC
        LD      (0A174h),HL
        LD      (0E030h),A
;----------------------------------------------------
;
;----------------------------------------------------
L083C:  CALL    L09A1           ; Read DIP Switch Settings
        LD      (0E030h),A      ; Reset watchdog
        POP     HL              ;
        POP     BC              ;
        POP     AF              ;
        RET                     ; Return



;----------------------------------------------------
;            Interrupt $12:  Joystick press
;----------------------------------------------------
L0846:  PUSH    AF              ;
        PUSH    HL              ;
        PUSH    IX              ;
        PUSH    IY              ;
        LD      (0E030h),A      ; Reset watchdog
        CALL    L0A44           ;
        LD      HL,0A171h       ;
        INC     (HL)            ;
        LD      IX,0A105h       ;
        LD      IY,0A109h       ;
        LD      A,(0E080h)      ;
        CPL                     ;
        CP      (IX+000h)       ;
        JR      NZ,L087C        ;
        LD      A,(0A107h)      ;
        XOR     (IX+000h)       ;
        AND     (IX+000h)       ;
        OR      (IY+000h)       ;
        LD      (IY+000h),A     ;
        LD      A,(IX+000h)     ;
        LD      (0A107h),A      ;
L087C:  LD      (IX+000h),A     ;
        LD      IX,0A106h       ;
        LD      IY,0A10Ah       ;
        LD      A,(0E088h)      ;
        CPL                     ;
        CP      (IX+000h)       ;
        JR      NZ,L08A5
        LD      A,(0A108h)
        XOR     (IX+000h)
        AND     (IX+000h)
        OR      (IY+000h)
        LD      (IY+000h),A
        LD      A,(IX+000h)
        LD      (0A108h),A
L08A5:  LD      (IX+000h),A
        LD      (0A177h),A
        CALL    L0282
        POP     IY
        POP     IX
        POP     HL
        POP     AF
        JP      0A102h          ; Run RAM routine (EI,RETI)



;----------------------------------------------------
;                RESET Code begins
;----------------------------------------------------
;                 Clear Display 
;----------------------------------------------------
L08B7:  LD      A,0FFh          ; $FF = Blank
        LD      (0E000h),A      ; Clear display
        LD      (0E008h),A      ; Clear display
        LD      (0E030h),A      ; Reset watchdog
        JP      L03D0           ; Perform first test: Register Check



;----------------------------------------------------
;    Register Test Passed, go to next test
;----------------------------------------------------
L08C5:  LD      (0E030h),A      ; Reset watchdog
        JP      L1B8B           ; Perform next test


;----------------------------------------------------
;     Checksum Test Passed, go to next test
;----------------------------------------------------
L08CB:  LD      (0E030h),A      ; Reset watchdog
        JP      L1B02           ; Perform next test


;----------------------------------------------------
;          RAM test passed, continue Setup
;----------------------------------------------------
L08D1:  LD      (0E030h),A      ; Reset watchdog
        LD      SP,0A7FFh       ; Setup Stack pointer (before function CALLs)
        CALL    L06C6           ; Perform Display test
        LD      (0E030h),A      ; Reset watchdog
        CALL    L03F7           ; Perform LDPlayer Test
        LD      (0E030h),A      ; Reset watchdog
        CALL    L0004           ; Nothing, just returns
        LD      (0E030h),A      ; Reset watchdog
;----------------------------------------------------
;            Print PASSED code to display
;----------------------------------------------------        
        LD      A,08Ch          ; Error code = $8C
        LD      (0E000h),A      ; Print error code to display
        JP      L0034           ; Begin Main Program



;----------------------------------------------------
;           Subtract Credits to Start Game
;----------------------------------------------------
L08F1:  LD      A,(0A10Ah)      ; Get Number of Credits needed to start
        AND     003h            ; 
        JP      Z,L0981         ; FREEPLAY so just start game
        CP      003h            ;
        JP      Z,L0981         ;
;----------------------------------------------------
;           Subtract Credits to Start Game
;----------------------------------------------------        
        LD      B,A             ; B = 1 or 2 Players (credits)
        LD      A,(0A14Bh)      ; Get Number of Credits
        SUB     B               ; Subtract credits at start of game
        DAA                     ; Create decimal number
        JP      M,L0981         ;
        LD      (0A14Bh),A      ; Save new total of credits
        SRA     B               ; B = 0,1 (was 1,2)
        LD      A,B             ; A = Number of players
        LD      (0A153h),A      ; Save Number of Players (0,1)
        CALL    L1BED           ;
        LD      (0A142h),BC     ;
        LD      (0A144h),BC     ;
        LD      (0A146h),BC     ;
        XOR     A               ; A = 0
        LD      (0A152h),A      ; Set current player to Player1
        INC     A               ; A = 1
        LD      (0A112h),A      ;
        XOR     A
        LD      (0A18Dh),A
        LD      (0A28Dh),A
        LD      (0A18Fh),A
        LD      (0A28Fh),A
        LD      HL,0A186h
        LD      (HL),001h
        LD      HL,0A185h
        LD      (HL),00Ch       ;
        LD      A,(0A148h)      ; Get Initial Number of Lives
        LD      (0A149h),A      ; Set Number of Lives Remaining P1
        LD      (0A14Ah),A      ; Set Number of Lives Remaining P2
        LD      HL,0A01Ah       ;
        LD      (0A13Eh),HL     ;
        CALL    L1C61           ;
        LD      HL,0A082h       ;
        LD      (0A13Ch),HL     ;
        LD      HL,0A001h       ;
        RES     0,(HL)          ;
        SET     3,(HL)          ;
        SET     4,(HL)          ;
        SET     5,(HL)          ;
        SET     6,(HL)          ;
        SET     2,(HL)          ;
        LD      HL,0A111h       ;
        RES     4,(HL)          ;
        LD      HL,0A17Dh       ;
        LD      (HL),000h       ;
        INC     HL              ;
        LD      (HL),000h       ;
        CALL    L0C1F           ;
        CALL    L195B           ;
;----------------------------------------------------
;                Start First Scene
;----------------------------------------------------        
        LD      HL,(L2002)      ; Get First Scene Index
        LD      (0A10Bh),HL     ; Store Scene Index
        CALL    L13FD           ; SEARCH to Frame from Scene data (index $A10B)
;----------------------------------------------------
;                
;----------------------------------------------------        
L0981:  LD      HL,0A001h       ;
        BIT     0,(HL)          ;
        NOP                     ;
        NOP                     ;
        NOP                     ;
        LD      HL,0A10Ah       ;
        RES     0,(HL)          ;
        RES     1,(HL)          ;
        RET                     ; Return
        
        
        
;----------------------------------------------------
;               
;----------------------------------------------------        
        RET     NZ
        LD      SP,HL
        AND     H
        OR      B
        SBC     A,C
        SUB     D
        ADD     A,D
        RET     M

        ADD     A,B
        SBC     A,B
        ADC     A,B
        ADD     A,E
        ADD     A,0A1h
        ADD     A,(HL)
        ADC     A,(HL)



;----------------------------------------------------
;             Read DIP Switch Settings
;----------------------------------------------------
L09A1:  LD      A,(0E090h)      ; Get DIP Switch A
        CPL                     ; Toggle bits
        LD      (0A16Ah),A      ; Save DIP Switch A
        LD      A,(0E098h)      ; Get DIP Switch B
        CPL                     ; Toggle bits
        LD      (0A16Bh),A      ; Save DIP Switch B
;----------------------------------------------------
;         Setting:  Number of Coins LEFT       
;----------------------------------------------------
        LD      A,(0A16Ah)      ; Get DIP Switch A
        AND     007h            ; Check Number Coins LEFT
        ADD     A,001h          ; Add 1 to create number of coins
        LD      (0A14Eh),A      ; Save Number of Coins LEFT
;----------------------------------------------------
;         Setting:  Number of Credits LEFT       
;----------------------------------------------------
        LD      A,(0A16Ah)      ; Get DIP Switch A
        SRL     A               ;
        SRL     A               ;
        SRL     A               ;
        AND     003h            ;
        ADD     A,001h          ;
        LD      (0A14Ch),A      ;
;----------------------------------------------------
;         Setting:  Number of Coins RIGHT       
;----------------------------------------------------
        LD      A,(0A16Bh)      ; Get DIP Switch B
        AND     003h            ; Get number of coins selection 
        ADD     A,001h          ; Add 1 to create number of coins
        LD      (0A14Fh),A      ; Save Number of Coins RIGHT
;----------------------------------------------------
;         Setting:  Number of Credits RIGHT
;----------------------------------------------------
        LD      A,(0A16Bh)      ; Get DIP Switch B
        SRL     A               ; Read DIPs
        SRL     A               ; Read DIPs
        LD      C,A             ; C = DIP Bank
        AND     003h            ; Get number of credits setting
        ADD     A,001h          ; Add 1 to create Number of Credits
        LD      (0A14Dh),A      ; Save Number of Credits
;----------------------------------------------------
;         Setting:  Number of Lives         
;----------------------------------------------------
        LD      A,C             ; Get DIP Switch
        SRL     A               ; Read DIPs
        SRL     A               ; Read DIPs
        AND     003h            ; Check Lives setting
        ADD     A,002h          ; Add 2 to create lives setting
        LD      (0A148h),A      ; Save Initial Number of Lives
;----------------------------------------------------
;         Setting:  
;----------------------------------------------------
        LD      A,(0A16Ah)      ; Get DIP Switch A
        SRL     A               ;
        SRL     A               ;
        SRL     A               ;
        SRL     A               ;
        SRL     A               ;
        SRL     A               ;
        LD      (0A18Eh),A      ;
        RET                     ; Return



;----------------------------------------------------
;         
;----------------------------------------------------
L0A01:  PUSH    AF
        LD      A,(0A000h)
        AND     0F8h
        OR      005h
        LD      (0E028h),A
        LD      (0A000h),A
        POP     AF
        RET     



;----------------------------------------------------
;                 A000 Status = $00
;----------------------------------------------------
L0A11:  PUSH    AF              ;
        LD      A,(0A000h)      ;
        AND     0F8h            ;
        LD      (0E028h),A      ;
        LD      (0A000h),A      ;
        POP     AF              ;
        RET                     ; Return



;----------------------------------------------------
;                    unknown
;----------------------------------------------------
        POP     DE
        POP     BC
        PUSH    DE
        LD      HL,00991h
        LD      D,000h
        LD      E,C
        SRL     C
        SRL     C
        SRL     C
        SRL     C
        ADD     HL,BC
        LD      A,(HL)
        LD      (0E000h),A
        LD      HL,00991h
        LD      D,000h
        LD      A,C
        AND     00Fh
        LD      C,A
        ADD     HL,BC
        LD      A,(HL)
        LD      (0E008h),A
        RET     

L0A44:  LD      DE,0A170h
        LD      HL,0A202h
        LD      B,002h
L0A4C:  INC     HL
        LD      A,(DE)
        BIT     3,A
        SET     7,(HL)
        JR      Z,L0A56
        RES     7,(HL)
L0A56:  INC     DE
        DJNZ    L0A4C
        LD      DE,0E008h
        LD      A,(HL)
        LD      (DE),A
        RES     3,E
        DEC     HL
        LD      A,(HL)
        LD      (DE),A
        RET     

        EX      AF,AF'
        RET     PO

        RET     

L0A67:  LD      A,001h
        LD      HL,0A112h
        CP      (HL)
        RET     NZ

        LD      A,(0A185h)
        CP      000h
        RET     Z

        LD      HL,0A186h
        DEC     (HL)
        JR      Z,L0ACA
        LD      A,04Ch
        CP      (HL)
        JR      NZ,L0A88
        LD      A,(0A001h)
        BIT     2,A
        JR      Z,L0A88
        LD      (HL),001h
L0A88:  LD      HL,0A188h
        LD      A,(0A14Bh)
        CP      (HL)
        LD      (HL),A
        JR      Z,L0AC5
        LD      A,(0A185h)
        CP      00Ah
        JR      NZ,L0AA7
        CALL    L0C1F
        CALL    L195B
        CALL    L01DE
        CALL    L0C2D
        JR      L0AC5
L0AA7:  CP      006h
        JR      NZ,L0AB6
        CALL    L0C1F
        CALL    L185C
        CALL    L0C2D
        JR      L0AC5
L0AB6:  CP      007h
        JR      NZ,L0AC5
        CALL    L0C1F
        CALL    L185C
        CALL    L0C2D
        JR      L0AC5
L0AC5:  POP     IX
        JP      L13C5
L0ACA:  CP      00Bh
        JR      NZ,L0ACF
        RET     

L0ACF:  CP      002h
        JR      NZ,L0AE8
        LD      A,00Bh
        LD      (0A185h),A
        LD      A,00Ch
        LD      (0A186h),A
        CALL    L13D3
        CALL    L0C1F
        POP     IX
        JP      L13C5
L0AE8:  CP      00Ch
        JR      NZ,L0B1A
        LD      A,(0A153h)      ; Get how many players
        CP      000h            ; Is this 1-Player game?
        JR      NZ,L0AFC        ; No, so skip ahead
        LD      A,00Bh          ;
        LD      (0A185h),A      ;
        CALL    L13D3           ;
        RET                     ; Return

L0AFC:  LD      A,04Bh
        LD      (0A186h),A
        LD      A,002h
        LD      (0A185h),A
        CALL    L0C1F
        CALL    L195B
        CALL    L1775
        CALL    L0C2D
        CALL    L13D3
        POP     IX
        JP      L13C5
        
        
        
L0B1A:  CP      001h
        JR      NZ,L0B55
        LD      A,(0A153h)      ; Get which player is playing
        CP      000h
        JR      Z,L0B40
        LD      A,002h
        LD      (0A185h),A
        LD      A,04Bh
        LD      (0A186h),A
        CALL    L0C1F
        CALL    L195B
        CALL    L1775
        CALL    L0C2D
        POP     IX
        JP      L13C5
L0B40:  LD      A,00Bh
        LD      (0A185h),A
        LD      A,00Ch
        LD      (0A186h),A
        CALL    L13D3
        CALL    L0C1F
        POP     IX
        JP      L13C5
L0B55:  CP      009h
        JR      Z,L0B40
        CP      007h
        JR      NZ,L0B99
        LD      A,(0A150h)
        LD      B,A
        LD      A,(0A151h)
        LD      C,A
        LD      A,(0A14Bh)
        OR      B
        OR      C
        JR      Z,L0B87
        LD      A,00Ah
        LD      (0A185h),A
        LD      A,04Bh
        LD      (0A186h),A
        CALL    L0C1F
        CALL    L195B
        CALL    L01DE
        CALL    L0C2D
        POP     IX
        JP      L13C5
L0B87:  LD      A,00Bh
        LD      (0A185h),A
        LD      A,00Ch
        LD      (0A186h),A
        CALL    L0C1F
        POP     IX
        JP      L13C5
L0B99:  CP      006h
        JR      NZ,L0BB8
        LD      A,007h
        LD      (0A185h),A
        LD      A,04Bh
        LD      (0A186h),A
        CALL    L0C1F
        CALL    L195B
        CALL    L1792
        CALL    L0C2D
        POP     IX
        JP      L13C5
L0BB8:  CP      005h
        JR      NZ,L0BD7
        LD      A,00Ah
        LD      (0A185h),A
        LD      A,04Bh
        LD      (0A186h),A
        CALL    L0C1F
        CALL    L195B
        CALL    L01DE
        CALL    L0C2D
        POP     IX
        JP      L13C5
L0BD7:  CP      00Ah
        JR      NZ,L0C0D
        LD      A,(0A14Bh)
        CP      002h
        JP      M,L0BF2
        LD      A,00Ah
        LD      (0A185h),A
        LD      A,04Bh
        LD      (0A186h),A
        POP     IX
        JP      L13C5
L0BF2:  LD      A,006h
        LD      (0A185h),A
        LD      A,04Bh
        LD      (0A186h),A
        CALL    L0C1F
        CALL    L195B
        CALL    L1792
        CALL    L0C2D
        POP     IX
        JP      L13C5
L0C0D:  LD      A,00Bh
        LD      (0A185h),A
        LD      A,00Ch
        LD      (0A186h),A
        CALL    L0C1F
        POP     IX
        JP      L13C5
        
        
        
;----------------------------------------------------
;                 Enable Display
;----------------------------------------------------        
L0C1F:  LD      A,(0A000h)      ;
        AND     0F8h            ;
        OR      006h            ;
        LD      (0E028h),A      ;
        LD      (0A000h),A      ;
        RET                     ;



;----------------------------------------------------
;               Disable Display
;----------------------------------------------------
L0C2D:  LD      A,(0A000h)      ;
        AND     0F8h            ;
        OR      005h            ;
        LD      (0E028h),A      ;
        LD      (0A000h),A      ;
        RET                     ;



;----------------------------------------------------
;               
;----------------------------------------------------
L0C3B:  PUSH    AF
        PUSH    HL              ;
        LD      HL,0A169h       ;
        LD      A,004h          ;
        INC     (HL)            ;
        CP      (HL)
        JP      NZ,L13CE
        LD      (HL),000h
        PUSH    BC
        PUSH    DE
        PUSH    IX
        PUSH    IY
        CALL    L1C34
        LD      HL,0A170h
        INC     (HL)
        LD      HL,0A001h
        BIT     0,(HL)
        CALL    NZ,L08F1        ; Subtract Credits to Start game
        CALL    L0A67
        LD      HL,0A001h
        BIT     2,(HL)
        JR      Z,L0C74
        LD      HL,0A112h
        DEC     (HL)
        CALL    L1CB4
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
L0C74:  LD      DE,0A113h
        LD      HL,0A109h
        LD      B,008h
L0C7C:  INC     DE
        INC     DE
        SLA     (HL)
        CALL    C,L0C96
        DJNZ    L0C7C
        LD      HL,0A10Ah
        LD      B,004h
L0C8A:  INC     DE
        INC     DE
        SLA     (HL)
        CALL    C,L0C96
        DJNZ    L0C8A
        JP      L0CDA
L0C96:  INC     DE
        LD      A,(DE)
        DEC     DE
        INC     A
        JR      NZ,L0CAC
        LD      A,(0A001h)
        BIT     0,A
        RET     NZ

        LD      A,(0A111h)
        BIT     4,A
        RET     NZ

        CALL    L1A8C
        RET     

L0CAC:  LD      HL,0A189h
        LD      A,(0A152h)
        AND     A
        JR      Z,L0CB7
        LD      H,0A2h
L0CB7:  LD      A,(0A112h)
        CP      (HL)
        RET     M

        CALL    L1AAA
        POP     IX
        LD      A,(DE)
        LD      (0A10Bh),A
        INC     DE
        LD      A,(DE)
        LD      (0A10Ch),A
        RLA     
        JP      NC,L0CDA
        CCF     
        RRA     
        LD      (0A10Ch),A
        LD      A,000h
        LD      (0A10Dh),A
        JR      L0CED
L0CDA:  LD      HL,0A001h
        RES     1,(HL)
        LD      HL,0A112h
        LD      A,(HL)
        CP      000h
        JP      NZ,L0D76
        LD      HL,0A001h
        SET     1,(HL)
L0CED:  CALL    L0D83
        CALL    L1D14
        LD      (0A10Bh),HL
        LD      A,(0A112h)
        SRL     A
        SRL     A
        LD      HL,0A189h
        LD      BC,0A18Fh
        LD      D,A
        LD      A,(0A152h)
        AND     A
        JR      Z,L0D10
        LD      HL,0A289h
        LD      BC,0A28Fh
L0D10:  LD      A,(BC)
        AND     A
        LD      (HL),A
        JR      Z,L0D25
        LD      (HL),D
        CP      001h
        JR      Z,L0D25
        LD      A,D
        ADD     A,D
        LD      (HL),A
        LD      A,(BC)
        CP      002h
        JR      Z,L0D25
        LD      A,(HL)
        ADD     A,D
        LD      (HL),A
L0D25:  CALL    L1E18
        JR      NZ,L0D36
        LD      HL,(0A10Fh)     ; Get Starting Frame Number
        LD      DE,(0A10Dh)     ; Get Ending Frame Number
        XOR     A               ; Clear carry
        SBC     HL,DE           ; Does start equal end?
        JR      Z,L0D3B         ; Yes, so skip PLAY command 
;----------------------------------------------------
;            Indicated frame is to be PLAYed
;----------------------------------------------------
L0D36:  LD      HL,0A001h       ;
        RES     1,(HL)          ;
;----------------------------------------------------
;         Determine Length of scene to PLAY
;----------------------------------------------------        
L0D3B:  LD      HL,(0A10Fh)     ; Get starting Frame Number
        LD      BC,(0A111h)     ; Get number of Frames to play
        LD      C,B             ; BC = Duration (0-255)
        LD      B,000h          ; BC = Duration (0-255) 
        INC     BC              ; Add 1 to duruation
        ADD     HL,BC           ; Add frames to create Ending Frame Number
        LD      (0A10Dh),HL     ; Setup ending Frame Number
        LD      HL,0A111h       ;
        BIT     6,(HL)          ;
        JR      Z,L0D57         ; Is this an Attract Mode Search????
        CALL    L0EB7           ; SEARCH to Frame Number in $A10F
        JP      L0D76           ;



;----------------------------------------------------
;                Play attract mode
;----------------------------------------------------
L0D57:  LD      HL,0A001h       ;
        BIT     1,(HL)          ;
        JP      NZ,L0D76        ;
        LD      HL,0A001h       ;
        BIT     0,(HL)          ;
        JR      Z,L0D73         ;
;----------------------------------------------------
;           Determine if Sound is included
;----------------------------------------------------        
        LD      HL,0A16Ah       ; HL = DIP Switch A
        BIT     5,(HL)          ; Is Sound enable in Attract Mode?
        JR      NZ,L0D73        ; Yes, so skip ahead
        CALL    L0E8C           ; Send Play Command (no sound)
        JP      L0D76           ;
;----------------------------------------------------
;                Start Attract Mode
;----------------------------------------------------
L0D73:  CALL    L0E66           ;
L0D76:  LD      A,000h          ;
        LD      HL,0A109h       ;
        LD      (HL),A          ;
        LD      HL,0A10Ah       ;
        LD      (HL),A          ;
        JP      L0F65           ;
        
        
        
;----------------------------------------------------
;                
;----------------------------------------------------        
L0D83:  PUSH    BC
        PUSH    DE
        PUSH    HL
        PUSH    IX
        LD      A,063h
        OUT     (000h),A
        XOR     A
        LD      HL,0A16Dh
        LD      (HL),A
        LD      HL,0A187h
        LD      (HL),A
        LD      HL,0A16Ch
        LD      (HL),A
        LD      BC,(0A10Bh)
        LD      (0A17Ah),BC
        DEC     BC
        LD      (0A10Bh),BC
        LD      IX,0A10Bh
        SLA     (IX+000h)
        RL      (IX+001h)
        SLA     (IX+000h)
        RL      (IX+001h)
        SLA     (IX+000h)
        RL      (IX+001h)
        SLA     (IX+000h)
        RL      (IX+001h)
        SLA     (IX+000h)
        RL      (IX+001h)
        LD      HL,(0A10Bh)
        LD      BC,L2088        ; Table
        ADD     HL,BC           
        LD      BC,00020h       ; 32 bytes to copy
        LD      DE,0A10Fh       ; Copy destination frame number
        LD      A,(0A111h)
        LD      (0A176h),A
        LDIR    
        POP     IX
        POP     HL
        POP     DE
        POP     BC
        RET     

        NOP     
        INC     B
        LD      C,017h
        JR      NZ,L0E17
        LD      L,037h
        LD      B,B
        LD      C,H
        LD      H,B
        LD      L,H
        RST     38h
        INC     B
        LD      A,(BC)
        ADD     HL,BC
        DEC     B
        INC     B
        LD      A,(BC)
        ADD     HL,BC
        DEC     B
        INC     C
        DEC     B
        INC     C
        DEC     B
        XOR     D
        NOP     
        OR      C
        NOP     
        CP      B
        NOP     
        SBC     A,H
        LD      BC,00084h
        LD      E,D
        LD      BC,000C5h
        LD      L,L
        LD      BC,000EFh
        AND     E
        LD      BC,0014Eh
        CALL    M,L0901
        NOP     
        LD      E,000h
        LD      D,(HL)
        NOP     
        LD      H,(HL)
        NOP     
        HALT    
        NOP     
        DEC     A
        LD      BC,0002Ah
        LD      DE,03A01h
        NOP     
        LD      HL,09701h
        NOP     
        OR      (HL)
        LD      BC,000D7h
        CALL    PO,L0201
        LD      BC,001D6h
        LD      C,B
        LD      (BC),A
        LD      D,E
        LD      (BC),A
        LD      A,D
        LD      (BC),A
        LD      A,A
        LD      BC,001C9h
        EX      AF,AF'
        LD      (BC),A
        INC     L
        LD      (BC),A
        LD      L,L
        LD      (BC),A
        LD      (HL),E
        NOP     
        LD      (IX+001h),D
        RET     



;----------------------------------------------------
;                LDPlayer Commands
;----------------------------------------------------
L0E54:  .BYTE $46,$00,$00,$00,$00,$00,$4E,$0D   ; 'F00000N' <RET> 
L0E5C:  .BYTE $55,$0D                           ; 'U'  FORWARD PLAY (No sound)
L0E5E:  .BYTE $46,$00,$00,$00,$00,$00,$52,$0D   ; 'F00000R' <RET> 




;----------------------------------------------------
;          Setup Commmand to Search Frame 
;----------------------------------------------------
L0E66:  PUSH    AF              ; Save register
        PUSH    BC              ; Save register
        PUSH    DE              ; Save register
        PUSH    HL              ; Save register
;----------------------------------------------------
;              
;----------------------------------------------------        
        LD      BC,00008h       ; 8 bytes to copy
        LD      DE,0A12Fh       ; Outgoing Serial Command buffer
        LD      HL,L0E54        ; HL = LDPlayer Command 'F00000N'
        LD      (0A138h),DE     ; Save outgoing buffer pointer
        LDIR                    ; Copy all bytes
        CALL    L00E0           ; Add HEX Frame Offset then convert to ASCII
        LD      A,(0A185h)      ;
        CP      000h            ;
        CALL    Z,L0C1F         ;
        CALL    L0ED5           ;
;----------------------------------------------------
;               Restore registers
;----------------------------------------------------        
        POP     HL              ; Restore register
        POP     DE              ; Restore register
        POP     BC              ; Restore register
        POP     AF              ; Restore register
        RET                     ; Return



;----------------------------------------------------
;              Send Play Command (no sound)
;----------------------------------------------------
L0E8C:  PUSH    AF              ; Save registers first
        PUSH    BC              ; Save registers first
        PUSH    DE              ; Save registers first
        PUSH    HL              ; Save registers first
;----------------------------------------------------
;             
;----------------------------------------------------        
        LD      BC,00002h       ; 2 bytes in command
        LD      DE,0A12Fh       ; DE = Serial Command buffer
        LD      HL,L0E5C        ; HL = PLAY Command NO SOUND ('U')
        LD      (0A138h),DE     ; Save outgoing buffer pointer
        LDIR                    ;
        CALL    L0ED5           ;
        LD      A,(0A000h)      ;
        AND     0F8h            ;
        LD      (0A000h),A      ;
        LD      (0E028h),A      ;
        LD      HL,0A001h       ;
        SET     2,(HL)          ;
;----------------------------------------------------
;           Restore registers and return
;----------------------------------------------------        
        POP     HL              ; Restore registers
        POP     DE              ; Restore registers
        POP     BC              ; Restore registers
        POP     AF              ; Restore registers
        RET                     ; Return


;----------------------------------------------------
;    SEARCH to Frame number found in $A10F
;----------------------------------------------------
L0EB7:  PUSH    AF              ; Save register
        PUSH    BC              ; Save register
        PUSH    DE              ; Save register
        PUSH    HL              ; Save register
;----------------------------------------------------
;            Setup Command to SEARCH
;----------------------------------------------------        
        LD      BC,00008h       ; 8 bytes in command
        LD      DE,0A12Fh       ; DE = Serial Command buffer
        LD      HL,L0E5E        ; Command 'F00000R' <RET> 
        LD      (0A138h),DE     ; Save outgoing buffer pointer
        LDIR                    ; Copy command to buffer
        CALL    L00E0           ; Add HEX Frame Offset then convert to ASCII
        CALL    L0ED5           ;
;----------------------------------------------------
;             Restore registers and return
;----------------------------------------------------        
        POP     HL              ; Restore register
        POP     DE              ; Restore register
        POP     BC              ; Restore register
        POP     AF              ; Restore register
        RET                     ; Return



;----------------------------------------------------
;    Wait for CLEAR TO SEND then begin transmission
;----------------------------------------------------
L0ED5:  LD      HL,0A001h       ;
        BIT     2,(HL)          ;
        JP      NZ,L0EE1        ;
        JR      L0ED5           ;
        DI                      ;
        HALT                    ;
L0EE1:  RES     2,(HL)          ;
;----------------------------------------------------
;           Open Serial Port for Transmit
;----------------------------------------------------
        LD      A,001h          ;
        OUT     (081h),A        ;
        LD      A,01Eh          ;
        OUT     (081h),A        ;
        SUB     A               ; A = 0
        OUT     (080h),A        ;
        RET                     ; Return


;----------------------------------------------------
;              Receive Interrupt (Rx)
;----------------------------------------------------
;            Read Status Byte from Player
;----------------------------------------------------
L0EEF:  PUSH    AF              ;
        PUSH    HL              ;
        IN      A,(080h)        ; Get serial byte from LDPlayer
        LD      HL,0A190h       ; HL = Error Status Byte
        CP      041h            ; Is feedback data = 'A'?
        JP      NZ,L0EFC        ; No, so skip ahead
        INC     (HL)            ; Receive State = 1 (A)
L0EFC:  CP      030h            ; Was SEARCH performed correctly? ('A0')
        JP      NZ,L0F02        ; No, so handle error
        INC     (HL)            ; Receive State = 2 (A0)
L0F02:  CP      031h            ;
        JP      NZ,L0F08        ;
        INC     (HL)            ; Receive State = 2 (A1)
L0F08:  CP      00Dh            ; Was carriage RETURN received?
        JR      NZ,L0F3C        ; No, so leave
;----------------------------------------------------
;            Check for completed message
;----------------------------------------------------        
        LD      A,(0A190h)      ; Get Receive State
        CP      002h            ; Has complete message been received?
        JP      M,L0F3C         ; No, so continue
        XOR     A               ; A = 0
        LD      (0A190h),A      ; Clear out Receive buffer
;----------------------------------------------------
;             Process completed message
;----------------------------------------------------        
        LD      HL,0A001h       ;
        SET     2,(HL)          ;
        XOR     A               ;
        LD      (0A169h),A      ;
        LD      A,(0A185h)      ;
        CP      000h            ;
        CALL    Z,L0A11         ;
        CP      00Bh            ;
        JR      NZ,L0F3C        ;
;----------------------------------------------------
;            
;----------------------------------------------------        
        LD      A,(0A000h)      ;
        AND     0F8h            ;
        LD      (0A000h),A      ;
;----------------------------------------------------
;            
;----------------------------------------------------        
        LD      (0E028h),A      ;
        XOR     A               ;
        LD      (0A185h),A      ;
;----------------------------------------------------
;               Return from Interrupt
;----------------------------------------------------        
L0F3C:  POP     HL              ;
        POP     AF              ;
        JP      0A102h          ; Run RAM routine (EI,RETI)
        
        
        
;----------------------------------------------------
;             Send one byte out serially
;----------------------------------------------------        
L0F41:  PUSH    AF              ; Save register
        PUSH    HL              ; Save register
        XOR     A               ;
        LD      (0A190h),A      ;
        LD      HL,(0A138h)     ; HL = Pointer to outgoing message
        LD      A,(HL)          ; Get next byte of commmand message
        OUT     (080h),A        ; Send byte out to serial port
        CP      00Dh            ; Last byte was Carriage RETURN?
        JR      NZ,L0F59        ; No, so keep sending
;----------------------------------------------------
;        Close Serial Port (after carriage return)
;----------------------------------------------------        
        LD      A,001h          ;
        OUT     (081h),A        ;
        LD      A,01Ch          ;
        OUT     (081h),A        ;
;----------------------------------------------------
;              Point to next serial byte
;----------------------------------------------------        
L0F59:  INC     HL              ; Increment buffer pointer
        LD      (0A138h),HL     ; Update buffer pointer
        POP     HL              ; Restore register
        POP     AF              ; Restore register
        JP      LA102           ; Run RAM routine (EI,RETI)
        
        
;----------------------------------------------------
;               
;----------------------------------------------------        
L0F62:  JP      LA102           ; Run RAM routine (EI,RETI) 
        
        
        
;----------------------------------------------------
;               
;----------------------------------------------------        
L0F65:  LD      HL,0A001h
        BIT     0,(HL)
        JR      Z,L0FAD
        LD      A,(0A10Bh)
        CP      001h
        JP      NZ,L13C5
        LD      A,(0A112h)
        CP      003h
        JR      NZ,L0FA0
        LD      A,(0A185h)
        CP      005h
        JR      Z,L0F98
        LD      A,(0A150h)
        LD      B,A
        LD      A,(0A151h)
        LD      C,A
        LD      A,(0A14Bh)
        OR      B
        OR      C
        JR      Z,L0F98
        LD      A,00Ah
        LD      (0A185h),A
        JR      L0F9D
L0F98:  LD      A,005h
        LD      (0A185h),A
L0F9D:  JP      L1322
L0FA0:  CP      002h
        JP      Z,L134C
        CP      001h
        JP      Z,L13AF
        JP      L13C5
;----------------------------------------------------
;       
;----------------------------------------------------        
L0FAD:  LD      A,(0A112h)
        CP      006h
        JP      Z,L0FD1
        CP      005h
        JP      Z,L101E
        CP      004h
        JP      Z,L126D
        CP      003h
        JP      Z,L1322
        CP      002h
        JP      Z,L134C
        CP      001h
        JP      Z,L13AF
        JP      L13C5
L0FD1:  LD      HL,0A001h
        BIT     7,(HL)
        JR      Z,L0FE1         ; Yes, so swap players
        RES     7,(HL)
        LD      HL,0A112h
        INC     (HL)
        JP      L13C5
        
;----------------------------------------------------
;       Load Game Variables for Player 1 or 2  
;----------------------------------------------------        
L0FE1:  LD      A,(0A152h)      ; Get which player is playing?
        CP      000h            ; Is Player1 playing?
        JR      NZ,L1003        ; No, so load Player2 variables
;----------------------------------------------------
;           Setup Player1 Game Variables
;----------------------------------------------------        
        LD      HL,0A13Ah       ; HL = Scene Index pointer
        LD      (0A154h),HL     ; Save Player1 Scene Index pointer
        LD      HL,0A13Eh       ;
        LD      (0A156h),HL     ;
        LD      HL,(0A172h)     ;
        LD      (0A158h),HL     ;
        LD      HL,0A002h       ;
        LD      (0A15Ch),HL     ;
        JP      L13C5           ; Continue with game
;----------------------------------------------------
;           Setup Player2 Game Variables
;----------------------------------------------------        
L1003:  LD      HL,0A13Ch       ; HL = Scene Index pointer
        LD      (0A154h),HL     ; Save Player2 Scene Index pointer
        LD      HL,0A140h       ;
        LD      (0A156h),HL     ;
        LD      HL,(0A174h)     ;
        LD      (0A158h),HL     ;
        LD      HL,0A082h       ;
        LD      (0A15Ch),HL     ;
        JP      L13C5           ; Continue with game
        
        
        
;----------------------------------------------------
;           
;----------------------------------------------------        
L101E:  LD      HL,0A001h       ;
        SET     7,(HL)          ;
        LD      A,(0A111h)      ;
        BIT     4,A             ;
        JP      L10AB           ;
L102B:  LD      A,(0A152h)      ;
        CP      000h            ;
        LD      HL,0A001h       ;
        JR      NZ,L103B        ;
        BIT     5,(HL)          ;
        RES     5,(HL)          ;
        JR      L103F           ;
L103B:  BIT     6,(HL)          ;
        RES     6,(HL)          ;
L103F:  JR      Z,L106B         ;
;----------------------------------------------------
;              Restore Player's Scene Index 
;----------------------------------------------------
        LD      HL,(0A154h)     ; Get Scene index pointer for player
        LD      E,(HL)          ; DE = Player's Scene index pointer
L1045:  INC     HL              ; DE = Player's Scene index pointer
        LD      D,(HL)          ; DE = Player's Scene index pointer
        EX      DE,HL           ; Put pointer in HL
        LD      E,(HL)          ; Get Scene index from address
        INC     HL              ; Get Scene index from address
        LD      D,(HL)          ; Get Scene index from address
        LD      (0A10Bh),HL     ; Store Scene Index
;----------------------------------------------------
;               Check if Lives Remaining  
;----------------------------------------------------        
        LD      A,(0A153h)      ; Check for 2-player game
        CP      000h            ; Is this a 2-player game?
        JP      Z,L1190         ; No, 1-player so skip ahead
        LD      A,(0A152h)      ; Which player is playing?
        XOR     001h            ; Check player number
        LD      HL,0A149h       ; HL = Number of Lives Remaining P1
        CP      000h            ; Is is player 1?
        JR      Z,L1063         ; Yes, so use this number
        INC     HL              ; HL = Number of Lives Remaining P2 (A14A)
L1063:  XOR     A               ; A = 0
        CP      (HL)            ; Are lives at zero?
        JP      Z,L1190         ; Yes, so game over
        JP      L111F           ;




L106B:  LD      HL,0A17Dh
        LD      A,(0A152h)
        CP      000h
        JR      Z,L1076
        INC     HL
L1076:  LD      A,001h
        CP      (HL)
L1079:  JR      NZ,L109E
        LD      DE,(L2004)
        LD      (0A10Bh),DE
        LD      A,(0A153h)      ; Check for 2 player game
        CP      000h            ; Is this a 2 player game?
        JP      Z,L1190         ; No, so skip ahead
        LD      A,(0A152h)      ; Which player is playing?
        XOR     001h            ; Check player number
        LD      HL,0A149h       ; HL = Number of Lives Remaining P1
        JR      Z,L1096         ; Olayer 1 so use this number
        INC     HL              ; HL = Number of Lives Remaining P2 (A14A)
L1096:  XOR     A               ; A = 0
        CP      (HL)            ; Are lives at zero?
        JP      Z,L1190         ; Yes, so game over
        JP      L111F           ; 
L109E:  LD      HL,(0A154h)
        INC     (HL)
        INC     (HL)
        LD      HL,(0A156h)
        INC     (HL)
        INC     (HL)
        JP      L111F
L10AB:  JR      Z,L10B5
        LD      A,001h
        LD      (0A200h),A
        JP      L1198
L10B5:  LD      A,(0A200h)
        AND     A
        JP      Z,L1198
        JP      L102B
L10BF:  BIT     4,A
        JP      NZ,L1274
        LD      A,(0A200h)
        AND     A
        LD      A,000h
        LD      (0A200h),A
        JP      Z,L1274
        JP      L12B2
L10D3:  PUSH    HL
        LD      HL,(0A201h)
        LD      A,R
        JR      NC,L10DE
        RLCA    
        RLD     
L10DE:  ADD     A,L
        JR      NC,L10E2
        INC     H
L10E2:  LD      L,A
        RES     5,H
        RES     6,H
        RES     7,H
        LD      (0A201h),HL
        LD      A,(HL)
        POP     HL
        RET     

L10EF:
        NOP     
        LD      (BC),A
        INC     B
        LD      B,088h
        ADC     A,H
        SUB     B
        SUB     H
        JR      L1113
        INC     E
        LD      E,020h
        LD      (0A8A4h),HL
        XOR     H
        OR      B
        INC     (HL)
        LD      (HL),038h
        LD      A,(03E3Ch)
        LD      B,B
        LD      B,D
        LD      B,H
        LD      B,(HL)
        NOP     
        INC     B
        DEC     B
        LD      B,007h
        EX      AF,AF'
        ADD     HL,BC
        LD      C,00Fh
        DJNZ    L1127
        RLA     
        LD      BC,00B0Ah
        LD      (DE),A
        JR      L1170
        LD      A,0A1h
        
        

;----------------------------------------------------
;              Restore Scene Variable 
;----------------------------------------------------        
L111F:  LD      A,(0A152h)      ; Get current player
        CP      000h            ; Check which player is playing
        LD      A,(0A001h)      ;
L1127:  JR      NZ,L112D        ; Player2 is playing, so skip ahead
        BIT     6,A             ;
        JR      L112F           ;
L112D:  BIT     5,A             ;
L112F:  JR      Z,L113A         ; Yes, so continue game
;----------------------------------------------------
;               Start Game from Beginning   
;----------------------------------------------------
        LD      HL,(L2002)      ;
        LD      (0A10Bh),HL     ;
        JP      L1190           ;
;----------------------------------------------------
;             Continue with current game   
;----------------------------------------------------        
L113A:  LD      HL,0A17Dh       ;
        LD      A,(0A152h)      ;
        CP      001h            ;
        JR      Z,L1145         ;
        INC     HL              ;
L1145:  LD      A,001h          ;
        CP      (HL)            ;
L1148:  JR      NZ,L1155        ;
        LD      DE,(L2004)      ;
        LD      (0A10Bh),DE     ;
        JP      L1190           ;
;----------------------------------------------------
;         Continue with current Scene Index   
;----------------------------------------------------        
L1155:  LD      HL,0A154h       ;
        LD      A,(0A153h)      ; Get which player is playing
        CP      000h            ;
        JR      Z,L1182         ;
        LD      IX,0A13Ah       ;
        LD      (0A154h),IX     ;
        XOR     A               ;
        PUSH    HL              ;
        LD      HL,0A149h       ;
        CP      (HL)            ;
        POP     HL
        JR      Z,L1180
L1170:  LD      A,(0A152h)
        CP      000h
        JR      NZ,L1182
        XOR     A
        PUSH    HL
        LD      HL,0A14Ah
        CP      (HL)
        POP     HL
        JR      Z,L1182
L1180:  INC     (HL)
        INC     (HL)
L1182:  LD      HL,(0A154h)
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        EX      DE,HL
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        LD      (0A10Bh),DE
L1190:  LD      A,001h
        LD      (0A185h),A
        JP      L13C5
L1198:  LD      A,(0A10Bh)
        CP      000h
        JP      NZ,L13C5
        LD      A,(0A10Ch)
        CP      000h
        JP      NZ,L13C5
        LD      A,(0A152h)
        CP      000h
        LD      HL,0A001h
        JR      NZ,L11B8
        BIT     5,(HL)
        RES     5,(HL)
        JR      L11BC
L11B8:  BIT     6,(HL)
        RES     6,(HL)
L11BC:  JR      Z,L11C6
        LD      A,00Dh
        LD      (0A185h),A
        JP      L1233
L11C6:  LD      HL,0A17Dh
        LD      A,(0A152h)
        CP      000h
        JP      Z,L11D2
        INC     HL
L11D2:  LD      A,001h
        CP      (HL)
        JR      NZ,L11DC
        LD      (HL),002h
        JP      L13C5
L11DC:  LD      HL,0A18Dh
        LD      A,(0A152h)
        AND     A
        JR      Z,L11E8
        LD      HL,0A28Dh
L11E8:  INC     (HL)
        LD      DE,0120Dh
        LD      A,(0A18Eh)
        RLCA    
        RLCA    
        ADD     A,E
        LD      E,A
        LD      BC,0A18Fh
        LD      A,(0A152h)
        AND     A
        JR      Z,L11FF
        LD      BC,0A28Fh
L11FF:  LD      A,(BC)
        ADD     A,E
        LD      E,A
        LD      A,(DE)
        CP      (HL)
        JR      NC,L121D
        LD      (HL),000h
        LD      A,(BC)
        INC     A
        LD      (BC),A
        JR      L121D
        INC     B
        LD      (BC),A
        LD      (BC),A
        NOP     
        INC     BC
        LD      (BC),A
        LD      (BC),A
        LD      BC,00102h
        LD      (BC),A
        INC     BC
        LD      BC,L0201
        INC     B
L121D:  LD      HL,(0A154h)
        INC     (HL)
        INC     (HL)
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        PUSH    DE
        LD      HL,(0A156h)
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        POP     HL
        XOR     A
        SBC     HL,DE
        JP      Z,L1245
L1233:  LD      HL,(0A154h)
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        EX      DE,HL
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        INC     DE
        LD      (0A10Bh),DE
        JP      L125B
L1245:  LD      DE,(L2004)
        INC     DE
        LD      (0A10Bh),DE
        LD      HL,0A17Dh
        LD      A,(0A152h)
        CP      000h
        JR      Z,L1259
        INC     HL
L1259:  LD      (HL),001h
L125B:  LD      HL,0A185h
        LD      A,00Dh
        CP      (HL)
        JR      NZ,L1268
        LD      (HL),000h
        JP      L13C5
L1268:  LD      (HL),009h
        JP      L13C5
L126D:  LD      A,(0A111h)
        JP      L10BF
        NOP     
L1274:  LD      HL,0A17Dh
        LD      A,(0A152h)
        CP      000h
        JR      Z,L127F
        INC     HL
L127F:  LD      A,002h
        CP      (HL)
        JP      NZ,L131F
        LD      A,(0A153h)      ; Get which player is playing
        CP      000h
        JP      Z,L12FD
        LD      A,(0A152h)
        CP      000h
        LD      HL,0A149h
        JR      Z,L12A1
        XOR     A
        CP      (HL)
        JR      Z,L12FD
        INC     HL
        LD      (HL),000h
        JP      L111F
L12A1:  LD      (HL),000h
        INC     HL
        LD      A,000h
        CP      (HL)
        JP      Z,L12FD
        LD      A,001h
        LD      (0A152h),A
        JP      L111F
L12B2:  LD      B,000h
        LD      A,(0A152h)
        LD      C,A
        LD      HL,0A149h
        ADD     HL,BC
        DEC     (HL)
        SUB     A
        CP      (HL)
        JP      Z,L12ED
        LD      A,(0A153h)      ; Get which player is playing
        CP      000h
        JP      Z,L131F
        CP      C
        JP      Z,L12DE
        LD      A,(0A17Eh)
        CP      002h
        JP      Z,L131F
        LD      A,001h
        LD      (0A152h),A
        JP      L131F
L12DE:  LD      A,(0A17Dh)
        CP      002h
        JP      Z,L131F
        SUB     A
        LD      (0A152h),A
        JP      L131F
L12ED:  LD      A,(0A153h)      ; Get which player is playing
        CP      001h
        JP      NZ,L12FD
        LD      A,(0A152h)
        CP      000h
        JP      Z,L1312
L12FD:  LD      BC,(L2006)
        LD      (0A10Bh),BC
        LD      HL,0A001h
        SET     0,(HL)
        LD      A,005h
        LD      (0A185h),A
        JP      L13C5
L1312:  LD      A,001h
        LD      (0A152h),A
        XOR     A
        LD      HL,0A14Ah
        CP      (HL)
        JP      Z,L12FD
L131F:  CALL    L15F0
L1322:  LD      HL,0A001h
        BIT     0,(HL)
        JR      NZ,L1341
        LD      HL,0A17Dh
        LD      A,(0A152h)
        CP      000h
        JR      Z,L1334
        INC     HL
L1334:  LD      A,002h
        CP      (HL)
        JR      NZ,L1341
        LD      A,(0A152h)
        XOR     001h
        LD      (0A152h),A
L1341:  LD      A,(0A185h)
        CP      000h
        CALL    NZ,L195B
        JP      L13C5
L134C:  LD      A,(0A185h)
        CP      000h
        JP      Z,L13C5
        CP      001h
        JR      NZ,L1363
L1358:  CALL    L187E
        LD      A,07Dh
        LD      (0A186h),A
        JP      L13C5
L1363:  CP      009h
        JR      Z,L1358
        CP      002h
        JR      NZ,L1376
        CALL    L1775
        LD      A,07Dh
        LD      (0A186h),A
        JP      L13C5
L1376:  CP      005h
        JR      NZ,L1385
        CALL    L16C3
        LD      A,07Dh
        LD      (0A186h),A
        JP      L13C5
L1385:  CP      006h
        JR      NZ,L1394
        CALL    L1792
        LD      A,07Dh
        LD      (0A186h),A
        JP      L13C5
L1394:  CP      007h
        JR      NZ,L13A0
        CALL    L1792
        LD      A,07Dh
        LD      (0A186h),A
L13A0:  CP      00Ah
        JR      NZ,L13AC
        CALL    L01DE
        LD      A,07Dh
        LD      (0A186h),A
L13AC:  JP      L13C5
L13AF:  LD      A,(0A185h)
        CP      000h
        JP      Z,L13C5
        CP      00Bh
        JP      Z,L13C5
        CALL    L0A01
        CALL    L13FD
        JP      L1E10
L13C5:  CALL    L1A58
        POP     IY
        POP     IX
        POP     DE
        POP     BC
L13CE:  POP     HL
        POP     AF
        JP      LA102
        
        
        
        
L13D3:  LD      HL,0A001h
        LD      A,(0A153h)      ; Get which player is playing
        CP      000h
        JR      NZ,L13E1
        RES     4,(HL)
        RES     6,(HL)
L13E1:  LD      A,(0A152h)
        CP      001h
        JP      Z,L13F0
        BIT     3,(HL)
        RET     Z

        RES     3,(HL)
        JR      L13F5
L13F0:  BIT     4,(HL)
        RET     Z

        RES     4,(HL)
L13F5:  LD      HL,(L2002)      ; Get value ($0006)
        INC     HL              ; HL = $0007
        LD      (0A10Bh),HL     ; Store 7 in A10B
        RET                     ; Return
        
        
        
        
;----------------------------------------------------
;      SEARCH to Frame from Scene data (index $A10B)
;----------------------------------------------------
L13FD:  LD      HL,(0A10Bh)     ; Index to frame table (32 bytes per)
        DEC     HL              ; Start at 0
        ADD     HL,HL           ; multiply by 2
        ADD     HL,HL           ; multiply by 4
        ADD     HL,HL           ; multiply by 8
        ADD     HL,HL           ; multiply by 16
        ADD     HL,HL           ; multiply by 32
        LD      DE,L2088        ; Start of Scene Data
        ADD     HL,DE           ; Index to proper scene
;----------------------------------------------------
;       SEARCH to Frame Number from Scene Data
;----------------------------------------------------        
        LD      E,(HL)          ; Get lower-nibble of Frame Number
        INC     HL              ; Go to next byte in data
        LD      D,(HL)          ; Get upper-nibble of Frame Number
        LD      (0A10Fh),DE     ; Save Frame Number in holding area
;----------------------------------------------------
;   Indicate new search started and SEARCH to frame
;----------------------------------------------------        
        LD      HL,0A001h       ;
        BIT     2,(HL)          ;
        JR      Z,L141B         ;
        CALL    L0EB7           ; SEARCH to Frame Number in $A10F
L141B:  RET                     ; Return




;----------------------------------------------------
;                unknown data
;----------------------------------------------------
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00110h
        INC     C
        LD      BC,00101h
        ADD     HL,DE
        LD      BC,00105h
        LD      (DE),A
        NOP     
        NOP     
        LD      BC,L0026
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00110h
        INC     C
        LD      BC,00101h
        ADD     HL,DE
        LD      BC,00105h
        LD      (DE),A
        NOP     
        NOP     
        LD      BC,00027h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        DEC     DE
        INC     E
        DEC     E
        LD      E,01Fh
        JR      NZ,L1484
        LD      (02423h),HL
        DEC     H
        LD      H,027h
        JR      Z,L1494
        LD      HL,(02C2Bh)
        DEC     L
        LD      L,000h
        

;----------------------------------------------------
;            Odd characters %&'()*+,-.
;----------------------------------------------------        
L1466:  .BYTE $25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E

        .BYTE $00,$00,$00,$00,$00,$00
        
        
        

;----------------------------------------------------
;                unknown data
;----------------------------------------------------        
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,0010Ch
        DEC     B
        LD      BC,00106h
        INC     D
        NOP     
        NOP     
        LD      BC,00113h
        INC     C
L1484:  LD      BC,0010Fh
        INC     D
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
L1494:  LD      BC,00112h
        ADD     HL,BC
        LD      BC,00107h
        EX      AF,AF'
        LD      BC,00014h
        NOP     
        LD      BC,00113h
        INC     C
        LD      BC,0010Fh
        INC     D
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        RRCA    
        LD      BC,L0109
        LD      C,001h
        INC     DE
        NOP     
        NOP     
        LD      BC,00048h
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        LD      BC,00013h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        LD      BC,00013h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00108h
        ADD     HL,BC
        LD      BC,00107h
        EX      AF,AF'
        NOP     
        NOP     
        LD      BC,00113h
        INC     BC
        LD      BC,0010Fh
        LD      (DE),A
        LD      BC,00005h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,0010Ch
        LD      BC,01301h
        LD      BC,00014h
        NOP     
        LD      BC,00113h
        INC     BC
        LD      BC,0010Fh
        LD      (DE),A
        LD      BC,00005h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        RRCA    
        LD      BC,L0109
        LD      C,000h
        NOP     
        LD      BC,00048h
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        LD      BC,00013h
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        RRCA    
        LD      BC,L0109
        LD      C,001h
        INC     DE
        NOP     
        NOP     
L1510:  .BYTE $01,$0C,$01,$01,$01,$13,$01,$14
        .BYTE $00,$00,$01,$13,$01,$03,$01,$0F
        .BYTE $01,$12,$01,$05,$00
        
        LD      BC,00048h
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00103h
        RRCA    
        LD      BC,L0109
        LD      C,000h
        NOP     
        LD      BC,00048h
        NOP     
        LD      BC,00103h
        LD      (DE),A
        LD      BC,00105h
        INC     B
        LD      BC,L0109
        INC     D
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00150h
        LD      D,D
        LD      BC,00154h
        LD      D,(HL)
        LD      BC,00158h
        LD      E,D
        LD      BC,00162h
        LD      E,H
        NOP     
        NOP     
        LD      BC,0015Eh
        LD      D,H
        LD      BC,L0160
        LD      D,D
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00151h
        LD      D,E
        LD      BC,00155h
        LD      D,A
        LD      BC,00159h
        LD      E,E
        NOP     
        NOP     
        LD      BC,0005Dh
        NOP     
        LD      BC,0015Fh
        LD      D,L
        LD      BC,00161h
        LD      D,E
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      BC,00110h
        INC     C
        LD      BC,00105h
        LD      BC,01301h
        LD      BC,00005h
        NOP     
        LD      BC,00113h
        INC     D
        LD      BC,00101h
        LD      C,001h
        INC     B
        LD      BC,00102h
        ADD     HL,DE
        NOP     
        NOP     


;----------------------------------------------------
;                 Get frame number
;----------------------------------------------------
L15F0:  LD      DE,(0A152h)     ;
        LD      D,000h          ;
        LD      HL,0A142h       ; E * 4 + 2
        ADD     HL,DE           ;
        ADD     HL,DE           ;
        ADD     HL,DE           ;
        INC     HL              ;
        INC     HL              ;
        LD      A,(HL)          ;
        LD      BC,(0A113h)     ;
        ADD     A,C             ;
        DAA                     ;
        LD      (HL),A          ;
        DEC     HL              ;
        LD      A,(HL)          ;
        ADC     A,B             ;
        DAA                     ;
        LD      (HL),A
        DEC     HL              ;
        LD      A,000h          ;
        ADC     A,(HL)          ;
        DAA                     ;
        LD      (HL),A          ;
        RET                     ; Return



;----------------------------------------------------
;                 
;----------------------------------------------------
        LD      HL,0E018h       ;
        LD      IX,0A17Fh       ;
        CALL    L1623           ;
        CALL    L1623           ;
        CALL    L1623           ;
        RET                     ;



;----------------------------------------------------
;                  Erase LED Display
;----------------------------------------------------
L1623:  LD      A,(IX+000h)     ;
        AND     0F0h            ;
        SRL     A               ;
        SRL     A               ;
        SRL     A               ;
        SRL     A               ;
        LD      (HL),A          ;
        INC     HL              ;
        LD      A,(IX+000h)     ;
        AND     00Fh            ;
        LD      (HL),A          ;
        INC     HL              ;
        INC     IX              ;
        RET                     ; Return
                                
                                
;----------------------------------------------------
;                               
;----------------------------------------------------
;     IX = Text to print
;     HL = Screen location to print
;----------------------------------------------------
L163C:  LD      E,010h          ; 16 characters to print
L163E:  LD      A,(IX+001h)     ; Get color code?
        LD      (HL),A          ;
        INC     HL              ;
        LD      A,(IX+000h)     ;
        LD      (HL),A          ;
        INC     HL              ;
        DEC     E               ;
        SUB     A               ;
        CP      E               ;
        INC     IX              ;
        INC     IX              ;
        JP      NZ,L163E        ;
        RET                     ; Return
;----------------------------------------------------
;               Print to Screen (overlay)
;----------------------------------------------------
;      E = Number of bytes to print
;     IX = Score
;     HL = Screen location
;----------------------------------------------------
L1653:  LD      A,(IX+000h)     ; Get first character to print (upper nibble)
        AND     0F0h            ; Isolate Upper nibble
        SRL     A               ; Shift nibble to lower position
        SRL     A               ; Shift nibble to lower position
        SRL     A               ; Shift nibble to lower position
        SRL     A               ; Shift nibble to lower position
        LD      C,A             ; C = Upper nibble
        CALL    L16BB           ; Set marker if char = 0
        LD      A,C             ; Get Upper nibble
        CP      000h            ; Is upper nibble zero?
        JP      NZ,L1672        ; No, so skip ahead
        LD      A,(0A179h)      ; Get first upper nibble
        CP      001h            ; Are we printing a '1'?
        JP      Z,L1679         ; Yes, so skip font change
;----------------------------------------------------
;               Index to Odd character
;----------------------------------------------------        
L1672:  LD      B,000h          ; Clear index
        ADD     IY,BC           ; Index to odd character
        LD      C,(IY+000h)     ; Get Odd character instead
;----------------------------------------------------
;             Print character and color
;----------------------------------------------------        
L1679:  LD      (HL),C          ; Print character to screen
        INC     HL              ; Move down one
        LD      (HL),D          ; Print color to screen
        INC     HL              ; Move down one
;----------------------------------------------------
;     Get second character (lower nibble byte 1)
;----------------------------------------------------        
L167D:  LD      IY,L1466        ;
        LD      A,(IX+000h)     ;
        AND     00Fh            ; Get 2nd character to print (lower nibble)
        LD      C,A             ;
        LD      A,001h          ;
        CP      E               ; Is this the last character to print?
        JP      NZ,L1692        ;
        LD      A,000h          ;
        LD      (0A179h),A      ;
L1692:  CALL    L16BB           ;
        LD      A,C             ;
        CP      000h            ;
        JP      NZ,L16A3        ;
        LD      A,(0A179h)      ;
        CP      001h            ;
        JP      Z,L16AA         ;
        ADD     IY,BC
L16AA:  LD      (HL),C
        LD      (HL),D
        INC     IX
        DEC     E
        CP      E
        RET     



;----------------------------------------------------
;       If char not zero, clear flag at A179
;----------------------------------------------------
;   C = character (nibble)
;----------------------------------------------------
L16BB:  LD      A,000h          ; Flag = 0
        CP      C               ; Is character a zero?
        RET     Z               ; Yes, so leave.
        LD      (0A179h),A      ; Clear flag if character not zero
        RET                     ; Return




;----------------------------------------------------
;
;----------------------------------------------------
L16C3:  CALL    L19C4
        LD      A,(0A153h)      ; Get which player is playing
        CP      000h
        JP      NZ,L170F
        LD      IX,L14F0
        LD      HL,0C0C7h
        CALL    L163C           ; Print number to screen
        LD      IX,L1510        ; Message to print??
        LD      HL,0C187h
        CALL    L163C
        LD      A,001h
        LD      (0A179h),A
;----------------------------------------------------
;
;----------------------------------------------------        
        LD      E,003h          ; 3 numbers to print
        LD      D,007h          ; Color = YELLOW
        LD      IY,01466h       ;
        LD      IX,0A182h       ;
        LD      HL,0C111h       ;
        CALL    L1653           ;
;----------------------------------------------------
;
;----------------------------------------------------        
        LD      A,001h          ;
        LD      (0A179h),A      ;
;----------------------------------------------------
;
;----------------------------------------------------        
        LD      E,003h          ; 3 numbers to print
        LD      IY,01466h       ;
        LD      IX,0A142h       ; IX = Player2 Score
        LD      HL,0C1D1h       ; HL = Screen location
        CALL    L1653           ; Print Player2 Score
        RET                     ; Return


;----------------------------------------------------
;                Print Player2 stats
;----------------------------------------------------
L170F:  LD      IX,L14F0        ;
        LD      HL,0C087h       ;
        CALL    L163C           ; Print number to screen
        LD      IX,L1510        ;
        LD      HL,0C147h       ;
        CALL    L163C           ; Print number to screen
        LD      HL,0C18Bh       ;
        LD      (HL),026h       ; char '&'
        INC     HL              ;
        LD      (HL),001h       ;
        LD      HL,0C1CBh       ;
        LD      (HL),027h       ;
        INC     HL              ;
        LD      (HL),001h       ;
        LD      A,001h          ;
        LD      (0A179h),A      ;
        LD      E,003h          ;
        LD      D,007h          ; Color = YELLOW
        LD      IY,01466h       ;
        LD      IX,0A182h       ;
        LD      HL,0C0D1h       ;
        CALL    L1653
        LD      A,001h
        LD      (0A179h),A
        LD      E,003h
        LD      IY,01466h
        LD      IX,0A142h
        LD      HL,0C191h
        CALL    L1653
        LD      A,001h
        LD      (0A179h),A
        LD      E,003h
        LD      IY,01466h
        LD      IX,0A145h
        LD      HL,0C1D1h
        CALL    L1653
        RET     

L1775:  LD      A,(0A152h)
        CP      000h
        JR      NZ,L1787
        LD      IX,0141Ch
        LD      HL,0C147h
        CALL    L163C
        RET     

L1787:  LD      IX,0143Ch
        LD      HL,0C147h
        CALL    L163C
        RET     

L1792:  LD      A,(0A14Eh)
        LD      C,A
        LD      A,(0A14Fh)
        CP      C
        JR      Z,L17A5
        LD      A,(0A185h)
        CP      006h
        JR      Z,L17C7
        JR      L17DE
L17A5:  LD      A,(0A14Ch)
        LD      C,A
        LD      A,(0A14Dh)
        CP      C
        JR      Z,L17B8
        LD      A,(0A185h)
        CP      006h
        JR      Z,L17C7
        JR      L17DE
L17B8:  JR      L17BA
L17BA:  LD      BC,0A14Eh
        LD      DE,0A14Ch
        CALL    L17F5
        CALL    L1826
        RET     

L17C7:  LD      IX,01470h
        LD      HL,0C087h
        CALL    L163C
        LD      BC,0A14Eh
        LD      DE,0A14Ch
        CALL    L17F5
        CALL    L1826
        RET     

L17DE:  LD      IX,01490h
        LD      HL,0C087h
        CALL    L163C
        LD      BC,0A14Fh
        LD      DE,0A14Dh
        CALL    L17F5
        CALL    L1841
        RET     

L17F5:  LD      IX,014B0h
        LD      A,(BC)
        CP      001h
        JR      NZ,L1805
        LD      A,(DE)
        CP      001h
        JR      Z,L1818
        JR      L180C
L1805:  LD      A,(DE)
        CP      001h
        JR      Z,L1812
        JR      L181C
L180C:  LD      IX,01530h
        JR      L181C
L1812:  LD      IX,01550h
        JR      L181C
L1818:  LD      IX,01570h
L181C:  LD      HL,0C147h
        CALL    L163C
        CALL    L185C
        RET     

L1826:  LD      D,007h
        LD      E,001h
        LD      IX,0A14Eh
        LD      HL,0C10Dh
        CALL    L167D
        LD      E,001h
        LD      IX,0A14Ch
        LD      HL,0C11Dh
        CALL    L167D
        RET     

L1841:  LD      D,007h
        LD      E,001h
        LD      IX,0A14Fh
        LD      HL,0C10Dh
        CALL    L167D
        LD      E,001h
        LD      IX,0A14Dh
        LD      HL,0C11Dh
        CALL    L167D
        RET     

L185C:  LD      IX,014D0h
        LD      HL,0C207h
        CALL    L163C
        LD      A,001h
        LD      (0A179h),A
        LD      E,001h
        LD      D,007h          ; Color = YELLOW
        LD      IY,01466h
        LD      IX,0A14Bh
        LD      HL,0C21Dh
        CALL    L1653
        RET     

L187E:  LD      A,(0A153h)      ; Get which player is playing
        CP      000h
        JP      NZ,L188A
        CALL    L18DC
        RET     

L188A:  LD      D,001h
        LD      HL,0C08Bh
        LD      A,04Ah
        LD      (HL),A
        INC     HL
        LD      (HL),D
        LD      HL,0C0CBh
        LD      A,04Bh
        LD      (HL),A
        INC     HL
        LD      (HL),D
        LD      HL,0C14Bh
        LD      A,04Ch
        LD      (HL),A
        INC     HL
        LD      (HL),D
        LD      HL,0C18Bh
        LD      A,04Dh
        LD      (HL),A
        INC     HL
        LD      (HL),D
        LD      E,003h
        LD      A,001h
        LD      (0A179h),A
        LD      D,007h
        LD      IY,L1466
        LD      HL,0C091h
        LD      IX,0A142h
        CALL    L1653
        LD      E,003h
        LD      A,001h
        LD      (0A179h),A
        LD      IY,01466h
        LD      HL,0C151h
        LD      IX,0A145h
        CALL    L1653
        CALL    L1909
        RET     

L18DC:  LD      D,001h
        LD      HL,0C0CBh
        LD      A,04Ah
        LD      (HL),A
        INC     HL
        LD      (HL),D
        LD      HL,0C10Bh
        LD      A,04Bh
        LD      (HL),A
        INC     HL
        LD      (HL),D
        LD      E,003h
        LD      A,001h
        LD      (0A179h),A
        LD      D,007h
        LD      IY,01466h
        LD      HL,0C0D1h
        LD      IX,0A142h
        CALL    L1653
        CALL    L192C
        RET     

L1909:  LD      D,001h
        LD      C,049h
        LD      HL,0C0D3h
        CALL    L1940
        LD      HL,0C0D3h
        LD      A,(0A149h)
        CALL    L194D
        LD      HL,0C193h
        CALL    L1940
        LD      HL,0C193h
        LD      A,(0A14Ah)
        CALL    L194D
        RET     

L192C:  LD      D,001h
        LD      C,049h
        LD      HL,0C153h
        CALL    L1940
        LD      HL,0C153h
        LD      A,(0A149h)
        CALL    L194D
        RET     

L1940:  LD      A,005h
L1942:  LD      (HL),C
        INC     HL
        LD      (HL),D
        INC     HL
        DEC     A
        CP      000h
        JP      NZ,L1942
        RET     

L194D:  LD      E,005h
        CP      E
        RET     Z

L1951:  LD      (HL),000h
        DEC     E
        CP      E
        RET     Z

        INC     HL
        INC     HL
        JP      L1951
L195B:  LD      HL,0C043h
        LD      DE,0C044h
        LD      (HL),000h
        LD      BC,00025h
        LDIR    
        LD      HL,0C083h
        LD      DE,0C084h
        LD      BC,00025h
        LD      (HL),000h
        LDIR    
        LD      HL,0C0C3h
        LD      DE,0C0C4h
        LD      BC,00025h
        LD      (HL),000h
        LDIR    
        LD      HL,0C103h
        LD      DE,0C104h
        LD      BC,00025h
        LD      (HL),000h
        LDIR    
        LD      HL,0C143h
        LD      DE,0C144h
        LD      BC,00025h
        LD      (HL),000h
        LDIR    
        LD      HL,0C183h
        LD      DE,0C184h
        LD      BC,00025h
        LD      (HL),000h
        LDIR    
        LD      HL,0C1C3h
        LD      DE,0C1C4h
        LD      BC,00025h
        LD      (HL),000h
        LDIR    
        LD      HL,0C203h
        LD      DE,0C204h
        LD      BC,00025h
        LD      (HL),000h
        LDIR    
        RET     




;----------------------------------------------------
;  Player1 High score?  Move A142-A144 to A18A-A18C
;----------------------------------------------------
L19C4:  LD      HL,0A18Ah       ; HL = High Score 
        LD      A,(0A142h)      ; Get
        LD      (HL),A          ;
        INC     HL              ;
        LD      A,(0A143h)      ;
        LD      (HL),A          ;
        INC     HL              ;
        LD      A,(0A144h)      ;
        LD      (HL),A          ;
;----------------------------------------------------
;
;----------------------------------------------------        
        LD      A,(0A153h)      ; Get which player is playing
        CP      001h            ;
        JP      NZ,L1A1E        ;
        LD      A,(0A145h)      ;
        LD      C,A             ;
        LD      A,(0A142h)      ;
        CP      C               ;
        JP      M,L1A0D         ;
        JP      Z,L19EE         ;
        JP      P,L1A1E         ;
L19EE:  LD      A,(0A146h)      ;
        LD      C,A             ;
        LD      A,(0A143h)      ;
        CP      C               ;
        JP      M,L1A0D         ;
        JP      Z,L19FF         ;
        JP      P,L1A1E         ;
L19FF:  LD      A,(0A147h)      ;
        LD      C,A             ;
        LD      A,(0A144h)      ;
        CP      C               ;
        JP      Z,L1A1E         ;
        JP      P,L1A1E         ;
L1A0D:  LD      HL,0A18Ah
        LD      A,(0A145h)
        LD      (HL),A
        INC     HL
        LD      A,(0A146h)
        LD      (HL),A
        INC     HL
        LD      A,(0A147h)
        LD      (HL),A
L1A1E:  LD      A,(0A18Ah)
        LD      C,A
        LD      A,(0A182h)
        CP      C
        JP      M,L1A46
        JP      Z,L1A2D
        RET     P

L1A2D:  LD      A,(0A18Bh)
        LD      C,A
        LD      A,(0A183h)
        CP      C
        JP      M,L1A46
        JP      Z,L1A3C
        RET     P

L1A3C:  LD      A,(0A18Ch)
        LD      C,A
        LD      A,(0A184h)
        CP      C
        RET     Z

        RET     P

L1A46:  LD      HL,0A182h
        LD      A,(0A18Ah)
        LD      (HL),A
        INC     HL
        LD      A,(0A18Bh)
        LD      (HL),A
        INC     HL
        LD      A,(0A18Ch)
        LD      (HL),A
        RET     

L1A58:  LD      A,(0A16Dh)
        BIT     0,A
        RET     Z

        LD      HL,0A187h
        XOR     A
        CP      (HL)
        JR      Z,L1A75
        LD      A,003h
        CP      (HL)
        JR      NZ,L1A6E
        LD      A,063h
        OUT     (000h),A
L1A6E:  DEC     (HL)
        RET     NZ

        XOR     A
        LD      (0A16Dh),A
        RET     

L1A75:  LD      HL,0A16Ch
        CP      (HL)
        RET     Z

        DEC     (HL)
        CP      (HL)
        CALL    Z,L1A80
        RET     

L1A80:  LD      A,063h
        OUT     (000h),A
        LD      HL,0A16Dh
        RES     0,(HL)
        RES     5,(HL)
        RET     

L1A8C:  PUSH    HL
        LD      HL,0A16Dh
        BIT     5,(HL)
        SET     5,(HL)
        JR      NZ,L1AA8
        LD      A,027h
        OUT     (000h),A
        LD      A,06Eh
        OUT     (000h),A
        LD      A,008h
        LD      (0A187h),A
        LD      HL,0A16Dh
        SET     0,(HL)
L1AA8:  POP     HL
        RET     

L1AAA:  LD      HL,0A16Dh
        BIT     4,(HL)
        SET     4,(HL)
        RET     NZ

        LD      A,027h
        OUT     (000h),A
        LD      A,01Eh
        OUT     (000h),A
        LD      A,005h
        LD      (0A16Ch),A
        LD      HL,0A16Dh
        SET     0,(HL)
        RET     

L1AC5:  PUSH    AF
        LD      A,027h
        OUT     (000h),A
        LD      A,023h
        OUT     (000h),A
        LD      A,005h
        LD      (0A16Ch),A
        LD      HL,0A16Dh
        SET     0,(HL)
        POP     AF
        RET     



;----------------------------------------------------
;                  coin
;----------------------------------------------------
L1ADA:  PUSH    AF
        LD      A,027h
        OUT     (000h),A
        LD      A,014h
        OUT     (000h),A
        LD      A,004h
        LD      (0A16Ch),A
        LD      HL,0A16Dh
        SET     0,(HL)
        POP     AF
        RET     

L1AEF:  LD      A,027h
        OUT     (000h),A
        LD      A,00Fh
        OUT     (000h),A
        LD      A,003h
        LD      (0A16Ch),A
        LD      HL,0A16Dh
        SET     0,(HL)
        RET     


;----------------------------------------------------
;                  Perform RAM Test
;----------------------------------------------------
L1B02:  LD      IX,L1B3E        ; IX = Start of data
L1B06:  LD      HL,0A000h       ; Start of RAM to fill
        LD      A,(IX+000h)     ; Get test byte from table
        CP      011h            ; Is this the last byte?
        JR      Z,L1B53         ; Yes, so exit test
;----------------------------------------------------
;        Fill $A000-$A800 with byte from table
;----------------------------------------------------        
L1B10:  LD      (0E030h),A      ; Reset watchdog
        LD      (HL),A          ; Fill RAM with byte
        INC     HL              ; Go to next RAM location
        LD      DE,0A800h       ; DE = Last RAM address to fill
        EX      DE,HL           ; Check for last address
        SCF                     ; Set carry
        CCF                     ; Clear carry
        SBC     HL,DE           ; Has RAM address reached $A800?
        EX      DE,HL           ; Return pointer to address
        JR      NZ,L1B10        ; No, so conintue fill
;----------------------------------------------------
;       Verify all RAM contents $A000-$A800         
;----------------------------------------------------
        LD      HL,0A000h       ; HL = Start of RAM to verify
        LD      BC,00800h       ; $800 bytes to check
L1B26:  LD      (0E030h),A      ; Reset watchdog in loop
        CPI                     ; Compare all RAM locations
L1B2B:  JR      NZ,L1B34        ; RAM location bad, print error
        JP      PE,L1B26        ; Continue all verify
        INC     IX              ; Point to next byte in table
        JR      L1B06           ; Loop back to RAM Fill
;----------------------------------------------------
;           Test failed, Print error $B0
;----------------------------------------------------
L1B34:  LD      A,0B0h          ; $B0 = Error code
        LD      (0E000h),A      ; Print Error code
L1B39:  LD      (0E030h),A      ; Reset watchdog
        JR      L1B39           ; Loop here forever
    

;----------------------------------------------------
;                  RAM Test bytes
;----------------------------------------------------
L1B3E:  .BYTE $FF,$01,$FE,$02,$04,$FB,$08,$F7,$10 
        .BYTE $F0,$20,$E0,$40,$BF,$80,$7F,$55,$AA      

        .BYTE $11  ; Last byte marker
        
;----------------------------------------------------
;                   
;----------------------------------------------------        
        .BYTE $21
        .BYTE $00

;----------------------------------------------------
;            Fill RAM with $00-$FF pattern
;----------------------------------------------------
L1B53:  AND     B               ; carry control
        LD      A,000h          ; A = 0 (loop thru 255)
L1B58:  LD      (0E030h),A      ; Reset watchdog
        LD      (HL),A          ; Erase RAM
        INC     A               ; Increment RAM test byte
        INC     HL              ; Go to next RAM location
        LD      DE,0A800h       ; DE = Last RAM address
        EX      DE,HL           ; Swap registers
        SCF                     ; Set carry
        CCF                     ; Clear carry
        SBC     HL,DE           ; Are we at last RAM address $A800?
        EX      DE,HL           ; Swap registers back
        JR      NZ,L1B58        ; Not at end, so loop back
;----------------------------------------------------
;            Verify RAM locations    
;----------------------------------------------------        
        LD      HL,0A000h       ; HL = Start of RAM
        LD      BC,00800h       ; $800 bytes to verify
        LD      A,0FFh          ; A = $FF
L1B71:  LD      (0E030h),A      ; Reset watchdog
        INC     A               ; Increment test compare byte
        CPI                     ; Compare RAM location
        JR      NZ,L1B7F        ; No match, so print error
        JP      PO,L1B71        ; Continue with testing next RAM location
        JP      L08D1           ; RAM test passed, start game
;----------------------------------------------------
;           Test failed, Print error $B0
;----------------------------------------------------        
L1B7F:  LD      A,0B0h          ; $B0 = Error code
        LD      (0E000h),A      ; Print Error code
L1B84:  LD      (0E030h),A      ; Reset watchdog
        JR      L1B84           ; Loop here forever
      
        
;----------------------------------------------------
;                   unknown
;----------------------------------------------------        
        .BYTE   $DA,$48



;----------------------------------------------------
;          Do Checksum Test $0000-$7FFF
;----------------------------------------------------
L1B8B:  LD      DE,00000h       ; Checksum total = 0000
        LD      HL,07FFFh       ; Start of ROM address for checksum
L1B91:  LD      (0E030h),A      ; Reset Watchdog during checksum calculation
        LD      C,(HL)          ; Get a ROM byte
        DEC     HL              ; Go to previous ROM address
        LD      B,(HL)          ; Get another ROM byte
        EX      DE,HL           ; Move Checksum total to HL for addition
        ADD     HL,BC           ; Add bytes to checksum total
        EX      DE,HL           ; Put checksum total back into DE
        SCF                     ; Set carry
        CCF                     ; Clear carry
        LD      BC,00000h       ; BC = last address to check
        SBC     HL,BC           ; Has our loop reached the last address?
        DEC     HL              ; Loop to next ROM byte
        JR      NZ,L1B91        ; Continue until all bytes checked
;----------------------------------------------------
;              Test if Checksum is correct
;----------------------------------------------------        
        EX      DE,HL           ; Move Checksum total to HL
        SCF                     ; Set carry
        CCF                     ; Clear carry
        SBC     HL,BC           ; Checksum total should be zero!
        JP      Z,L08CB         ; Passed test, so skip ahead
;----------------------------------------------------
;    Checksum Test Failed, Print error $A4
;----------------------------------------------------
        LD      A,0A4h          ; Error code = $A4
        LD      (0E000h),A      ; Print Error code
        LD      (0E030h),A      ; Reset watchdog
        JP      L08CB           ; Continue to next test



;----------------------------------------------------
;               
;----------------------------------------------------
L1BB7:  CALL    L1BBD           ;
        JP      L0765           ;



;----------------------------------------------------
;                  Fill A300, Print?
;----------------------------------------------------
L1BBD:  LD      HL,L10EF        ;
        LD      BC,0001Ch       ;
        LD      DE,0A300h       ;
        PUSH    BC              ;
        PUSH    HL              ;
        LDIR                    ;
        POP     HL              ;
        POP     BC              ;
        LD      DE,0A320h       ;
        LDIR                    ;
        LD      BC,00011h       ;
        LD      HL,0110Bh       ;
        LD      DE,0A340h       ;
        PUSH    BC              ;
        PUSH    HL              ;
        LDIR                    ;
        POP     DE              ;
        POP     BC              ;
        LD      B,C             ;
        LD      HL,0A360h       ;
L1BE4:  LD      A,(DE)          ;
        ADD     A,020h          ;
        LD      (HL),A          ;
        INC     HL              ;
        INC     DE              ;
        DJNZ    L1BE4           ;
        RET                     ; Return



;----------------------------------------------------
;     Reset Game Variables (score = 00000)
;----------------------------------------------------
L1BED:  LD      IX,0A002h
        LD      IY,0A340h
        CALL    L1C07
        LD      IX,0A082h
        LD      IY,0A360h
        CALL    L1C07
        LD      BC,00000h       ; Reset score to zero
        RET                     ; Return



;----------------------------------------------------
;     
;----------------------------------------------------
;    IX = ?
;    IY = ?
;----------------------------------------------------
L1C07:  LD      B,011h          ;
L1C09:  LD      D,0A3h          ;
        CALL    L1C6E           ;
        BIT     7,E             ;
        RES     7,E
        JR      Z,L1C1D
        CALL    L10D3
        BIT     0,A
        JR      Z,L1C1D
        INC     E
        INC     E
L1C1D:  NOP     
        LD      HL,00E06h
        ADD     HL,DE
        LD      A,(HL)
        LD      (IX+000h),A
        INC     HL
        LD      A,(HL)
        LD      (IX+001h),A
        INC     IX
        INC     IX
        INC     IY
        DJNZ    L1C09
        RET     

L1C34:  LD      H,0A3h
        LD      D,H
        LD      IX,00DEDh
        LD      IY,00DFAh
L1C3F:  LD      A,(IX+000h)
        LD      E,A
        CP      0FFh
        JR      Z,L1C5E
L1C47:  CALL    L10D3
        AND     00Fh
        CP      (IY+000h)
        JR      NC,L1C47
        ADD     A,E
        LD      L,A
        LD      A,(DE)
        LD      B,(HL)
        LD      (HL),A
        EX      DE,HL
        LD      (HL),B
        INC     IX
        INC     IY
        JR      L1C3F
L1C5E:  JP      L1C76
L1C61:  LD      HL,0A002h
        LD      (0A13Ah),HL
        LD      HL,0A09Ah
        LD      (0A140h),HL
        RET     

L1C6E:  LD      E,(IY+000h)
        LD      A,(DE)
        LD      E,A
        LD      D,000h
        RET     

L1C76:  LD      H,0A3h
        LD      IX,00DEDh
        LD      IY,00DFAh
        LD      DE,01CA7h
L1C83:  LD      L,(IX+000h)
        LD      A,(HL)
        LD      B,(IY+000h)
        DEC     B
L1C8B:  INC     HL
        XOR     (HL)
        DJNZ    L1C8B
        LD      B,A
        LD      A,(DE)
        CP      B
        JR      NZ,L1CA1
        INC     IX
        INC     IY
        INC     DE
        LD      A,(DE)
        CP      0FFh
        JR      NZ,L1C83
        JP      L0A44
L1CA1:  CALL    L1BBD
        JP      L1C34
        NOP     
        LD      (BC),A
        INC     L
        LD      A,000h
        LD      (BC),A
        INC     L
        LD      A,016h
        LD      A,(BC)
        LD      D,02Ah
        RST     38h
L1CB4:  LD      IX,0A203h
        LD      HL,01D04h
        LD      A,(0A112h)
        LD      (IX+002h),000h
        PUSH    HL
        RLCA    
        RLCA    
        RLCA    
        RLCA    
        AND     00Fh
        JR      NZ,L1CCF
        LD      (IX+002h),001h
L1CCF:  ADD     A,L
        JR      NC,L1CD3
        INC     H
L1CD3:  LD      L,A
        LD      A,07Fh
        OR      (IX+001h)
        BIT     0,(IX+002h)
        JR      NZ,L1CE0
        AND     (HL)
L1CE0:  LD      (IX+001h),A
        POP     HL
        LD      A,(0A112h)
        AND     00Fh
        JR      Z,L1CEF
        RES     0,(IX+002h)
L1CEF:  ADD     A,L
        JR      NC,L1CF3
        INC     H
L1CF3:  LD      L,A
        LD      A,07Fh
        OR      (IX+000h)
        BIT     0,(IX+002h)
        JR      NZ,L1D00
        AND     (HL)
L1D00:  LD      (IX+000h),A
        RET     

        RET     NZ

        LD      SP,HL
        AND     H
        OR      B
        SBC     A,C
        SUB     D
        ADD     A,D
        RET     M

        ADD     A,B
        SUB     B
        ADC     A,B
        ADD     A,E
        AND     A
        AND     C
        ADD     A,(HL)
        ADC     A,(HL)



;----------------------------------------------------
;            Special Frame Check ($2245)
;----------------------------------------------------
L1D14:  LD      HL,(0A10Fh)
        LD      A,L
        CP      045h
        JR      NZ,L1D28
        LD      A,H
        CP      022h
        JR      NZ,L1D28
        LD      HL,000B0h
        LD      (0A12Dh),HL
        RET     



;----------------------------------------------------
;            Special Frame Check ($45DC)
;----------------------------------------------------
L1D28:  LD      A,H
        CP      045h
        JR      NZ,L1D3C
        LD      A,L
        CP      0DCh
        JR      Z,L1D36
        CP      0F4h
        JR      NZ,L1D3C
L1D36:  LD      HL,002FCh
        LD      (0A12Dh),HL
L1D3C:  LD      HL,(0A12Dh)
        RET     



;----------------------------------------------------
;                   Initialize
;----------------------------------------------------
L1D40:  LD      A,001h
        OUT     (001h),A
        OUT     (003h),A
        LD      A,0FFh
        LD      (0E000h),A
        LD      (0E008h),A
        CALL    L0A11
        CALL    L1E02           ; Delay routine
        LD      IX,0A12Fh       ; Outgoing Command buffer
L1D58:  LD      A,031h          ; char = '1'
;----------------------------------------------------
;             
;----------------------------------------------------
L1D5A:  LD      (IX+001h),A     ; 
        LD      (IX+000h),044h  ; char = 'D'
        LD      (IX+002h),00Dh  ; char = <carriage return>
        JR      L1D6E           ;
        
        
        
;----------------------------------------------------
;    Set Single Byte followed by Carriage RETURN  
;----------------------------------------------------        
L1D67:  LD      (IX+000h),A     ;
        LD      (IX+001h),00Dh  ;             
;----------------------------------------------------
;              Process USART Control
;----------------------------------------------------        
L1D6E:  CALL    L1DF4           ;
        CALL    L1E02           ; Delay routine
L1D74:  LD      (0E030h),A      ; Reset Watchdog
        LD      HL,0E080h       ; HL = USART Control Input
        BIT     0,(HL)          ; 
        JR      Z,L1DA9         ; Enter Special Engineering Mode?
        BIT     1,(HL)          ;
        JR      Z,L1DA9         ; Enter Special Engineering Mode?
        LD      A,055h          ;
        BIT     2,(HL)          ;
        JR      Z,L1D67         ;
        LD      A,056h          ;
        BIT     3,(HL)          ;
        JR      Z,L1D67         ;
        BIT     4,(HL)          ;
        JR      Z,L1D58         ;
;----------------------------------------------------
;
;----------------------------------------------------
        LD      HL,0E088h       ; 
        LD      A,04Ch          ; char = 'L'
        BIT     0,(HL)          ;
        JR      Z,L1D67         ;
        LD      A,04Dh          ; char = 'M'
        BIT     1,(HL)          ;
        JR      Z,L1D67         ;
        LD      A,030h          ; char = '0' zero
        BIT     2,(HL)          ;
        JR      Z,L1D5A         ;
        JR      L1D74           ; Wait until communication cycle completes
                                
           
                                
;----------------------------------------------------
;         Create Serial Message for LDPlayer
;----------------------------------------------------        
;     FxxxxxR or FxxxxxN sent serially to player
;----------------------------------------------------
L1DA9:  LD      (IX+000h),046h  ; First Character in Command ('F')
        LD      A,052h          ; Last Character in Command ('R')
        BIT     0,(HL)          ;
        JR      NZ,L1DB5        ;
        LD      A,04Eh          ; Last Character in Command ('N')
L1DB5:  LD      (IX+006h),A     ; Set last character 'R' or 'N'
        LD      (IX+007h),00Dh  ; Conclude with Carriage RETURN
;----------------------------------------------------        
;              Special Engineering Mode
;----------------------------------------------------        
        LD      A,(0E090h)      ; Read DIP Switch A
        LD      (0A10Fh),A      ; Use DIP A for Frame number
        LD      A,(0E098h)      ; Read DIP Switch B
        RES     7,A             ; Ignore upper B7 DIP switch
        LD      (0A110h),A      ; Use DIP B for Frame number
;----------------------------------------------------        
;                
;----------------------------------------------------        
        LD      HL,0E000h       ;
        RES     7,(HL)          ;
;----------------------------------------------------        
;     Set Frame Number in serial command to 00000
;----------------------------------------------------        
        PUSH    IX              ; Save pointer to serial command
        LD      B,005h          ; 5 numbers in Frame Number
L1DD3:  LD      (IX+001h),000h  ; Clear out Frame Number 00000
        INC     IX              ; Go to next number
        DJNZ    L1DD3           ; Loop until Frame Number cleared
        POP     IX              ; Recall pointer to serial command
        CALL    L1DF1           ; Send command to player
;----------------------------------------------------        
;     
;----------------------------------------------------        
L1DE0:  LD      HL,0A001h       ;
        BIT     2,(HL)          ;
        LD      (0E030h),A      ; Reset watchdog
        JR      NZ,L1DE0        ;
;----------------------------------------------------        
;     
;----------------------------------------------------        
        LD      HL,0E000h       ;
        SET     7,(HL)          ;
        JR      L1D74           ;
        
        
        
;----------------------------------------------------        
;     
;----------------------------------------------------        
L1DF1:  CALL    L00E0           ; Add HEX Frame Offset then convert to ASCII
L1DF4:  LD      HL,0A12Fh       ; HL = Outgoing Command Buffer
        LD      (0A138h),HL     ; Set pointer for outgoing message
        LD      HL,0A001h       ;
        SET     2,(HL)          ; Indicate message ready to transmit
        JP      L0ED5           ;
        
        
        
;----------------------------------------------------        
;                   Delay
;----------------------------------------------------        
L1E02:  LD      C,0FFh          ; C = delay value
L1E04:  LD      B,0FFh          ; B = delay loop
L1E06:  LD      (0E030h),A      ; Reset watchdog
        DJNZ    L1E06           ; Loop on delay
        DEC     C               ; Decrement loop
        JR      NZ,L1E04        ; Loop on delay
        RET                     ; Return



;----------------------------------------------------        
;     
;----------------------------------------------------
        NOP     
L1E10:  LD      A,001h
        LD      (0A240h),A
        JP      L13C5
L1E18:  LD      A,(0A240h)
        AND     A
        RET     Z

        LD      A,000h
        LD      (0A240h),A
        RET     

        NOP     
        LD      H,(HL)
        NOP     
        HALT    
        NOP     
        DEC     A
        LD      BC,0002Ah
        LD      DE,03A01h
        NOP     
        LD      HL,09701h
        NOP     
        OR      (HL)
        LD      BC,000D7h
        CALL    PO,L0201
        LD      BC,001D6h
        LD      C,B
        LD      (BC),A
        LD      D,E
        LD      (BC),A
        LD      A,D
        LD      (BC),A
        LD      A,A
        LD      BC,001C9h
        EX      AF,AF'
        LD      (BC),A
        INC     L
        LD      (BC),A
        LD      L,L
        LD      (BC),A
        LD      (HL),E
        NOP     
        LD      (IX+001h),D
        RET     

        LD      B,(HL)
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      C,(HL)
        DEC     C
        LD      D,L
        DEC     C
        LD      B,(HL)
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        LD      D,D
        DEC     C
        
        
        
;----------------------------------------------------
;  
;----------------------------------------------------
Lyxxx:  PUSH    AF              ; Save registers
        PUSH    BC              ; Save registers
        PUSH    DE              ; Save registers
        PUSH    HL              ; Save registers
;----------------------------------------------------
;  
;----------------------------------------------------        
        LD      BC,00008h       ; 8 bytes in command
        LD      DE,0A12Fh       ; DE = Outgoing Serial Command buffer
        LD      HL,L0E54        ; HL = LDPlayer Command 'F00000N'
        LD      (0A138h),DE     ; Save outgoing buffer pointer
        LDIR    
        CALL    L00E0           ; Add HEX Frame Offset then convert to ASCII
        LD      A,(0A185h)
        CP      000h
        CALL    Z,L0C1F
        CALL    L0ED5
;----------------------------------------------------
;                 Restore registers
;----------------------------------------------------        
        POP     HL              ; Restore registers
        POP     DE              ; Restore registers
        POP     BC              ; Restore registers
        POP     AF              ; Restore registers
        RET                     ; Return     
        
        

;----------------------------------------------------
;  
;----------------------------------------------------
Lxxxx:  PUSH    AF              ; Save registers
        PUSH    BC              ; Save registers
        PUSH    DE              ; Save registers
        PUSH    HL              ; Save registers
;----------------------------------------------------
;  
;----------------------------------------------------
        LD      BC,00002h       ; 2 bytes in command
        LD      DE,0A12Fh       ; DE = Outgoing Serial Command buffer
        LD      HL,L0E5C        ; Command = PLAY Command NO SOUND ('U')
        LD      (0A138h),DE     ; Save pointer to command
        LDIR                    ; Copy blank serach command into outgoing buffer
        CALL    L0ED5           ;
;----------------------------------------------------
;  
;----------------------------------------------------        
        LD      A,(0A000h)      ;
        AND     0F8h            ;
        LD      (0A000h),A      ;
        LD      (0E028h),A      ;
        LD      HL,0A001h       ;
        SET     2,(HL)          ;
;----------------------------------------------------
;                 Restore registers
;----------------------------------------------------        
        POP     HL              ; Restore registers
        POP     DE              ; Restore registers
        POP     BC              ; Restore registers
        POP     AF              ; Restore registers
        RET                     ; Return     



;----------------------------------------------------
;  
;----------------------------------------------------
L1EB5:  PUSH    AF              ; Save registers
        PUSH    BC              ; Save registers
        PUSH    DE              ; Save registers
        PUSH    HL              ; Save registers
;----------------------------------------------------
;  
;----------------------------------------------------        
        LD      BC,00008h       ; 8 bytes in command
        LD      DE,0A12Fh       ; DE = Outgoing Serial Command buffer
        LD      HL,L0E5E        ; Command = 'F00000R' <RET> 
        LD      (0A138h),DE     ; Save pointer to command
        LDIR                    ; Copy blank serach command into outgoing buffer
        CALL    L00E0           ; Create HEX Frame then convert to ASCII
        CALL    L0ED5           ;
;----------------------------------------------------
;                 Restore registers
;----------------------------------------------------        
        POP     HL              ; Restore registers
        POP     DE              ; Restore registers
        POP     BC              ; Restore registers
        POP     AF              ; Restore registers
        RET                     ; Return



;----------------------------------------------------
;  
;----------------------------------------------------
L1ED5:  LD      HL,0A001h
        BIT     2,(HL)
        JP      NZ,L0EE1
        JR      L1ED5
        DI      
        HALT    
        RES     2,(HL)
        LD      A,001h
        OUT     (081h),A
        LD      A,01Eh
        OUT     (081h),A
        SUB     A
        OUT     (080h),A
        RET     

        PUSH    AF
        PUSH    HL
        IN      A,(080h)
        LD      HL,0A190h
        CP      041h
        JP      NZ,L0EFC
        INC     (HL)
        CP      030h
        JP      NZ,L0F02
        INC     (HL)
        CP      031h
        JP      NZ,L0F08
        INC     (HL)
        CP      00Dh
        JR      NZ,L1F3C
        LD      A,(0A190h)
        CP      002h
        JP      M,L0F3C
        XOR     A
        LD      (0A190h),A
        LD      HL,0A001h
        SET     2,(HL)
        XOR     A
        LD      (0A169h),A
        LD      A,(0A185h)
        CP      000h
        CALL    Z,L0A11
        CP      00Bh
        JR      NZ,L1F3C
        LD      A,(0A000h)
        AND     0F8h
        LD      (0A000h),A
        LD      (0E028h),A
        XOR     A
        LD      (0A185h),A
L1F3C:  POP     HL
        POP     AF
        JP      LA102
        PUSH    AF
        PUSH    HL
        XOR     A
        LD      (0A190h),A
        LD      HL,(0A138h)
        LD      A,(HL)
        OUT     (080h),A
        CP      00Dh
        JR      NZ,L1F59
        LD      A,001h
        OUT     (081h),A
        LD      A,01Ch
        OUT     (081h),A
L1F59:  INC     HL
        LD      (0A138h),HL
        POP     HL
        POP     AF
        JP      LA102
        JP      LA102
        LD      HL,0A001h
        BIT     0,(HL)
        JR      Z,L1FAD
        LD      A,(0A10Bh)
        CP      001h
        JP      NZ,L13C5
        LD      A,(0A112h)
        CP      003h
        JR      NZ,L1FA0
        LD      A,(0A185h)
        CP      005h
        JR      Z,L1F98
        LD      A,(0A150h)
        LD      B,A
        LD      A,(0A151h)
        LD      C,A
        LD      A,(0A14Bh)
        OR      B
        OR      C
        JR      Z,L1F98
        LD      A,00Ah
        LD      (0A185h),A
        JR      L1F9D
L1F98:  LD      A,005h
        LD      (0A185h),A
L1F9D:  JP      L1322
L1FA0:  CP      002h
        JP      Z,L134C
        CP      001h
        JP      Z,L13AF
        JP      L13C5
L1FAD:  LD      A,(0A112h)
        CP      006h
        JP      Z,L0FD1
        CP      005h
        JP      Z,L101E
        CP      004h
        JP      Z,L126D
        CP      003h
        JP      Z,L1322
        CP      002h
        JP      Z,L134C
        CP      001h
        JP      Z,L13AF
        JP      L13C5
        LD      HL,0A001h
        BIT     7,(HL)
        JR      Z,L1FE1
        RES     7,(HL)
        LD      HL,0A112h
        INC     (HL)
        JP      L13C5
        
        
        
L1FE1:  LD      A,(0A152h)
        CP      000h
        JR      NZ,L2003
        LD      HL,0A13Ah
        LD      (0A154h),HL
        LD      HL,0FF3Eh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        RST     38h
        SUB     C
        JR      NC,L2025
        JR      NC,L2025
        
;----------------------------------------------------        
;     Scene Indexes
;----------------------------------------------------        
L2000:  .WORD $0024  ;  36         
L2002:  .WORD $0006  ; Start game
L2004:  .WORD $029E  ; Something
L2006:  .WORD $0001  ; Start game Scene 1
        .WORD $0009
        .WORD $001E
        .WORD $002A
        .WORD $003A
        .WORD $0056
        .WORD $0066
        .WORD $0076
        .WORD $0084
        .WORD $0097
        .WORD $00AA
        .WORD $00B1
        .WORD $00B8
        .WORD $00C5
        .WORD $00D7
        .WORD $00EF
        .BYTE  02        
        
        
;----------------------------------------------------        
;     Scene 0 Data:  Attract Mode
;----------------------------------------------------        
L2088:  .WORD $00A6     ; Frame 166
        .BYTE $00,$FF   ;
        .WORD $0000     ; A113-A114
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .WORD $0002     ; Next scene 0002
;----------------------------------------------------        
;     Scene 1 Data:  Insert Coins
;----------------------------------------------------        
        .BYTE $01A6     ; Frame 422
        .BYTE $00,$FF   ;
        .WORD $0000     ;
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .WORD $0003     ; Next Scene 0003
;----------------------------------------------------        
;     Scene 2 Data
;----------------------------------------------------
        .BYTE $02A6     ;
        .BYTE $00,$FF   ;
        .WORD $0000     ;
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .WORD $0004
;----------------------------------------------------        
;     Scene 3 Data
;----------------------------------------------------        
        .WORD $03A6     ;
        .BYTE $00,$FF   ;
        .WORD $0000     ;
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .WORD $0005
;----------------------------------------------------        
;     Scene 4 Data
;----------------------------------------------------
        .BYTE $04A6     ; Frame number 1190
        .BYTE $00,$11
        .WORD $0000
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .WORD $0001     ; Next scene = loop back to scene 0001
;----------------------------------------------------        
;     Scene 5 Data
;----------------------------------------------------
        .WORD $04BA     ; Frame number 1210
        .BYTE $00,$3E
        .WORD $0000
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $0007
;----------------------------------------------------        
;     Scene 6 Data: First Scene (L2002)
;----------------------------------------------------
        .WORD $0501     ; Frame number 1281
        .BYTE $00,$83
        .WORD $0000     ; A111-A114
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .WORD $0008
;----------------------------------------------------        
;     Scene 7 Data
;----------------------------------------------------        
        .BYTE $0687
        .BYTE $00,$3F,$00,$00
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $0000
;----------------------------------------------------        
;     Scene 8 Data
;----------------------------------------------------
        .BYTE $0861
        .BYTE $00,$37
        .WORD $0000
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $000A

        .BYTE $99,$08
        .BYTE $00,$41
        .WORD $0000
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $0B,$00

        .BYTE $DB,$08
        .BYTE $20,$11
        .WORD $0000
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$0C,$00,$19,$00,$19,$00
        .BYTE $19,$00,$19,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $19,$00

        .BYTE $ED,$08
        .BYTE $00,$33
        .WORD $0350
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .BYTE $0D,$00
        
L2055:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L205B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2066:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2070:  RST     38h
L2071:  RST     38h
        RST     38h
        RST     38h
L2074:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     (HL)
        NOP     
        NOP     
        RST     38h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (BC),A
        NOP     
        AND     (HL)
        LD      BC,$FF00
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     BC
        NOP     
        AND     (HL)
        LD      (BC),A
        NOP     
        RST     38h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     B
        NOP     
        AND     (HL)
        INC     BC
        NOP     
        RST     38h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     B
        NOP     
        AND     (HL)
        INC     B
        NOP     
        LD      DE,L0000
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      BC,0BA00h
        INC     B
        NOP     
        LD      A,000h
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RLCA    
        NOP     
        LD      BC,00005h
        ADD     A,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      AF,AF'
        NOP     
        ADD     A,A
        LD      B,000h
        CCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      H,C
        EX      AF,AF'
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(BC)
        NOP     
        SBC     A,C
        EX      AF,AF'
        NOP     
        LD      B,C
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     BC
        NOP     
        IN      A,(008h)
        JR      NZ,L21DD
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     C
        NOP     
        ADD     HL,DE
        NOP     
        ADD     HL,DE
        NOP     
        ADD     HL,DE
        NOP     
        ADD     HL,DE
L21DD:  NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,DE
        NOP     
        .BYTE   0EDh, 008h            ; UnDoCumEntED 8 T-StAtE NOP
        NOP     
        INC     SP
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     C
        NOP     
        LD      HL,02009h
        RRCA    
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        NOP     
        LD      A,(DE)
        NOP     
        LD      A,(DE)
        NOP     
        LD      A,(DE)
        NOP     
        LD      C,000h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        NOP     
        LD      SP,00009h
        RRA     
        NOP     
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RRCA    
        NOP     
        LD      D,C
        ADD     HL,BC
        JR      NZ,L225B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        NOP     
        DJNZ    L2258
L2258:  LD      A,(DE)
        NOP     
        LD      A,(DE)
L225B:  NOP     
        LD      A,(DE)
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        NOP     
        LD      H,C
        ADD     HL,BC
        NOP     
        RLA     
        LD      B,E
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      DE,07900h
        ADD     HL,BC
        JR      NZ,L2297
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        NOP     
        LD      A,(DE)
L2297:  NOP     
        LD      A,(DE)
        NOP     
        LD      (DE),A
        NOP     
        LD      A,(DE)
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        NOP     
        ADD     A,L
        ADD     HL,BC
        NOP     
        LD      L,073h
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     DE
        NOP     
        OR      H
        ADD     HL,BC
        JR      NZ,L22E2
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     DE
        NOP     
        DEC     DE
        NOP     
        INC     D
        NOP     
        DEC     DE
        NOP     
        DEC     DE
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L22E2:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     DE
        NOP     
        RRC     C
        NOP     
        RLA     
        SUB     A
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     D
        NOP     
        EX      (SP),HL
        ADD     HL,BC
        JR      NZ,L2317
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        NOP     
        LD      A,(DE)
L2317:  NOP     
        LD      A,(DE)
        NOP     
        LD      A,(DE)
        NOP     
        JR      L231E
L231E:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,000h
        RST     28h
        ADD     HL,BC
        JR      NZ,L2331
        INC     BC
        INC     BC
        RST     38h
        RST     38h
        RST     38h
L2331:  RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        NOP     
        LD      A,(DE)
        NOP     
        LD      A,(DE)
        NOP     
        LD      A,(DE)
        NOP     
        INC     E
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RLA     
        NOP     
        PUSH    AF
        ADD     HL,BC
        JR      NZ,L2355
        INC     SP
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2355:  RST     38h
        LD      A,(DE)
        NOP     
        LD      A,(DE)
        NOP     
        LD      A,(DE)
        NOP     
        JR      L235E
L235E:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        NOP     
        RST     38h
        ADD     HL,BC
        NOP     
        LD      DE,00300h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      DE,0100Ah
        LD      B,A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     E
        NOP     
        LD      E,C
        LD      A,(BC)
        DJNZ    L23DB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     E
        NOP     
        ADC     A,C
        LD      A,(BC)
        DJNZ    L2413
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L23DB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     E
        NOP     
        POP     DE
        LD      A,(BC)
        DJNZ    L240F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     E
        NOP     
        PUSH    AF
        LD      A,(BC)
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
L240F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
L2413:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      C,C
        DEC     BC
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RRA     
        NOP     
        ADD     A,C
        DEC     BC
        NOP     
        CPL     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      NZ,L2468
L2468:  OR      C
        DEC     BC
        JR      NZ,L2479
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      HL,02800h
        NOP     
        JR      Z,L247A
L247A:  JR      Z,L247C
L247C:  JR      Z,L247E
L247E:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L2488
L2488:  CP      A
        DEC     BC
        NOP     
        JR      NZ,L248D
L248D:  INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (0E000h),HL
        DEC     BC
        JR      NZ,L24B8
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     HL
        NOP     
        JR      Z,L24B8
L24B8:  JR      Z,L24BA
L24BA:  JR      Z,L24BC
L24BC:  JR      Z,L24BE
L24BE:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L24C8
L24C8:  .BYTE   0EDh, 00Bh            ; UnDoCumEntED 8 T-StAtE NOP
        NOP     
        DEC     DE
        NOP     
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     H
        NOP     
        ADD     HL,BC
        INC     C
        JR      NZ,L24F5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     H
L24F5:  NOP     
        JR      Z,L24F8
L24F8:  JR      Z,L24FA
L24FA:  JR      Z,L24FC
L24FC:  JR      Z,L24FE
L24FE:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L2508
L2508:  INC     DE
        INC     C
        NOP     
        EX      AF,AF'
        NOP     
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,000h
        INC     E
        INC     C
        JR      NZ,L2538
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L2536
L2536:  JR      Z,L2538
L2538:  JR      Z,L253A
L253A:  JR      Z,L253C
L253C:  DAA     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L2548
L2548:  ADD     HL,HL
        INC     C
        NOP     
        LD      D,E
        NOP     
        INC     DE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      A,L
        INC     C
        DJNZ    L25B3
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        NOP     
        PUSH    BC
        INC     C
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        ADD     HL,DE
        DEC     C
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L25B3:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     HL
        NOP     
        LD      D,C
        DEC     C
        NOP     
        INC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     L
        NOP     
        LD      (HL),L
        DEC     C
        JR      NZ,L25FB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CPL     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
L25FB:  ADD     A,B
        SCF     
        ADD     A,B
        RST     38h
        RST     38h
L2600:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     L
        NOP     
        ADD     A,L
        DEC     C
        JR      NZ,L2641
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,000h
        CP      E
        DEC     C
        JR      NZ,L2645
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CPL     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
L2641:  RST     38h
        RST     38h
        RST     38h
        RST     38h
L2645:  RST     38h
        SCF     
        NOP     
        PUSH    DE
        DEC     C
        JR      NZ,L2663
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SCF     
        NOP     
        SCF     
        NOP     
        SCF     
        NOP     
        SCF     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2663:  RST     38h
        RST     38h
        RST     38h
        JR      NC,L2668
L2668:  .BYTE   0EDh, 00Dh            ; UnDoCumEntED 8 T-StAtE NOP
        JR      NZ,L2681
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      SP,03700h
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
L2681:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      C,L2688
L2688:  INC     BC
        LD      C,020h
        RLA     
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (01B00h),A
        LD      C,020h
        DEC     D
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     SP
        NOP     
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      C,L26C8
L26C8:  LD      SP,0200Eh
        RLA     
        LD      D,B
        LD      D,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     (HL)
        NOP     
        LD      C,C
        LD      C,020h
        LD      A,(BC)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     (HL)
        NOP     
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        SCF     
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),000h
        LD      D,H
        LD      C,000h
        DEC     L
        LD      D,B
        RLA     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      A,A
        LD      C,010h
        DEC     A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,SP
        NOP     
        CP      L
        LD      C,010h
        LD      C,C
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,SP
        NOP     
        EX      (SP),HL
        LD      C,010h
        INC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,SP
        NOP     
        RLCA    
        RRCA    
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      E,E
        RRCA    
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     SP
        NOP     
        SUB     E
        RRCA    
        NOP     
        INC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     A
        NOP     
        OR      A
        RRCA    
        JR      NZ,L27F9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,A
        NOP     
        DEC     A
L27F9:  NOP     
        RST     38h
        RST     38h
        LD      C,A
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,A
        NOP     
        PUSH    BC
        RRCA    
        NOP     
        INC     HL
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,000h
        JP      (HL)
        RRCA    
        JR      NZ,L2835
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2835:  RST     38h
        LD      D,B
        NOP     
        LD      C,(HL)
        NOP     
        LD      D,B
        NOP     
        CCF     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,(HL)
        NOP     
        DI      
        RRCA    
        NOP     
        RLA     
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,B
        NOP     
        DEC     BC
        DJNZ    L288B
        INC     H
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,C
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,A
        NOP     
        JR      NC,L289A
        NOP     
L288B:  LD      D,050h
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L289A:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,D
        NOP     
        LD      B,A
        DJNZ    L28CB
        DEC     BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,E
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,B
        NOP     
        LD      D,E
        DJNZ    L28CB
L28CB:  INC     HL
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,H
        NOP     
        LD      (HL),A
        DJNZ    L290B
        RLA     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
        NOP     
        ADC     A,A
        DJNZ    L290B
L290B:  DEC     E
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,(HL)
        NOP     
        XOR     L
        DJNZ    L294B
        LD      DE,L0000
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
        NOP     
        LD      D,D
        NOP     
        LD      D,B
        NOP     
        LD      B,A
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,D
        NOP     
        CP      A
        DJNZ    L294B
L294B:  DEC     A
        LD      D,B
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,B
        NOP     
        DJNZ    L298B
        ADD     HL,BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,C
        NOP     
        LD      D,E
        NOP     
        LD      D,E
        NOP     
        LD      D,E
        NOP     
        LD      D,E
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,E
        NOP     
        RLCA    
        LD      DE,01700h
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,D
        NOP     
        RRA     
        LD      DE,00B20h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,E
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,A
        NOP     
        DEC     HL
        LD      DE,02500h
        LD      D,B
        DJNZ    L29CE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,H
        NOP     
        LD      D,C
        LD      DE,01120h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,A
        NOP     
        LD      C,A
        NOP     
        LD      C,A
        NOP     
        LD      C,L
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,H
        NOP     
        LD      H,E
        LD      DE,02300h
        LD      D,B
        INC     DE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        ADD     A,A
        LD      DE,01710h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,L
        NOP     
        SBC     A,A
        LD      DE,02F10h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,L
        NOP     
        RST     08h
        LD      DE,02F10h
        LD      BC,$FF00
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,L
        NOP     
        RST     38h
        LD      DE,04F10h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,L
        NOP     
        LD      C,A
        LD      (DE),A
        DJNZ    L2ACF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,L
        NOP     
        LD      (HL),E
        LD      (DE),A
        DJNZ    L2AFB
        NOP     
        NOP     
        RST     38h
L2ACF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,L
        NOP     
        AND     E
        LD      (DE),A
        DJNZ    L2B27
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2AFB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,L
        NOP     
        RST     18h
        LD      (DE),A
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
L2B27:  NOP     
        INC     SP
        INC     DE
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,A
        NOP     
        LD      L,E
        INC     DE
        NOP     
        CPL     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,B
        NOP     
        SBC     A,E
        INC     DE
        JR      NZ,L2B79
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2B79:  RST     38h
        RST     38h
        RST     38h
        LD      E,C
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,E
        NOP     
        XOR     C
        INC     DE
        NOP     
        DAA     
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,D
        NOP     
        POP     DE
        INC     DE
        JR      NZ,L2BB9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,E
        NOP     
        RST     38h
        RST     38h
        RST     38h
L2BB9:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,D
        NOP     
        RST     18h
        INC     DE
        NOP     
        INC     H
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,H
        NOP     
        INC     B
        INC     D
        JR      NZ,L2BF5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2BF5:  RST     38h
        LD      E,L
        NOP     
        RST     38h
        RST     38h
        LD      E,L
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,E
        NOP     
        LD      C,014h
        NOP     
        RRCA    
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,(HL)
        NOP     
        LD      E,014h
        JR      NZ,L2C40
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,A
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2C40:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,H
        NOP     
        INC     SP
        INC     D
        NOP     
        LD      (HL),050h
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,B
        NOP     
        LD      L,D
        INC     D
        JR      NZ,L2C80
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,C
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2C80:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,E
        NOP     
        LD      A,A
        INC     D
        NOP     
        RLA     
        NOP     
        LD      (DE),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        SUB     A
        INC     D
        DJNZ    L2CCF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,L
        NOP     
        CP      E
        INC     D
        DJNZ    L2CEF
        NOP     
        NOP     
        RST     38h
L2CCF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,L
        NOP     
        RST     18h
        INC     D
        DJNZ    L2D1B
        NOP     
        NOP     
        RST     38h
L2CEF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,L
        NOP     
        RRCA    
        DEC     D
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2D1B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      H,E
        DEC     D
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,A
        NOP     
        SBC     A,E
        DEC     D
        NOP     
        LD      A,(L0000)
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,B
        NOP     
        SUB     015h
        JR      NZ,L2D7C
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,C
        NOP     
        LD      (HL),D
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2D7C:  LD      (HL),H
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),D
        NOP     
        RST     20h
        DEC     D
        NOP     
        JR      L2DDD
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,D
        NOP     
        NOP     
        LD      D,020h
        DEC     BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,E
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),H
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),E
        NOP     
        INC     C
        LD      D,020h
        LD      L,050h
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),H
        NOP     
        RST     38h
        RST     38h
        RST     38h
L2DDD:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,H
        NOP     
        DEC     SP
        LD      D,020h
        DEC     BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,L
        NOP     
        RST     38h
        RST     38h
        LD      (HL),C
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),C
        NOP     
        LD      B,A
        LD      D,000h
        DAA     
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,(HL)
        NOP     
        LD      L,A
        LD      D,020h
        RRCA    
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),C
        NOP     
        RST     38h
        RST     38h
        LD      (HL),H
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,A
        NOP     
        LD      A,A
        LD      D,020h
        LD      A,(BC)
        LD      D,B
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),C
        NOP     
        RST     38h
        RST     38h
        LD      (HL),H
        NOP     
        LD      (HL),H
        NOP     
        LD      (HL),B
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),D
        NOP     
        ADC     A,D
        LD      D,000h
        JR      L2EBD
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        AND     E
        LD      D,010h
        LD      E,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),L
        NOP     
        RST     38h
        LD      D,010h
        INC     SP
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2EBD:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),L
        NOP     
        INC     SP
        RLA     
        DJNZ    L2F37
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),L
        NOP     
        LD      A,E
        RLA     
        DJNZ    L2F0F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),L
        NOP     
        SBC     A,A
        RLA     
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
L2F0F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        DI      
        RLA     
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L2F37:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
        NOP     
        DEC     HL
        JR      L2F4B
L2F4B:  LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,B
        NOP     
        LD      A,A
        JR      L2F8B
        DEC     BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,B
        NOP     
        ADD     A,B
        NOP     
        LD      A,C
        NOP     
        ADD     A,B
        NOP     
        ADD     A,B
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,B
        NOP     
        ADC     A,E
        JR      L2F8B
L2F8B:  ADD     HL,HL
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,D
        NOP     
        OR      L
        JR      L2FCB
        LD      DE,L0000
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        NOP     
        ADD     A,C
        NOP     
        ADD     A,C
        NOP     
        ADD     A,C
        NOP     
        ADD     A,C
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,C
        NOP     
        RST     00h
        JR      L2FCB
L2FCB:  DEC     D
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,H
        NOP     
        JR      L300B
        DEC     C
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,C
        NOP     
        ADD     A,C
        NOP     
        LD      A,L
        NOP     
        ADD     A,C
        NOP     
        ADD     A,C
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,C
        NOP     
        EX      DE,HL
        JR      L300B
L300B:  LD      (00550h),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(HL)
        NOP     
        LD      E,019h
        JR      NZ,L303C
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,D
        NOP     
        ADD     A,B
        NOP     
        LD      A,A
        NOP     
        ADD     A,B
        NOP     
L303C:  ADD     A,D
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,B
        NOP     
        CPL     
        ADD     HL,DE
        NOP     
        CPL     
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      E,A
        ADD     HL,DE
        DJNZ    L309B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,E
        NOP     
        ADC     A,A
        ADD     HL,DE
        DJNZ    L30AF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L309B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,E
        NOP     
        OR      E
        ADD     HL,DE
        DJNZ    L310B
        NOP     
        NOP     
        RST     38h
L30AF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,E
        NOP     
        INC     DE
        LD      A,(DE)
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      H,A
        LD      A,(DE)
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,L
        NOP     
        SBC     A,A
        LD      A,(DE)
        NOP     
L310B:  CCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,(HL)
        NOP     
        RST     18h
        LD      A,(DE)
        JR      NZ,L3153
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,A
        NOP     
        SUB     B
        NOP     
        SUB     B
        NOP     
        SUB     B
        NOP     
        SUB     C
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     C
        NOP     
        RLCA    
        DEC     DE
        NOP     
        DEC     DE
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3153:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,B
        NOP     
        INC     HL
        DEC     DE
        JR      NZ,L318B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,C
        NOP     
        SUB     B
        NOP     
        SUB     B
        NOP     
        SUB     B
        NOP     
        SUB     D
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     D
        NOP     
        LD      B,E
        DEC     DE
        NOP     
L318B:  INC     H
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,D
        NOP     
        LD      L,B
        DEC     DE
        JR      NZ,L31BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     E
        NOP     
        SUB     B
        NOP     
        ADC     A,E
        NOP     
        SUB     E
        NOP     
L31BC:  SUB     E
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     E
        NOP     
        LD      A,C
        DEC     DE
        NOP     
        JR      NZ,L321D
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,H
        NOP     
        SBC     A,D
        DEC     DE
        JR      NZ,L31FC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,L
        NOP     
        SUB     H
        NOP     
        SUB     H
        NOP     
        SUB     H
        NOP     
L31FC:  SUB     H
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     H
        NOP     
        XOR     E
        DEC     DE
        NOP     
        ADD     A,C
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L321D:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,(HL)
        NOP     
        DEC     L
        INC     E
        JR      NZ,L3245
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,A
        NOP     
        SUB     L
        NOP     
        SUB     L
        NOP     
        SUB     L
        NOP     
        SUB     L
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3245:  RST     38h
        SUB     L
        NOP     
        LD      B,A
        INC     E
        NOP     
        LD      H,C
        LD      D,B
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        XOR     C
        INC     E
        DJNZ    L328F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     (HL)
        NOP     
        CALL    L101C
        RLA     
        NOP     
        NOP     
        RST     38h
L328F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     (HL)
        NOP     
        PUSH    HL
        INC     E
        DJNZ    L32DB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     (HL)
        NOP     
        DEC     D
        DEC     E
        DJNZ    L32FF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L32DB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     (HL)
        NOP     
        LD      C,C
        DEC     E
        DJNZ    L3303
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L32FF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
L3303:  RST     38h
        RST     38h
        RST     38h
        SUB     (HL)
        NOP     
        LD      H,C
        DEC     E
        DJNZ    L3353
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     (HL)
        NOP     
        XOR     C
        DEC     E
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        DEC     E
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3353:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,B
        NOP     
        DEC     (HL)
        LD      E,020h
        SBC     A,L
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        ADD     A,B
        XOR     B
        ADD     A,B
        RST     38h
        RST     38h
        AND     (HL)
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,C
        NOP     
        OUT     (01Eh),A
        JR      NZ,L3395
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3395:  RST     38h
        XOR     B
        ADD     A,B
        XOR     B
        ADD     A,B
        RST     38h
        RST     38h
        SBC     A,A
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        NOP     
        LD      E,020h
        ADD     HL,DE
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        ADD     A,B
        XOR     B
        ADD     A,B
        RST     38h
        RST     38h
        AND     (HL)
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,E
        NOP     
        RST     30h
        LD      E,020h
        ADD     HL,BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        ADD     A,B
        XOR     B
        ADD     A,B
        RST     38h
        RST     38h
        SBC     A,A
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,H
        NOP     
        LD      BC,0201Fh
        ADD     HL,DE
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        ADD     A,B
        XOR     B
        ADD     A,B
        RST     38h
        RST     38h
        AND     (HL)
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,L
        NOP     
        DEC     DE
        RRA     
        JR      NZ,L3415
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3415:  RST     38h
        XOR     B
        ADD     A,B
        XOR     B
        ADD     A,B
        RST     38h
        RST     38h
        SBC     A,A
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,(HL)
        NOP     
        DEC     H
        RRA     
        JR      NZ,L3445
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        ADD     A,B
        XOR     B
        ADD     A,B
        RST     38h
        RST     38h
        AND     (HL)
        ADD     A,B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3445:  RST     38h
        AND     (HL)
        NOP     
        CCF     
        RRA     
        NOP     
        LD      B,A
        NOP     
        DJNZ    L344E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     B
        NOP     
        ADD     A,A
        RRA     
        JR      NZ,L3477
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     C
        NOP     
        XOR     B
L3477:  NOP     
        XOR     B
        NOP     
        XOR     B
        NOP     
        AND     A
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     A
        NOP     
        SUB     E
        RRA     
        NOP     
        INC     SP
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     D
        NOP     
        RST     00h
        RRA     
        JR      NZ,L34C3
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        NOP     
        XOR     B
        NOP     
        XOR     B
        NOP     
        AND     E
        NOP     
        XOR     B
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L34C3:  RST     38h
        RST     38h
        RST     38h
        XOR     B
        NOP     
        RST     18h
        RRA     
        NOP     
        DEC     H
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     H
        NOP     
        DEC     B
        JR      NZ,L350B
        LD      D,000h
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        NOP     
        XOR     B
        NOP     
        XOR     B
        NOP     
        XOR     B
        NOP     
        AND     L
        NOP     
        RST     38h
        RST     38h
        RST     38h
L3501:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        NOP     
        INC     E
        JR      NZ,L350B
L350B:  LD      D,000h
        DEC     D
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        INC     SP
        JR      NZ,L353B
        DEC     (HL)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L353B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     C
        NOP     
        LD      L,C
        JR      NZ,L355B
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L355B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     C
        NOP     
        CP      L
        JR      NZ,L357B
        INC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L357B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     C
        NOP     
        POP     HL
        JR      NZ,L358B
L358B:  LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        DEC     (HL)
        LD      HL,03700h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     E
        NOP     
        LD      L,L
        LD      HL,09700h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     H
        NOP     
        DEC     B
        LD      (01920h),HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     A
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     A
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     L
        NOP     
        RRA     
        LD      (01320h),HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     A
        NOP     
        XOR     (HL)
        NOP     
        XOR     A
        NOP     
        XOR     A
        NOP     
        XOR     A
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     A
        NOP     
        INC     SP
        LD      (01100h),HL
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      B,L
        LD      (05310h),HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        SBC     A,C
        LD      (05300h),HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        .BYTE   0EDh, 022h            ; UnDoCumEntED 8 T-StAtE NOP
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      D
        NOP     
        DEC     H
        INC     HL
        NOP     
        DEC     L
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      E
        NOP     
        LD      D,E
        INC     HL
        JR      NZ,L36D9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      L
        NOP     
        OR      (HL)
        NOP     
        OR      (HL)
L36D9:  NOP     
        OR      (HL)
        NOP     
        OR      H
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      L
        NOP     
        LD      H,C
        INC     HL
        NOP     
        LD      B,A
        NOP     
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        XOR     C
        INC     HL
        DJNZ    L373B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      A
        NOP     
        EXX     
        INC     HL
        DJNZ    L3767
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L373B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      A
        NOP     
        DEC     D
        INC     H
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
L3767:  NOP     
        LD      L,C
        INC     H
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        NOP     
        AND     C
        INC     H
        NOP     
        LD      B,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      D
        NOP     
        PUSH    HL
        INC     H
        NOP     
        LD      DE,L0000
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      $BB00
        NOP     
        JP      $C300
        NOP     
        JP      $FF00
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      $F700
        INC     H
        NOP     
        ADD     HL,DE
        LD      D,B
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      H
        NOP     
        LD      DE,L2025
        INC     D
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      $C300
        NOP     
        CP      L
        NOP     
        JP      $BD00
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      L2600
        DEC     H
        NOP     
        LD      C,050h
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      (HL)
        NOP     
        DEC     (HL)
        DEC     H
        JR      NZ,L384F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      $C300
        NOP     
        CP      A
        NOP     
        JP      $C200
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      L5900
        DEC     H
        NOP     
        RRA     
        LD      D,B
        INC     B
        RST     38h
L384F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     NZ

        NOP     
        LD      A,C
        DEC     H
        JR      NZ,L3877
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      $C300
L3877:  NOP     
        POP     BC
        NOP     
        JP      $C200
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      $8500
        DEC     H
        NOP     
        CCF     
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        PUSH    BC
        DEC     H
        DJNZ    L38E7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    NZ,LE900
        DEC     H
        DJNZ    L38E3
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L38E3:  RST     38h
        RST     38h
        RST     38h
        CALL    NZ,L0100
        LD      H,000h
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      D,L
        LD      H,000h
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,000h
        ADC     A,L
        LD      H,000h
        LD      E,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     00h
        NOP     
        JP      (HL)
        LD      H,020h
        ADD     HL,BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        RET     Z

        NOP     
        PUSH    DE
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        DI      
        LD      H,000h
        ADD     HL,DE
        LD      D,B
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     

        NOP     
        DEC     C
        DAA     
        JR      NZ,L3997
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        PUSH    DE
L3997:  NOP     
        JP      Z,$FF00
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        ADD     HL,DE
        DAA     
        NOP     
        RRA     
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RLC     B
        ADD     HL,SP
        DAA     
        JR      NZ,L39D5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        CALL    Z,LD500
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        LD      B,E
        DAA     
        NOP     
        LD      H,050h
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    L6A00
        DAA     
        JR      NZ,L3A1A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        PUSH    DE
        NOP     
        ADC     A,000h
L3A1A:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        LD      A,C
        DAA     
        NOP     
        RLA     
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     08h
        NOP     
        SUB     C
        DAA     
        JR      NZ,L3A59
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    NC,LD400
        NOP     
        RET     NC

L3A59:  NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    NC,L9F00
        DAA     
        NOP     
        ADD     HL,DE
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        POP     DE
        NOP     
        CP      C
        DAA     
        JR      NZ,L3A9B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        PUSH    DE
        NOP     
        JP      NC,$FF00
L3A9B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (000h),A
        RET     

        DAA     
        NOP     
        LD      (HL),E
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        DEC     A
        JR      Z,L3ADB
        CPL     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3ADB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     000h
        LD      L,L
        JR      Z,L3AFB
        CCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3AFB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     000h
        XOR     L
        JR      Z,L3B1B
        INC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3B1B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     000h
        POP     DE
        JR      Z,L3B2B
L3B2B:  LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        DEC     H
        ADD     HL,HL
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     C

        NOP     
        LD      E,L
        ADD     HL,HL
        NOP     
        LD      D,L
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EXX     
        NOP     
        OR      E
        ADD     HL,HL
        JR      NZ,L3B9A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        JP      C,LEB00
        NOP     
L3B9A:  EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        JP      NZ,L0029
        INC     D
        LD      D,B
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        IN      A,(000h)
        RST     10h
        ADD     HL,HL
        JR      NZ,L3BD9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        CALL    C,LEB00
        NOP     
        EX      DE,HL
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        PUSH    HL
        ADD     HL,HL
        NOP     
        RRA     
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        DEC     B
        LD      HL,(00920h)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        SBC     A,000h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        RRCA    
        LD      HL,(02B00h)
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     18h
        NOP     
        DEC     SP
        LD      HL,(00920h)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        RET     PO

        NOP     
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        LD      B,L
        LD      HL,(L1D00)
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        POP     HL
        NOP     
        LD      H,E
        LD      HL,(00B20h)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        JP      PO,LEB00
        NOP     
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        LD      L,A
        LD      HL,(01100h)
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      (SP),HL
        NOP     
        ADD     A,C
        LD      HL,(00920h)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        CALL    PO,LEB00
        NOP     
        EX      DE,HL
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        ADC     A,E
        LD      HL,(00B00h)
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        PUSH    HL
        NOP     
        SUB     A
        LD      HL,(00920h)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        AND     000h
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        EX      DE,HL
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      DE,HL
        NOP     
        AND     C
        LD      HL,(02B00h)
        LD      D,B
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     20h
        NOP     
        CALL    L202A
        ADD     HL,BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     PE

        NOP     
        CALL    PE,LEC00
        NOP     
        EX      DE,HL
        NOP     
        CALL    PE,$FF00
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    PE,LD700
        LD      HL,(06500h)
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      (HL)
        NOP     
        DEC     A
        DEC     HL
        JR      NZ,L3D99
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        .BYTE   0EDh, 000h            ; UnDoCumEntED 8 T-StAtE NOP
        .BYTE   0EDh, 000h            ; UnDoCumEntED 8 T-StAtE NOP
        .BYTE   0EDh, 000h            ; UnDoCumEntED 8 T-StAtE NOP
        .BYTE   0EDh, 000h            ; UnDoCumEntED 8 T-StAtE NOP
        JP      PE,$FF00
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        .BYTE   0EDh, 000h            ; UnDoCumEntED 8 T-StAtE NOP
        LD      C,E
        DEC     HL
        NOP     
        LD      HL,01050h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      L,L
        DEC     HL
        DJNZ    L3DFB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     000h
        SBC     A,L
        DEC     HL
        DJNZ    L3E0B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3DFB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     000h
        LD      L,H
        LD      (02C10h),HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     000h
        CP      L
        DEC     HL
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      DE,L002C
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     P

        NOP     
        LD      C,C
        INC     L
        NOP     
        ADD     HL,SP
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        POP     AF
        NOP     
        ADD     A,E
        INC     L
        JR      NZ,L3E9C
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        NOP     
        NOP     
L3E9C:  JP      P,$FF00
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        SUB     H
        INC     L
        NOP     
        INC     D
        LD      D,B
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DI      
        NOP     
        XOR     C
        INC     L
        JR      NZ,L3ED7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    P,$FE00
L3ED7:  NOP     
        CP      000h
        CP      000h
        CP      000h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      000h
        OR      L
        INC     L
        NOP     
        DEC     E
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        PUSH    AF
        NOP     
        OUT     (02Ch),A
        JR      NZ,L3F1D
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        RST     38h
        NOP     
        RST     38h
        NOP     
        RST     38h
        NOP     
        OR      000h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        PUSH    HL
        INC     L
        NOP     
        JR      L3F7D
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     30h
        NOP     
        CP      02Ch
        JR      NZ,L3F56
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        NOP     
L3F56:  CP      000h
        CP      000h
        CP      000h
        CP      000h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      000h
        ADD     HL,BC
        DEC     L
        NOP     
        DEC     D
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3F7D:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      SP,HL
        NOP     
        RRA     
        DEC     L
        JR      NZ,L3F9D
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        RST     38h
        NOP     
        JP      M,$FF00
        NOP     
        RST     38h
L3F9D:  NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        LD      SP,0002Dh
        ADD     HL,DE
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EI      
        NOP     
        LD      C,E
        DEC     L
        JR      NZ,L3FE5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    M,L0000
        LD      BC,L0100
        NOP     
        LD      BC,L0100
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L3FE5:  RST     38h
        NOP     
        LD      BC,02D65h
        NOP     
        LD      L,E
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        POP     DE
        DEC     L
        DJNZ    L402F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      BC,0F501h
        DEC     L
        DJNZ    L4043
        NOP     
        NOP     
        RST     38h
L402F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L4043:  RST     38h
        RST     38h
        RST     38h
        LD      BC,00D01h
        LD      L,010h
        INC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      BC,03101h
        LD      L,010h
        LD      B,A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      BC,07901h
        LD      L,000h
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        CALL    L002E
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     BC
        LD      BC,02F05h
        NOP     
        INC     (HL)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     B
        LD      BC,02F3Ah
        JR      NZ,L40F5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,001h
        LD      C,001h
        LD      C,001h
        LD      C,001h
        DEC     B
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,001h
        LD      B,H
        CPL     
        NOP     
        LD      (DE),A
        LD      D,B
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,001h
        LD      D,A
        CPL     
        JR      NZ,L4139
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,001h
        LD      C,001h
        LD      C,001h
        LD      C,001h
        RLCA    
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,001h
        LD      H,L
        CPL     
        NOP     
        CPL     
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      AF,AF'
        LD      BC,02F95h
        JR      NZ,L4177
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,BC
        LD      BC,0010Fh
        RRCA    
        LD      BC,0010Fh
        RRCA    
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RRCA    
        LD      BC,02FA1h
        NOP     
        RLA     
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(BC)
        LD      BC,02FB9h
        JR      NZ,L41B7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,001h
        DEC     BC
L41B7:  LD      BC,0010Eh
        LD      C,001h
        LD      C,001h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,001h
        PUSH    BC
        CPL     
        NOP     
        JR      L421D
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     C
        LD      BC,02FDEh
        JR      NZ,L41F6
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,001h
L41F6:  DEC     C
        LD      BC,0010Eh
        LD      C,001h
        LD      C,001h
        RST     38h
        RST     38h
        RST     38h
L4201:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,001h
        JP      (HL)
        CPL     
        NOP     
        DEC     SP
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L421D:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        INC     H
        JR      NC,L423B
        INC     A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L423B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DJNZ    L4249
        LD      H,C
L4249:  JR      NC,L425B
        CPL     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L425B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DJNZ    L4269
        SUB     C
L4269:  JR      NC,L426B
L426B:  LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        PUSH    HL
        JR      NC,L428B
L428B:  SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (DE),A
        LD      BC,0311Dh
        NOP     
        DAA     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     DE
        LD      BC,03145h
        JR      NZ,L42DA
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,081h
        LD      E,081h
        LD      D,081h
L42DA:  LD      E,081h
        LD      E,081h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     D
        LD      BC,03154h
        JR      NZ,L4321
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,081h
        LD      E,081h
        LD      E,081h
        LD      E,081h
        LD      E,081h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     D
        LD      BC,0318Ah
        JR      NZ,L4317
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,081h
        LD      E,081h
        LD      D,081h
        LD      E,081h
        LD      E,081h
        RST     38h
        RST     38h
        RST     38h
L4321:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RRA     
        LD      BC,03196h
        NOP     
        INC     L
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,001h
        LD      E,001h
        LD      E,001h
        LD      E,001h
        LD      E,001h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RLA     
        LD      BC,031C3h
        JR      NZ,L4355
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,081h
        LD      E,081h
        JR      L435B
        LD      E,081h
        LD      E,081h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,001h
        CALL    L0031
        INC     HL
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,081h
        LD      E,081h
        LD      E,081h
        LD      E,081h
        LD      E,081h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,DE
        LD      BC,031F1h
        JR      NZ,L4395
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,081h
        LD      E,081h
        LD      A,(DE)
        LD      BC,0811Eh
        LD      E,081h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RRA     
        LD      BC,031FBh
        NOP     
        INC     E
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,081h
        LD      E,081h
        LD      E,081h
        LD      E,081h
        LD      E,081h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     DE
        LD      BC,03218h
        JR      NZ,L43D5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,081h
        LD      E,081h
        INC     E
        LD      BC,0811Eh
        LD      E,081h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     E
        LD      BC,03222h
        NOP     
        LD      HL,(00650h)
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      C,L
        LD      (03B10h),A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      NZ,L4429
        ADC     A,C
L4429:  LD      (04910h),A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      NZ,L4449
        LD      L,L
L4449:  LD      (L1B10),A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      NZ,L4469
        OUT     (032h),A
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        DAA     
        INC     SP
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (05F01h),HL
        INC     SP
        NOP     
        INC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     HL
        LD      BC,03383h
        JR      NZ,L44D9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SCF     
        LD      BC,00124h
        SCF     
L44D9:  LD      BC,00137h
        LD      (HL),001h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),001h
        SUB     C
        INC     SP
        NOP     
        DEC     H
        LD      D,B
        INC     BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     H
        LD      BC,033B7h
        JR      NZ,L4515
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     (HL)
L4515:  LD      BC,00135h
        DEC     (HL)
        LD      BC,00135h
        LD      H,001h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     (HL)
        LD      BC,033C1h
        NOP     
        RLA     
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DAA     
        LD      BC,033D9h
        JR      NZ,L456D
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),001h
        LD      (HL),001h
        JR      Z,L455B
        SCF     
L455B:  LD      BC,00136h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),001h
        EI      
        INC     SP
        NOP     
        DEC     DE
        LD      D,B
L456D:  DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      BC,03417h
        JR      NZ,L4595
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SCF     
L4595:  LD      BC,00137h
        SCF     
        LD      BC,00137h
        LD      HL,($FF01)
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SCF     
        LD      BC,03421h
        NOP     
        INC     HL
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     HL
        LD      BC,L3445
        JR      NZ,L45E1
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      C,L45D7
        INC     L
L45D7:  LD      BC,00138h
        SCF     
        LD      BC,00138h
        RST     38h
        RST     38h
        RST     38h
L45E1:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      C,L45E9
        LD      E,E
L45E9:  INC     (HL)
        NOP     
        INC     HL
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     L
        LD      BC,0347Fh
        JR      NZ,L4617
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,SP
        LD      BC,00139h
        JR      C,L461B
        SCF     
L461B:  LD      BC,0012Eh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,SP
        LD      BC,0348Bh
        NOP     
        DEC     A
        LD      D,B
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CPL     
        LD      BC,034C9h
        JR      NZ,L4659
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      NC,L4657
        LD      A,(03A01h)
L4659:  LD      BC,00137h
        LD      A,($FF01)
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(0D701h)
        INC     (HL)
        NOP     
        RLA     
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      SP,0EF01h
        INC     (HL)
        JR      NZ,L4695
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SCF     
L4695:  LD      BC,00137h
        LD      (03701h),A
        LD      BC,00137h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SCF     
        LD      BC,034F9h
        NOP     
        DEC     H
        LD      D,B
        DJNZ    L46AE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     SP
        LD      BC,0351Fh
        JR      NZ,L46DB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     SP
        LD      BC,00137h
        SCF     
        LD      BC,00138h
        INC     (HL)
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     SP
        LD      BC,0352Fh
        NOP     
        INC     HL
        LD      D,B
        LD      HL,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      D,E
        DEC     (HL)
        DJNZ    L4723
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L4723:  RST     38h
        RST     38h
        RST     38h
        INC     A
        LD      BC,0356Bh
        DJNZ    L475B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     A
        LD      BC,0359Bh
        DJNZ    L477B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L475B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     A
        LD      BC,035CBh
        DJNZ    L47BB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L477B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     A
        LD      BC,0361Bh
        DJNZ    L47AF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     A
        LD      BC,0363Fh
        DJNZ    L47DB
        NOP     
        NOP     
        RST     38h
L47AF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L47BB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     A
        LD      BC,0366Fh
        DJNZ    L4807
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L47DB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     A
        LD      BC,036ABh
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
L4807:  NOP     
        RST     38h
        LD      (HL),000h
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,001h
        SCF     
        SCF     
        NOP     
        LD      HL,(L0000)
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CCF     
        LD      BC,03762h
        JR      NZ,L485E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,B
        LD      BC,0014Ah
        LD      C,D
        LD      BC,0014Ah
        LD      C,D
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,D
        LD      BC,03775h
        NOP     
        LD      D,050h
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,C
        LD      BC,0378Ch
        JR      NZ,L4898
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,H
        LD      BC,0014Ch
L4898:  LD      B,D
        LD      BC,0014Ch
        LD      C,H
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,H
        LD      BC,03799h
        NOP     
        DEC     L
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,E
        LD      BC,037C7h
        JR      NZ,L48D7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,E
        LD      BC,0014Bh
        LD      C,E
        LD      BC,0014Bh
        LD      B,H
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,E
        LD      BC,037D3h
        NOP     
        DEC     HL
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      BC,037FFh
        JR      NZ,L4915
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,(HL)
L4915:  LD      BC,00149h
        LD      C,C
        LD      BC,00149h
        LD      C,C
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,C
        LD      BC,03809h
        NOP     
        RRA     
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,A
        LD      BC,03829h
        JR      NZ,L4955
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,H
L4955:  LD      BC,0014Ch
        LD      C,B
        LD      BC,0014Ch
        LD      C,H
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,H
        LD      BC,03833h
        NOP     
        INC     HL
        LD      D,B
        ADD     HL,DE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      D,A
        JR      C,L499B
        INC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L499B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,L
        LD      BC,0387Bh
        DJNZ    L49DB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,L
        LD      BC,038ABh
        DJNZ    L49FB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L49DB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,L
        LD      BC,038BFh
        DJNZ    L4A07
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L49FB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,L
L4A07:  LD      BC,038DBh
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        CPL     
        ADD     HL,SP
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,A
        LD      BC,03967h
        NOP     
        LD      B,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,B
        LD      BC,039ABh
        JR      NZ,L4AA0
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
        LD      BC,00158h
        LD      E,B
        LD      BC,00158h
        LD      E,B
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
        LD      BC,039E0h
        JR      NZ,L4A95
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,D
L4A95:  LD      BC,00158h
        LD      D,(HL)
        LD      BC,00158h
        LD      E,B
        LD      BC,0FFFFh
L4AA0:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,D
        LD      BC,039EAh
        JR      NZ,L4AB1
        NOP     
        DEC     B
        RST     38h
        RST     38h
        RST     38h
L4AB1:  RST     38h
        RST     38h
        RST     38h
        LD      D,E
        LD      BC,00158h
        LD      E,B
        LD      BC,00158h
        LD      E,B
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,E
        LD      BC,039F0h
        JR      NZ,L4AD5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,H
L4AD5:  LD      BC,00158h
        LD      D,(HL)
        LD      BC,00158h
        LD      E,B
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,H
        LD      BC,039FAh
        JR      NZ,L4AF1
        NOP     
        DJNZ    L4AEE
        RST     38h
        RST     38h
L4AF1:  RST     38h
        RST     38h
        RST     38h
        LD      D,L
        LD      BC,00158h
        LD      E,B
        LD      BC,00158h
        LD      E,B
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,L
        LD      BC,03A00h
        JR      NZ,L4B15
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,A
L4B15:  LD      BC,00158h
        LD      D,(HL)
        LD      BC,00158h
        LD      E,B
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,A
        LD      BC,03B6Fh
        NOP     
        HALT    
        LD      D,B
        JR      NZ,L4B2E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        JP      PO,L103A
        LD      C,A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,C
        LD      BC,03B32h
        DJNZ    L4BA7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,C
        LD      BC,03BE6h
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
L4BA7:  NOP     
        LD      A,(0003Ch)
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,E
        LD      BC,03C72h
        NOP     
        LD      D,C
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,H
        LD      BC,03CC4h
        JR      NZ,L4C01
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,L
        LD      BC,00167h
        LD      H,A
        LD      BC,00167h
        LD      H,A
        LD      BC,0FFFFh
        RST     38h
L4C01:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,A
        LD      BC,03CDAh
        NOP     
        DEC     L
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,(HL)
        LD      BC,03D08h
        JR      NZ,L4C39
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,A
        LD      BC,00168h
        LD      L,B
L4C39:  LD      BC,00168h
        LD      L,B
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,B
        LD      BC,03D16h
        NOP     
        JR      NC,L4C9D
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,B
        LD      BC,03D47h
        JR      NZ,L4C75
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,C
L4C75:  LD      BC,00161h
        LD      H,(HL)
        LD      BC,00169h
        LD      L,C
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,C
        LD      BC,03D51h
        NOP     
        INC     HL
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L4C9D:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,D
        LD      BC,03D75h
        JR      NZ,L4CBC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,E
        LD      BC,0016Ah
        LD      L,D
        LD      BC,0016Ah
L4CBC:  LD      L,D
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,D
        LD      BC,03D86h
        NOP     
        ADD     A,D
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,H
        LD      BC,03E09h
        JR      NZ,L4CFC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,L
        LD      BC,0016Bh
        LD      L,E
        LD      BC,0016Bh
L4CFC:  LD      L,E
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,E
        LD      BC,03E1Ah
        NOP     
        LD      H,C
        LD      D,B
        RLA     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      A,H
        LD      A,010h
        INC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,H
        LD      BC,03EA0h
        DJNZ    L4D63
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L4D63:  RST     38h
        RST     38h
        RST     38h
        LD      L,H
        LD      BC,03EB8h
        DJNZ    L4D9B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,H
        LD      BC,03EE8h
        DJNZ    L4DBF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L4D9B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,H
        LD      BC,03F1Ch
        DJNZ    L4DC3
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L4DBF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
L4DC3:  RST     38h
        RST     38h
        RST     38h
        LD      L,H
        LD      BC,03F34h
        DJNZ    L4E13
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,H
        LD      BC,03F7Ch
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        RET     NC

        CCF     
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L4E13:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,(HL)
        LD      BC,04008h
        NOP     
        LD      E,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,A
        LD      BC,04064h
        JR      NZ,L4E55
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
L4E55:  LD      BC,0017Dh
        LD      (HL),B
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      BC,0406Eh
        NOP     
        ADD     HL,DE
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),C
        LD      BC,04088h
        JR      NZ,L4E97
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      BC,00172h
        LD      A,L
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      BC,04094h
        NOP     
        JR      NZ,L4EFD
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),E
        LD      BC,040B5h
        JR      NZ,L4EDA
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      BC,0017Dh
        LD      (HL),H
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      BC,040C4h
        NOP     
        LD      HL,00750h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L4EFD:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),L
        LD      BC,040E6h
        JR      NZ,L4F19
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      BC,00176h
        LD      A,L
L4F19:  LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      BC,040F4h
        NOP     
        LD      E,050h
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
        LD      BC,04113h
        JR      NZ,L4F56
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,H
        LD      BC,00178h
        LD      A,H
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,H
        LD      BC,0411Eh
        NOP     
        DEC     D
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,C
        LD      BC,04134h
        JR      NZ,L4F9B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      BC,0017Ah
        LD      A,L
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      BC,04144h
        NOP     
        LD      (HL),E
        LD      D,B
        JR      NZ,L4FAE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        CP      B
        LD      B,C
        DJNZ    L4FFB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(HL)
        LD      BC,041E8h
        DJNZ    L502B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L4FFB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(HL)
        LD      BC,04228h
        DJNZ    L502F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(HL)
        LD      BC,0424Ch
        NOP     
L502B:  LD      D,E
        NOP     
        NOP     
        RST     38h
L502F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        AND     B
        LD      B,D
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,B
        LD      BC,042D8h
        NOP     
        DEC     HL
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,C
        LD      BC,04304h
        JR      NZ,L5095
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
L5095:  LD      BC,L019B
        ADD     A,D
        LD      BC,0019Ah
        SBC     A,E
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,0430Eh
        JR      NZ,L50FF
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,L019B
        SBC     A,E
        LD      BC,0019Ah
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,E
        LD      BC,04362h
        JR      NZ,L50D9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,00184h
        SBC     A,E
L50D9:  LD      BC,0019Ah
        SBC     A,E
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,04370h
        JR      NZ,L512D
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,L019B
        SBC     A,E
        LD      BC,0019Ah
        RST     38h
        RST     38h
        RST     38h
L50FF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,L
        LD      BC,043B2h
        JR      NZ,L5120
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,00186h
        SBC     A,E
        LD      BC,0019Ah
        SBC     A,E
        LD      BC,0FFFFh
L5120:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,043C7h
        JR      NZ,L5152
        LD      D,B
L512D:  EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,L019B
        SBC     A,E
        LD      BC,0019Ah
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,A
        LD      BC,043EEh
        JR      NZ,L5157
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5152:  RST     38h
        RST     38h
        SBC     A,D
        LD      BC,00188h
        SBC     A,E
        LD      BC,0019Ah
        SBC     A,E
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,043FAh
        NOP     
        INC     SP
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,C
        LD      BC,0442Eh
        JR      NZ,L51B9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,L019B
        SBC     A,E
        LD      BC,0019Ah
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,D
        LD      BC,0445Ch
        JR      NZ,L51B8
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,0018Bh
L51B8:  SBC     A,E
L51B9:  LD      BC,0019Ah
        SBC     A,E
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,L4469
        JR      NZ,L51F5
        LD      D,B
        DJNZ    L51CE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,L019B
        SBC     A,E
        LD      BC,0019Ah
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,H
        LD      BC,04493h
        JR      NZ,L51F8
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
L51F5:  LD      BC,0018Dh
L51F8:  SBC     A,E
        LD      BC,0019Ah
        SBC     A,E
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,044A0h
        NOP     
        RRCA    
        LD      D,B
        LD      DE,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,(HL)
        LD      BC,044B0h
        JR      NZ,L5257
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,L019B
        SBC     A,E
        LD      BC,0019Ah
        ADC     A,A
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,044DCh
        NOP     
        INC     DE
        LD      D,B
        LD      (DE),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5257:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     B
        LD      BC,044F0h
        JR      NZ,L5275
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     C
L5275:  LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,044FAh
        NOP     
        LD      DE,01350h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     D
        LD      BC,0450Ch
        JR      NZ,L52B9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,0019Ah
        SUB     E
L52B9:  LD      BC,00193h
        SBC     A,D
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,0451Ah
        NOP     
        DEC     BC
        LD      D,B
        INC     D
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     H
        LD      BC,04526h
        JR      NZ,L52F7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     L
        LD      BC,0019Ah
        SBC     A,D
        LD      BC,0019Ah
        SBC     A,D
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,04532h
        NOP     
        DEC     BC
        LD      D,B
        DEC     D
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SUB     (HL)
        LD      BC,0453Eh
        JR      NZ,L5336
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,0019Ah
        SUB     A
        LD      BC,00197h
        SBC     A,D
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,04549h
        NOP     
        DEC     BC
        LD      D,B
        LD      D,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,B
        LD      BC,04555h
        JR      NZ,L5375
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,C
L5375:  LD      BC,0019Ah
        SBC     A,D
        LD      BC,0019Ah
        SBC     A,D
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,D
        LD      BC,0455Fh
        NOP     
        LD      A,H
        LD      D,B
        DAA     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        CALL    C,L1045
        RLA     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,H
        LD      BC,045F4h
        DJNZ    L541D
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,H
        LD      BC,0469Ah
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,L
        LD      BC,046D2h
        NOP     
        INC     H
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L541D:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,(HL)
        LD      BC,046F7h
        JR      NZ,L5436
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5436:  SBC     A,A
        LD      BC,001A1h
        AND     C
        LD      BC,001A0h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     C
        LD      BC,04702h
        JR      NZ,L547B
        NOP     
        LD      (DE),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      (01047h),A
        LD      L,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L547B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     D
        LD      BC,0479Eh
        DJNZ    L54AF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     D
        LD      BC,047C2h
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
L54AF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      D,048h
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     H
        LD      BC,0484Eh
        NOP     
        DEC     (HL)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     L
        LD      BC,04884h
        JR      NZ,L5521
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      C
        LD      BC,001B1h
        OR      C
        LD      BC,001B1h
        AND     (HL)
        LD      BC,0FFFFh
        RST     38h
L5521:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      C
        LD      BC,0489Ah
        NOP     
        INC     DE
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     A
        LD      BC,048AEh
        JR      NZ,L5557
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        LD      BC,001B2h
        OR      D
        LD      BC,001B2h
        OR      D
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      D
        LD      BC,048BAh
        NOP     
        DEC     E
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     C
        LD      BC,048D8h
        JR      NZ,L559D
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      E
        LD      BC,001B3h
        OR      E
        LD      BC,001B3h
        XOR     D
L559D:  LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      E
        LD      BC,048EAh
        NOP     
        RLA     
        LD      D,B
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     E
        LD      BC,04902h
        JR      NZ,L55D7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     H
        LD      BC,001B2h
        OR      D
        LD      BC,001B2h
        OR      D
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      D
        LD      BC,0490Eh
        NOP     
        DEC     D
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     L
        LD      BC,04924h
        JR      NZ,L5620
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      E
        LD      BC,001AEh
        OR      E
        LD      BC,001B3h
        OR      E
        LD      BC,0FFFFh
L5620:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      E
        LD      BC,04939h
        NOP     
        LD      D,050h
        DJNZ    L562E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     A
        LD      BC,04950h
        JR      NZ,L5665
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      B
        LD      BC,001B4h
        OR      H
        LD      BC,001B4h
        OR      H
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5665:  RST     38h
        OR      H
        LD      BC,0496Ah
        NOP     
        LD      L,E
        LD      D,B
        LD      DE,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        SUB     049h
        DJNZ    L56AF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      L
        LD      BC,049FAh
        DJNZ    L56C3
        NOP     
        NOP     
        RST     38h
L56AF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L56C3:  RST     38h
        RST     38h
        RST     38h
        OR      L
        LD      BC,04A12h
        DJNZ    L56EF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      L
        LD      BC,04A36h
        DJNZ    L5733
        NOP     
        NOP     
        RST     38h
L56EF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L56FB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      L
        LD      BC,04A7Eh
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        JP      NC,L004A
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5733:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      A
        LD      BC,04B0Ah
        JR      NZ,L56FB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     00h
        ADD     A,C
        RST     00h
        ADD     A,C
        RST     38h
        RST     38h
        PUSH    BC
        ADD     A,C
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      B
        LD      BC,04BBAh
        JR      NZ,L5775
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5775:  RST     38h
        RST     00h
        ADD     A,C
        RST     00h
        ADD     A,C
        RST     38h
        RST     38h
        CP      (HL)
        ADD     A,C
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      BC,04BC4h
        JR      NZ,L57A4
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     00h
        ADD     A,C
        RST     00h
        ADD     A,C
        RST     38h
        RST     38h
        PUSH    BC
        ADD     A,C
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L57A4:  RST     38h
        RST     38h
        CP      D
        LD      BC,04BDDh
        JR      NZ,L57B5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L57B5:  RST     38h
        RST     00h
        ADD     A,C
        RST     00h
        ADD     A,C
        RST     38h
        RST     38h
        CP      (HL)
        ADD     A,C
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      E
        LD      BC,04BE7h
        JR      NZ,L57E6
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     00h
        ADD     A,C
        RST     00h
        ADD     A,C
        RST     38h
        RST     38h
        PUSH    BC
        ADD     A,C
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L57E6:  CP      H
        LD      BC,04C02h
        JR      NZ,L57F5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L57F5:  RST     38h
        RST     00h
        ADD     A,C
        RST     00h
        ADD     A,C
        RST     38h
        RST     38h
        CP      (HL)
        ADD     A,C
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      L
        LD      BC,04C0Ch
        JR      NZ,L5813
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5813:  RST     38h
        RST     38h
        RST     38h
        RST     00h
        ADD     A,C
        RST     00h
        ADD     A,C
        RST     38h
        RST     38h
        PUSH    BC
        ADD     A,C
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        PUSH    BC
        LD      BC,04C14h
        NOP     
        LD      B,A
        NOP     
        LD      (DE),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      A
        LD      BC,04C5Ch
        JR      NZ,L5857
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     NZ

        LD      BC,001C7h
        RST     00h
        LD      BC,001C7h
        ADD     A,001h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,001h
        LD      L,B
        LD      C,H
        NOP     
        SCF     
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        POP     BC
        LD      BC,04CA0h
        JR      NZ,L5895
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     00h
L5895:  LD      BC,001C7h
        RST     00h
        LD      BC,001C2h
        RST     00h
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     00h
        LD      BC,04CAAh
        NOP     
        DEC     L
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      LD801
        LD      C,H
        JR      NZ,L58E2
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     00h
        LD      BC,001C7h
        RST     00h
        LD      BC,001C7h
        CALL    NZ,$FF01
        RST     38h
        RST     38h
        RST     38h
L58E2:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     00h
        LD      BC,04CEFh
        NOP     
        JR      L58ED
L58ED:  JR      L58EE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5900:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        EX      AF,AF'
        LD      C,L
        DJNZ    L5941
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     Z

        LD      BC,04D3Eh
        DJNZ    L597F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5941:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     Z

        LD      BC,04D92h
        DJNZ    L596F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     Z

        LD      BC,04DB6h
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
L596F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L597F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      A,(BC)
        LD      C,(HL)
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      Z,L4201
        LD      C,(HL)
        NOP     
        LD      E,L
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RLC     C
        AND     B
        LD      C,(HL)
        JR      NZ,L59D5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      NC,LD301
        LD      BC,001D2h
        CALL    Z,LD201
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      NC,LAA01
        LD      C,(HL)
        NOP     
        INC     C
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    $B701
        LD      C,(HL)
        JR      NZ,L5A18
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5A18:  JP      NC,LD301
        LD      BC,001D2h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADC     A,001h
        CALL    NZ,L204E
        DEC     BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (001h),A
        OUT     (001h),A
        JP      NC,$FF01
        RST     38h
        RST     08h
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OUT     (001h),A
        RET     NC

        LD      C,(HL)
        NOP     
        INC     DE
        LD      D,B
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     NC

        LD      BC,04EE4h
        JR      NZ,L5A77
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    NC,LD401
L5A77:  LD      BC,001D1h
        CALL    NC,LD201
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      NC,$F001
        LD      C,(HL)
        NOP     
        RLA     
        LD      D,B
        ADD     HL,DE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        EX      AF,AF'
        LD      C,A
        DJNZ    L5AED
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        PUSH    DE
        LD      BC,04F4Ah
        DJNZ    L5AEF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        PUSH    DE
        LD      BC,04F6Eh
        DJNZ    L5B1B
        NOP     
L5AED:  NOP     
        RST     38h
L5AEF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        PUSH    DE
        LD      BC,04F9Eh
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5B1B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        JP      P,L004F
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     10h
        LD      BC,0502Ah
        NOP     
        CPL     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     C

        LD      BC,0505Ah
        JR      NZ,L5B7B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     PO

        LD      BC,001D9h
        POP     HL
        LD      BC,001E1h
        POP     HL
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        POP     HL
        LD      BC,0506Ah
        NOP     
        RLCA    
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      C,L7201
        LD      D,B
        JR      NZ,L5BB7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     PO

        LD      BC,001E1h
        RET     PO

        LD      BC,001E1h
        IN      A,(001h)
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        POP     HL
        LD      BC,0507Eh
        NOP     
        DEC     BC
        LD      D,B
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    C,$8A01
        LD      D,B
        JR      NZ,L5BF7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     PO

        LD      BC,001DDh
        RET     PO

        LD      BC,001E1h
        POP     HL
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        POP     HL
        LD      BC,05096h
        NOP     
        LD      D,C
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,001h
        RET     PE

        LD      D,B
        JR      NZ,L5C41
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     18h
        LD      BC,001E1h
        POP     HL
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
L5C41:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      PO,$FE01
        LD      D,B
        NOP     
        ADD     HL,HL
        LD      D,B
        JR      NZ,L5C4E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        JR      Z,L5CBB
        DJNZ    L5CB3
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      (SP),HL
        LD      BC,05170h
        DJNZ    L5CA9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      (SP),HL
        LD      BC,0518Eh
        DJNZ    L5CD4
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5CB3:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5CBB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EX      (SP),HL
        LD      BC,L51B8
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5CD4:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        INC     C
        LD      D,D
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        PUSH    HL
        LD      BC,05244h
        NOP     
        LD      D,A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     001h
        SBC     A,H
        LD      D,D
        JR      NZ,L5D3B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,001F8h
        RST     20h
        LD      BC,001F8h
        RET     M

        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,052ACh
        NOP     
        INC     DE
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     PE

        LD      BC,052C0h
        JR      NZ,L5D79
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,001E9h
        RET     M

L5D79:  LD      BC,001F8h
        RET     M

        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,052CEh
        NOP     
        DEC     E
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      PE,LEC01
        LD      D,D
        JR      NZ,L5DB3
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5DB3:  RST     38h
        RET     M

        LD      BC,001F8h
        RET     M

        LD      BC,001F8h
        EX      DE,HL
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,052F4h
        NOP     
        DEC     HL
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    PE,L2001
        LD      D,E
        JR      NZ,L5DF5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

L5DF5:  LD      BC,001EDh
        RET     M

        LD      BC,001F8h
        RET     M

        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,0532Ah
        NOP     
        JR      NZ,L5E5D
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     001h
        LD      C,E
        LD      D,E
        JR      NZ,L5E38
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,001F8h
L5E38:  RST     28h
        LD      BC,001F8h
        RET     M

        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,05358h
        NOP     
        RRCA    
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5E5D:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     P

        LD      BC,05368h
        JR      NZ,L5E76
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,001F1h
        RET     M

        LD      BC,001F8h
        RET     M

        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,05373h
        NOP     
        DEC     BC
        LD      D,B
        DJNZ    L5E8E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      P,L7F01
        LD      D,E
        JR      NZ,L5EB5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

L5EB5:  LD      BC,001F8h
        DI      
        LD      BC,001F8h
        RET     M

        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     M

        LD      BC,05389h
        NOP     
        LD      HL,(01150h)
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CALL    P,$B401
        LD      D,E
        JR      NZ,L5EFB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        PUSH    AF
        LD      BC,001F9h
        LD      SP,HL
        LD      BC,001F8h
        LD      SP,HL
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      SP,HL
        LD      BC,053C4h
        NOP     
        LD      H,L
        LD      D,B
        LD      (DE),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      001h
        LD      HL,(02054h)
        LD      A,(BC)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      M,$FA01
        LD      BC,001FAh
        JP      M,$F701
        LD      BC,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JP      M,L3501
        LD      D,H
        NOP     
        LD      E,050h
        INC     HL
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      D,H
        LD      D,H
        DJNZ    L5F9B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EI      
        LD      BC,05484h
        DJNZ    L5FAB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5F9B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EI      
        LD      BC,04F6Eh
        DJNZ    L5FDB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        EI      
        LD      BC,054A4h
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L5FDB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        RET     M

        LD      D,H
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      BC,05530h
        NOP     
        LD      B,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      001h
        LD      (HL),H
        LD      D,L
        JR      NZ,L605F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      BC,055A8h
        JR      NZ,L6055
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
L6055:  LD      (BC),A
        INC     B
        LD      (BC),A
        LD      B,002h
        LD      B,002h
        LD      B,002h
        RST     38h
L605F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        LD      (BC),A
        OR      D
        LD      D,L
        JR      NZ,L6072
        NOP     
        DJNZ    L606E
        RST     38h
        RST     38h
        RST     38h
L6072:  RST     38h
        RST     38h
        LD      BC,00602h
        LD      (BC),A
        LD      B,002h
        LD      B,002h
        LD      B,002h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      BC,0B902h
        LD      D,L
        JR      NZ,L6095
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (BC),A
L6095:  LD      (BC),A
        INC     B
        LD      (BC),A
        LD      B,002h
        LD      B,002h
        LD      B,002h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (BC),A
        LD      (BC),A
        JP      L2055
        DEC     B
        NOP     
        DEC     D
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     BC
        LD      (BC),A
        LD      B,002h
        LD      B,002h
        LD      B,002h
        LD      B,002h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     BC
        LD      (BC),A
        RET     

        LD      D,L
        JR      NZ,L60D5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     B
L60D5:  LD      (BC),A
        INC     B
        LD      (BC),A
        LD      B,002h
        LD      B,002h
        LD      B,002h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     B
        LD      (BC),A
        JR      C,L6141
        NOP     
        HALT    
        NOP     
        DEC     H
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        XOR     E
        LD      D,(HL)
        DJNZ    L615B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RLCA    
        LD      (BC),A
        EI      
        LD      D,(HL)
        DJNZ    L6167
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6141:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RLCA    
        LD      (BC),A
        XOR     A
        LD      D,A
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L615B:  RST     38h
L615C:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
L6167:  NOP     
        INC     BC
        LD      E,B
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,BC
        LD      (BC),A
        DEC     SP
        LD      E,B
        JR      NZ,L615C
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     H
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(BC)
        LD      (BC),A
        INC     C
        LD      E,C
        JR      NZ,L61B7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     H
        LD      (BC),A
        INC     H
L61B7:  LD      (BC),A
        DEC     BC
        LD      (BC),A
        INC     H
        LD      (BC),A
        INC     H
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     H
        LD      (BC),A
        JR      L6223
        JR      NZ,L61F0
        LD      D,B
        INC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     H
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     C
        LD      (BC),A
        DEC     A
        LD      E,C
        JR      NZ,L61F6
        NOP     
        NOP     
        RST     38h
        RST     38h
L61F0:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     H
        LD      (BC),A
L61F6:  DEC     C
        LD      (BC),A
        DEC     H
        LD      (BC),A
        DEC     H
        LD      (BC),A
        DEC     H
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     H
        LD      (BC),A
        LD      C,B
        LD      E,C
        JR      NZ,L6230
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,002h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6223:  RST     38h
        RST     38h
        RST     38h
        LD      C,002h
        LD      L,L
        LD      E,C
        JR      NZ,L6238
        NOP     
        NOP     
        RST     38h
        RST     38h
L6230:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,002h
        LD      H,002h
L6238:  RRCA    
        LD      (BC),A
        LD      H,002h
        LD      H,002h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,002h
        LD      A,D
        LD      E,C
        JR      NZ,L626D
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DAA     
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DJNZ    L626A
        SBC     A,H
        LD      E,C
L626A:  JR      NZ,L6277
        NOP     
L626D:  NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DAA     
        LD      (BC),A
        LD      DE,02702h
        LD      (BC),A
        DAA     
        LD      (BC),A
        DAA     
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DAA     
        LD      (BC),A
        XOR     B
        LD      E,C
        JR      NZ,L62FA
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L62A0
        RST     38h
        RST     38h
L62A0:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (DE),A
        LD      (BC),A
        RLA     
        LD      E,D
        JR      NZ,L62BB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L62B8
        JR      Z,L62BA
L62B8:  JR      Z,L62BC
L62BA:  JR      Z,L62BE
L62BC:  INC     DE
        LD      (BC),A
L62BE:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L62CA
        DAA     
        LD      E,D
L62CA:  JR      NZ,L62F7
        LD      D,B
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L62E0
        RST     38h
        RST     38h
L62E0:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     D
        LD      (BC),A
        LD      D,E
        LD      E,D
        JR      NZ,L62FB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L62F8
        JR      Z,L62FA
L62F8:  JR      Z,L62FC
L62FA:  JR      Z,L62FE
L62FC:  DEC     D
        LD      (BC),A
L62FE:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L630A
        LD      H,E
        LD      E,D
L630A:  JR      NZ,L6337
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L6320
        RST     38h
        RST     38h
L6320:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,002h
        ADC     A,A
        LD      E,D
        JR      NZ,L633B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L6338
        JR      Z,L633A
L6338:  JR      Z,L633C
L633A:  JR      Z,L633E
L633C:  RLA     
        LD      (BC),A
L633E:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L634A
        SBC     A,A
        LD      E,D
L634A:  JR      NZ,L637F
        LD      D,B
        DJNZ    L634E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L6360
        RST     38h
        RST     38h
L6360:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      L636A
        OUT     (05Ah),A
L636A:  JR      NZ,L637B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L6378
        JR      Z,L637A
L6378:  JR      Z,L637C
L637A:  JR      Z,L637E
L637C:  ADD     HL,DE
        LD      (BC),A
L637E:  RST     38h
L637F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      Z,L638A
        EX      (SP),HL
        LD      E,D
L638A:  JR      NZ,L63F3
        LD      D,B
        LD      DE,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(DE)
        LD      (BC),A
        LD      C,E
        LD      E,E
        JR      NZ,L63BF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        DEC     DE
        LD      (BC),A
        ADD     HL,HL
        LD      (BC),A
        ADD     HL,HL
        LD      (BC),A
        ADD     HL,HL
        LD      (BC),A
        RST     38h
L63BF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        LD      E,A
        LD      E,E
        JR      NZ,L63FD
        LD      D,B
        LD      (DE),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     E
        LD      (BC),A
        SUB     C
        LD      E,E
        JR      NZ,L63FF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L63F3:  RST     38h
        ADD     HL,HL
        LD      (BC),A
        ADD     HL,HL
        LD      (BC),A
        DEC     E
        LD      (BC),A
        ADD     HL,HL
        LD      (BC),A
        ADD     HL,HL
L63FD:  LD      (BC),A
        RST     38h
L63FF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        AND     L
        LD      E,E
        JR      NZ,L6438
        LD      D,B
        INC     DE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,002h
        JP      NC,L205B
        LD      (DE),A
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        RRA     
        LD      (BC),A
L6438:  ADD     HL,HL
        LD      (BC),A
        ADD     HL,HL
        LD      (BC),A
        ADD     HL,HL
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        PUSH    HL
        LD      E,E
        JR      NZ,L6476
        LD      D,B
        INC     D
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      NZ,L646A
        DJNZ    L64C6
L646A:  JR      NZ,L6482
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
L6476:  ADD     HL,HL
        LD      (BC),A
        LD      HL,02902h
        LD      (BC),A
        ADD     HL,HL
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6482:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     HL,HL
        LD      (BC),A
        DAA     
        LD      E,H
        JR      NZ,L64F4
        LD      D,B
        DEC     D
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      HL,(0FF02h)
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (09002h),HL
        LD      E,H
        JR      NZ,L64B9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      HL,(02302h)
        LD      (BC),A
        LD      HL,(02A02h)
        LD      (BC),A
        INC     HL
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L64C6:  LD      HL,(0A802h)
        LD      E,H
        NOP     
        LD      B,D
        LD      D,B
        LD      H,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        EX      DE,HL
        LD      E,H
        DJNZ    L6503
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L64F4:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6503:  RST     38h
        RST     38h
        RST     38h
        DEC     HL
        LD      (BC),A
        INC     BC
        LD      E,L
        DJNZ    L6523
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6523:  RST     38h
        RST     38h
        RST     38h
        DEC     HL
        LD      (BC),A
        DEC     DE
        LD      E,L
        DJNZ    L6543
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6543:  RST     38h
        RST     38h
        RST     38h
        DEC     HL
        LD      (BC),A
        INC     SP
        LD      E,L
        DJNZ    L6563
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6563:  RST     38h
        RST     38h
        RST     38h
        DEC     HL
        LD      (BC),A
        LD      C,E
        LD      E,L
        DJNZ    L65A7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     HL
        LD      (BC),A
        ADD     A,A
        LD      E,L
        DJNZ    L65CB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     HL
L65A7:  LD      (BC),A
        RST     00h
        LD      E,L
        DJNZ    L65FB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     HL
        LD      (BC),A
        RLA     
        LD      E,(HL)
        NOP     
L65CB:  LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      L,E
        LD      E,(HL)
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L65FB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        DEC     L
        LD      (BC),A
        AND     E
        LD      E,(HL)
        NOP     
        ADD     A,B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,002h
        INC     H
        LD      E,A
        JR      NZ,L6639
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CPL     
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        LD      B,L
L6639:  LD      (BC),A
        LD      B,L
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        LD      (0005Fh),A
        LD      B,D
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      NC,L666A
        LD      (HL),L
        LD      E,A
L666A:  JR      NZ,L6683
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        LD      SP,0FF02h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6683:  RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        ADC     A,L
        LD      E,A
        NOP     
        ADD     HL,DE
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (0A702h),A
        LD      E,A
        JR      NZ,L66B7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        LD      B,(HL)
L66B7:  LD      (BC),A
        LD      B,(HL)
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        INC     SP
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L66C3:  RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        OR      E
        LD      E,A
        NOP     
        RLA     
        LD      D,B
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     (HL)
        LD      (BC),A
        BIT     3,A
        JR      NZ,L66F3
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L66F3:  RST     38h
        LD      B,L
        LD      (BC),A
        DEC     (HL)
        LD      (BC),A
        LD      B,(HL)
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        LD      B,E
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,D
        LD      (BC),A
        OUT     (05Fh),A
        NOP     
        DAA     
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),002h
        EI      
        LD      E,A
        JR      NZ,L6737
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        LD      B,E
L6737:  LD      (BC),A
        SCF     
        LD      (BC),A
        LD      B,H
        LD      (BC),A
        SCF     
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,H
        LD      (BC),A
        RLCA    
        LD      H,B
        NOP     
        DEC     DE
        LD      D,B
        DJNZ    L674E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        JR      C,L676A
        INC     HL
        LD      H,B
L676A:  JR      NZ,L6777
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        LD      B,L
L6777:  LD      (BC),A
        LD      B,L
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        ADD     HL,SP
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,D
        LD      (BC),A
        CPL     
        LD      H,B
        JR      NZ,L67BC
        LD      D,B
        LD      DE,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,E
        LD      (BC),A
        LD      B,E
        LD      (BC),A
        RST     38h
        RST     38h
        LD      B,E
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(06002h)
        LD      H,B
        JR      NZ,L67BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        LD      B,E
        LD      (BC),A
        LD      B,E
        LD      (BC),A
        LD      B,L
        LD      (BC),A
L67BC:  DEC     SP
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,E
        LD      (BC),A
        LD      (HL),C
        LD      H,B
        NOP     
        LD      (01250h),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        INC     A
        LD      (BC),A
        AND     H
        LD      H,B
        JR      NZ,L67FA
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        LD      B,L
        LD      (BC),A
L67FA:  LD      B,L
        LD      (BC),A
        DEC     A
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        OR      E
        LD      H,B
        NOP     
        LD      E,A
        LD      D,B
        INC     DE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,002h
        INC     DE
        LD      H,C
        JR      NZ,L6836
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
L6836:  LD      B,L
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        LD      B,L
        LD      (BC),A
        CCF     
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,L
        LD      (BC),A
        LD      E,061h
        NOP     
        LD      A,(BC)
        LD      D,B
        INC     D
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,B
        LD      (BC),A
        ADD     HL,HL
        LD      H,C
        JR      NZ,L6877
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,E
        LD      (BC),A
        LD      B,H
L6877:  LD      (BC),A
        LD      B,H
        LD      (BC),A
        LD      B,E
        LD      (BC),A
        LD      B,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,E
        LD      (BC),A
        DEC     (HL)
        LD      H,C
        NOP     
        DEC     A
        LD      D,B
        DEC     H
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      (HL),E
        LD      H,C
        DJNZ    L68C3
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L68C3:  RST     38h
        RST     38h
        RST     38h
        LD      B,A
        LD      (BC),A
        AND     E
        LD      H,C
        DJNZ    L68FB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,A
        LD      (BC),A
        OUT     (061h),A
        DJNZ    L6955
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L68FB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,A
        LD      (BC),A
        DEC     A
        LD      H,D
        DJNZ    L6947
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,A
        LD      (BC),A
        LD      A,C
        LD      H,D
        DJNZ    L694F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,A
L6947:  LD      (BC),A
        SBC     A,L
        LD      H,D
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
L694F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6955:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        POP     AF
        LD      H,D
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,C
        LD      (BC),A
        ADD     HL,HL
        LD      H,E
        JR      NZ,L69D5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        LD      D,B
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,D
        LD      (BC),A
        LD      (HL),E
        LD      H,E
        JR      NZ,L69B5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
L69B5:  LD      (BC),A
        LD      D,B
        LD      (BC),A
        LD      C,E
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
        LD      (BC),A
        LD      A,L
        LD      H,E
        JR      NZ,L6A21
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
L69D5:  LD      (BC),A
        LD      D,C
        LD      (BC),A
        LD      D,B
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,H
        LD      (BC),A
        OUT     (063h),A
        JR      NZ,L69F7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
        LD      (BC),A
        LD      D,B
L69F7:  LD      (BC),A
        LD      C,L
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        RST     38h
        RST     38h
L6A00:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
        LD      (BC),A
        RST     18h
        LD      H,E
        JR      NZ,L6A47
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
        LD      (BC),A
        LD      D,B
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
L6A21:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,(HL)
        LD      (BC),A
        DEC     DE
        LD      H,H
        JR      NZ,L6A39
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      C,A
        LD      (BC),A
        LD      D,B
L6A39:  LD      (BC),A
        LD      D,C
        LD      (BC),A
        LD      D,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,C
L6A47:  LD      (BC),A
        ADD     HL,HL
        LD      H,H
        NOP     
        ADD     HL,SP
        LD      D,B
        JR      L6A4E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      H,E
        LD      H,H
        DJNZ    L6A8F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,D
        LD      (BC),A
        ADD     A,A
        LD      H,H
        DJNZ    L6AD3
        NOP     
        NOP     
        RST     38h
L6A8F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,D
        LD      (BC),A
        RST     08h
        LD      H,H
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        INC     HL
        LD      H,L
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6AD3:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,H
        LD      (BC),A
        LD      E,E
        LD      H,L
        NOP     
        LD      (HL),E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,L
        LD      (BC),A
        RST     08h
        LD      H,L
        JR      NZ,L6B17
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6B17:  RST     38h
        RST     38h
        RST     38h
        LD      L,D
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      D,(HL)
        LD      (BC),A
        IN      A,(065h)
        JR      NZ,L6B38
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6B38:  RST     38h
        RST     38h
        LD      D,A
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,C
        LD      (BC),A
        RET     PE

        LD      H,L
        NOP     
        RLA     
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,B
        LD      (BC),A
        NOP     
        LD      H,(HL)
        JR      NZ,L6B75
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6B75:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,D
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,C
        LD      (BC),A
        LD      A,(BC)
        LD      H,(HL)
        JR      NZ,L6B95
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6B95:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,D
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,C
        LD      (BC),A
        INC     D
        LD      H,(HL)
        NOP     
        DEC     DE
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,E
        LD      (BC),A
        JR      NC,L6C30
        JR      NZ,L6BD4
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6BD4:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,D
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,H
        LD      (BC),A
        ADD     HL,SP
        LD      H,(HL)
        JR      NZ,L6BF7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6BF7:  RST     38h
        RST     38h
        RST     38h
        LD      E,L
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,C
        LD      (BC),A
        LD      B,L
        LD      H,(HL)
        NOP     
        ADD     HL,DE
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,(HL)
        LD      (BC),A
        LD      E,A
        LD      H,(HL)
        JR      NZ,L6C35
        NOP     
        NOP     
        RST     38h
        RST     38h
L6C30:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6C35:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,D
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      E,A
        LD      (BC),A
        LD      L,C
        LD      H,(HL)
        JR      NZ,L6C58
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6C58:  RST     38h
        RST     38h
        LD      H,B
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,C
        LD      (BC),A
        HALT    
        LD      H,(HL)
        NOP     
        JR      L6CBD
        EX      AF,AF'
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,C
        LD      (BC),A
        ADC     A,A
        LD      H,(HL)
        JR      NZ,L6C97
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6C97:  RST     38h
        RST     38h
        RST     38h
        LD      L,D
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,D
        LD      (BC),A
        SBC     A,E
        LD      H,(HL)
        JR      NZ,L6CB6
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6CB6:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,E
        LD      (BC),A
        LD      L,C
L6CBD:  LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,C
        LD      (BC),A
        AND     (HL)
        LD      H,(HL)
        NOP     
        ADD     HL,DE
        LD      D,B
        ADD     HL,BC
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,H
        LD      (BC),A
        RET     NZ

        LD      H,(HL)
        JR      NZ,L6CF5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6CF5:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,D
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,L
        LD      (BC),A
        JP      Z,L2066
        LD      A,(BC)
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,(HL)
        LD      (BC),A
        LD      L,C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,C
        LD      (BC),A
        PUSH    DE
        LD      H,(HL)
        NOP     
        ADD     HL,DE
        LD      D,B
        DJNZ    L6D2E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      H,A
        LD      (BC),A
        RST     28h
        LD      H,(HL)
        JR      NZ,L6D55
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6D55:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,B
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,E
        LD      (BC),A
        LD      SP,HL
        LD      H,(HL)
        NOP     
        LD      B,C
        LD      D,B
        LD      HL,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        DEC     SP
        LD      H,A
        DJNZ    L6DAF
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,H
        LD      (BC),A
        LD      E,A
        LD      H,A
        DJNZ    L6DC3
        NOP     
        NOP     
        RST     38h
L6DAF:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6DC3:  RST     38h
        RST     38h
        RST     38h
        LD      L,H
        LD      (BC),A
        DEC     DE
        LD      D,A
        DJNZ    L6DE7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,H
L6DE7:  LD      (BC),A
        LD      (HL),A
        LD      H,A
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        BIT     4,A
        NOP     
        LD      (HL),000h
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,(HL)
        LD      (BC),A
        LD      (BC),A
        LD      L,B
        JR      NZ,L6E63
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
        LD      (BC),A
        LD      (HL),A
        LD      (BC),A
        LD      (HL),A
        LD      (BC),A
        LD      (HL),A
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      L,A
        LD      (BC),A
        LD      A,(02068h)
        DEC     C
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
        LD      (BC),A
        LD      (HL),A
        LD      (BC),A
        LD      (HL),A
        LD      (BC),A
        LD      (HL),B
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6E63:  RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
        LD      (BC),A
        LD      C,B
        LD      L,B
        JR      NZ,L6E8D
        LD      D,B
        DEC     B
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
        LD      (BC),A
        LD      (HL),A
        LD      (BC),A
        LD      (HL),A
        LD      (BC),A
        HALT    
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),C
        LD      (BC),A
        LD      L,D
        LD      L,B
        JR      NZ,L6E97
        NOP     
L6E8D:  NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
L6E97:  LD      (BC),A
        LD      (HL),A
        LD      (BC),A
        LD      (HL),A
        LD      (BC),A
        LD      (HL),D
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
        LD      (BC),A
        HALT    
        LD      L,B
        NOP     
        DEC     A
        LD      D,B
        LD      B,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),E
        LD      (BC),A
        OR      H
        LD      L,B
        JR      NZ,L6F04
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
        LD      (BC),A
        LD      A,B
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),H
        LD      (BC),A
        IN      L,(C)
        JR      NZ,L6EF8
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      (HL),A
        LD      (BC),A
L6EF8:  LD      (HL),L
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L6F04:  RST     38h
        RST     38h
        LD      A,B
        LD      (BC),A
        JP      M,L0068
        RLA     
        NOP     
        DEC     D
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      (DE),A
        LD      L,C
        DJNZ    L6F4F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,C
        LD      (BC),A
        LD      (HL),069h
        DJNZ    L6F6F
        NOP     
        NOP     
        RST     38h
L6F4F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,C
        LD      (BC),A
        LD      E,D
        LD      L,C
        DJNZ    L6F8F
        NOP     
        NOP     
        RST     38h
L6F6F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,C
        LD      (BC),A
        LD      A,(HL)
        LD      L,C
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
L6F8F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        CP      A
        INC     B
        NOP     
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,E
        LD      (BC),A
        ADC     A,E
        DEC     B
        NOP     
        LD      A,L
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,H
        LD      (BC),A
        ADD     HL,BC
        LD      B,020h
        DEC     BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,L
        LD      (BC),A
        ADD     A,H
        LD      (BC),A
        ADD     A,H
        LD      (BC),A
        ADD     A,H
        LD      (BC),A
        ADD     A,H
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,H
        LD      (BC),A
        DEC     D
        LD      B,020h
        LD      DE,00750h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,H
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,H
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(HL)
        LD      (BC),A
        DAA     
        LD      B,020h
        DEC     BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,H
        LD      (BC),A
        ADD     A,H
        LD      (BC),A
        ADD     A,H
        LD      (BC),A
        ADD     A,H
        LD      (BC),A
        LD      A,A
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,H
        LD      (BC),A
        INC     SP
        LD      B,000h
        POP     BC
        LD      D,B
        RLCA    
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,B
        LD      (BC),A
        PUSH    AF
        LD      B,020h
        ADD     HL,BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,L
        LD      (BC),A
        ADD     A,C
        LD      (BC),A
        ADD     A,L
        LD      (BC),A
        ADD     A,L
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,L
        LD      (BC),A
        RST     38h
        LD      B,000h
        DEC     L
        NOP     
        DJNZ    L708E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,D
        LD      (BC),A
        DEC     L
        RLCA    
        JR      NZ,L70B4
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L70B4:  ADD     A,(HL)
        LD      (BC),A
        ADD     A,E
        LD      (BC),A
        ADD     A,(HL)
        LD      (BC),A
        ADD     A,(HL)
        LD      (BC),A
        ADD     A,(HL)
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,(HL)
        LD      (BC),A
        LD      (HL),007h
        NOP     
        INC     SP
        NOP     
        DJNZ    L70CE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        LD      L,C
        RLCA    
        DJNZ    L710F
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,A
        LD      (BC),A
        ADC     A,L
        RLCA    
        DJNZ    L713B
        NOP     
        NOP     
        RST     38h
L710F:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,A
        LD      (BC),A
        CP      L
        RLCA    
        DJNZ    L717B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L713B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        ADD     A,A
        LD      (BC),A
        DEC     C
        EX      AF,AF'
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L717B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L7201:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      A,(00070h)
        SCF     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        SBC     A,A
        LD      (BC),A
        LD      (HL),D
        LD      (HL),B
        JR      NZ,L74B3
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     B
        LD      (BC),A
        JP      C,L2070
        DEC     BC
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        AND     C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        AND     070h
L748A:  JR      NZ,L748A
        LD      D,B
        DEC     D
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     D
        LD      (BC),A
        PUSH    HL
        LD      (HL),C
        JR      NZ,L74C0
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L74B3:  RST     38h
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        AND     E
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
L74C0:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        JP      M,L2071
        CP      L
        LD      D,B
        LD      D,0FFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     H
        LD      (BC),A
        CP      B
        LD      (HL),D
        JR      NZ,L74F6
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L74F6:  CP      C
        LD      (BC),A
        AND     L
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        JP      L0072
        LD      D,B
        RLA     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     (HL)
        LD      (BC),A
        AND     C
        LD      (HL),E
        NOP     
        RST     00h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        AND     A
        LD      (BC),A
        LD      L,C
        LD      (HL),H
        JR      NZ,L75BA
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      H
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     B
        LD      (BC),A
        RET     C

        LD      (HL),H
        JR      NZ,L757D
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      H
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        XOR     C
        LD      (BC),A
        CP      C
L757D:  LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        JP      PE,L2074
        AND     E
        LD      D,B
        JR      L758E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      L
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      D
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     D
        LD      (BC),A
        ADC     A,(HL)
        LD      (HL),L
        JR      NZ,L75B7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      L
        LD      (BC),A
        CP      C
L75B7:  LD      (BC),A
        CP      C
        LD      (BC),A
L75BA:  XOR     E
        LD      (BC),A
        CP      D
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      D
        LD      (BC),A
        SBC     A,D
        LD      (HL),L
        JR      NZ,L7641
        LD      D,B
        ADD     HL,DE
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     H
        LD      (BC),A
        DJNZ    L7660
        JR      NZ,L75F9
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     L
        LD      (BC),A
        CP      C
L75F9:  LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        LD      E,076h
        JR      NZ,L764B
        LD      D,B
        JR      NZ,L760E
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      (HL)
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        XOR     (HL)
        LD      (BC),A
        LD      E,(HL)
        HALT    
        JR      NZ,L7641
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      (HL)
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        XOR     A
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
L7641:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      C
        LD      (BC),A
        LD      (HL),H
        HALT    
        JR      NZ,L7664
        LD      D,B
        LD      HL,0FFFFh
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      (HL)
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
L7660:  RST     38h
        RST     38h
        RST     38h
        RST     38h
L7664:  RST     38h
        RST     38h
        OR      B
        LD      (BC),A
        ADC     A,L
        HALT    
        JR      NZ,L7676
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      (HL)
        LD      (BC),A
L7676:  CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        OR      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      E
        LD      (BC),A
        SBC     A,B
        HALT    
        JR      NZ,L76B2
        LD      D,B
        LD      (0FFFFh),HL
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      E
        LD      (BC),A
        CP      E
        LD      (BC),A
        CP      E
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      D
        LD      (BC),A
        CP      A
        HALT    
        JR      NZ,L76B5
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L76B2:  RST     38h
        RST     38h
        OR      E
L76B5:  LD      (BC),A
        CP      E
        LD      (BC),A
        CP      E
        LD      (BC),A
        CP      C
        LD      (BC),A
        CP      C
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      E
        LD      (BC),A
        RET     

        HALT    
        JR      NZ,L7726
        LD      D,B
        INC     HL
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      H
        LD      (BC),A
        CP      H
        LD      (BC),A
        CP      H
        LD      (BC),A
        CP      H
        LD      (BC),A
        CP      H
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      H
        LD      (BC),A
        INC     H
        LD      (HL),A
        JR      NZ,L7715
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      H
        LD      (BC),A
        CP      H
        LD      (BC),A
        OR      L
        LD      (BC),A
        CP      H
        LD      (BC),A
        CP      H
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      H
        LD      (BC),A
        LD      C,(HL)
        LD      (HL),A
        JR      NZ,L771B
        LD      D,B
        INC     H
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      (HL)
L7715:  LD      (BC),A
        CP      (HL)
        LD      (BC),A
        CP      (HL)
        LD      (BC),A
        CP      (HL)
L771B:  LD      (BC),A
        CP      (HL)
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L7726:  OR      (HL)
        LD      (BC),A
        LD      E,(HL)
        LD      (HL),A
        JR      NZ,L7735
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        OR      A
L7735:  LD      (BC),A
        CP      (HL)
        LD      (BC),A
        CP      (HL)
        LD      (BC),A
        CP      (HL)
        LD      (BC),A
        CP      (HL)
        LD      (BC),A
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      (HL)
        LD      (BC),A
        LD      L,B
        LD      (HL),A
        NOP     
        RET     PE

        LD      D,B
        DEC     (HL)
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      B
        LD      (BC),A
        LD      D,C
        LD      A,B
        NOP     
        JP      PO,L0000
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RET     NZ

        LD      (BC),A
        LD      A,079h
        DJNZ    L77BB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      A
        LD      (BC),A
        LD      L,(HL)
        LD      A,C
        DJNZ    L77E7
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L77BB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      A
        LD      (BC),A
        XOR     D
        LD      A,C
        DJNZ    L77FB
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      A
L77E7:  LD      (BC),A
        JP      C,L1079
        CPL     
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L77FB:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      A
        LD      (BC),A
        LD      A,(BC)
        LD      A,D
        DJNZ    L7847
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      A
        LD      (BC),A
        LD      B,(HL)
        LD      A,D
        DJNZ    L785B
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        CP      A
L7847:  LD      (BC),A
        HALT    
        LD      A,D
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L785B:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        INC     (HL)
        LD      A,C
        LD      B,B
        XOR     H
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L7F01:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
L7FC3:  RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        LD      B,(HL)
        LD      B,(HL)
        NOP     
        LD      D,E
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        RST     38h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        RST     38h
        RST     38h
        JP      $FFC3
        RST     38h
        JP      $C3C3
        JP      L0000
        NOP     
        NOP     
        NOP     
        NOP     
        RST     38h
        RST     38h
        JP      L7FC3
        LD      A,A
        JP      $FFC3
        RST     38h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        RST     38h
        RST     38h
        INC     BC
        INC     BC
        INC     BC
        INC     BC
        INC     BC
        INC     BC
        RST     38h
        RST     38h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        RST     38h
        RST     38h
        CALL    Z,LCCCC
        CALL    Z,LCCCC
        RST     38h
        RST     38h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        RST     38h
        RST     38h
        INC     BC
        INC     BC
        LD      A,A
        LD      A,A
        INC     BC
        INC     BC
        RST     38h
        RST     38h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        RST     38h
        RST     38h
        INC     BC
        INC     BC
        LD      A,A
        LD      A,A
        INC     BC
        INC     BC
        INC     BC
        INC     BC
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        RST     38h
        RST     38h
        INC     BC
        INC     BC
        DI      
        DI      
        JP      $FFC3
        RST     38h
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        JP      $C3C3
        JP      0FFFFh
        JP      $C3C3
        JP      L0000
        NOP     
        NOP     
        NOP     
        NOP     
        INC     A
        INC     A
        JR      $80AD
        JR      $80AF
        JR      $80B1
        INC     A
        INC     A
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        NOP     
        RET     NZ

